<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/*	
 *	@author 	: Creativeitem
 *	date		: 14 september, 2017
 *	Ekattor School Management System Pro
 *	http://codecanyon.net/user/Creativeitem
 *	http://support.creativeitem.com
 */

class Accountant extends CI_Controller
{
    
    
	function __construct()
	{
		parent::__construct();
		$this->load->database();
        $this->load->library('session');
        $this->load->model(array('Ajaxdataload_model' => 'ajaxload'));
		
       /*cache control*/
		$this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
		$this->output->set_header('Pragma: no-cache');
		
    }
    
    /***default functin, redirects to login page if no accountant logged in yet***/
    public function index()
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect(site_url('login'), 'refresh');
        if ($this->session->userdata('accountant_login') == 1)
            redirect(site_url('accountant/dashboard'), 'refresh');
    }
    
    /***ADMIN DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'dashboard';
        $page_data['page_title'] = get_phrase('accountant_dashboard');
        $this->load->view('backend/index', $page_data);
    }
    function get_class_students($class_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        foreach ($students as $row) {
           $this->db->where(['student_id' =>$row['student_id'],'alumni' =>0]);
            $checkStudent = $this->db->get('student')->result_array();
            if(count($checkStudent)>0){
            $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<option value="' . $row['student_id'] . '">' . $name . '</option>';
        } }
    }
    function get_class_students_mass($class_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        echo '<div class="form-group">
                <label class="col-sm-3 control-label">' . get_phrase('students') . '</label>
                <div class="col-sm-9">';
        foreach ($students as $row) {
          $this->db->where(['student_id' =>$row['student_id'],'alumni' =>0]);
           $checkStudent = $this->db->get('student')->result_array();
            if(count($checkStudent)>0){
             $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<div class="checkbox">
                    <label><input type="checkbox" class="checks" name="student_id[]" value="' . $row['student_id'] . '">' . $name .'</label>
                </div>';
        } }
        echo '<br><button type="button" class="btn btn-default" onClick="select()">'.get_phrase('select_all').'</button>';
        echo '<button style="margin-left: 5px;" type="button" class="btn btn-default" onClick="unselect()"> '.get_phrase('select_none').' </button>';
        echo '</div></div>';
    }
    /******MANAGE BILLING / INVOICES WITH STATUS*****/
    function invoice($param1 = '', $param2 = '', $param3 = '')
    {  
        if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($param1 == 'create') {
            $data['student_id']         = $this->input->post('student_id');
            $data['term_id']        =   $this->input->post('term');
            $data['invoice_no']        =   $this->input->post('invoice_no');
            $data['description']        = $this->input->post('description');
            $data['amount']             = $this->input->post('amount');
            $data['amount_paid']        = $this->input->post('amount_paid');
            $data['due']                = $data['amount'] - $data['amount_paid'];
            $data['status']             = $this->input->post('status');
            $data['creation_timestamp'] = strtotime($this->input->post('date'));
            $data['due_date'] = strtotime($this->input->post('due_date'));
            $data['fine_id'] = strtotime($this->input->post('fine_id'));
            $data['year']               = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

            $this->db->insert('invoice', $data);
            $invoice_id = $this->db->insert_id();
            //krish

            foreach($_POST['title'] as $item){ 
            $cat_id = $this->db->get_where('income_category',['name' => $item])->row()->income_category_id;
            $data1['invoice_id']        =   $invoice_id;
            $data1['income_category_id']  =  $cat_id;
            $item = preg_replace('/\s+/', '', $item);
            $data1['amount']            =  $this->input->post($item);
            $data1['due'] = $this->input->post($item) - $this->input->post('pay_'.$item);
            $this->db->insert('invoice_student_master' , $data1);
            }
            
            $data2['invoice_id']        =   $invoice_id;
            $data2['student_id']        =   $this->input->post('student_id');
            
            $data2['description']       =   $this->input->post('description');
            $data2['payment_type']      =  'income';
            $data2['method']            =   $this->input->post('method');
            $data2['bank']            =   $this->input->post('bank');
            $data2['payment_ref']       =   $this->input->post('payment_ref');
            $data2['payment_remarks']       =   $this->input->post('payment_remark');
            $data2['cheque_dd']       =   $this->input->post('cheque');
            $data2['payment_date']       =   $this->input->post('date_payment');
            $data2['amount']            =   $this->input->post('amount_paid');
            $data2['timestamp']         =   strtotime($this->input->post('date'));
            $data2['year']              =  $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

            $this->db->insert('payment' , $data2);
            $this->db->select('phone');
            //krish
            $data=$this->db->get_where('student',['student_id' =>$this->input->post('student_id')])->result();
            if(isset($data)){
                //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $this->input->post('class_id')))->row()->name;
                 $student = $this->db->get_where('student' , array('student_id' => $this->input->post('student_id')))->row()->name;
                 $datas['description']    =   'New invoice has been created for student '.$student.' ,class '.$class.'.';
                 $datas['status']    =   2;
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
                //sms
                $message = 'Thank you for your Payment. Your Invoice has been created. Total Amount is '.$this->input->post('amount').'. Paid amount is '.$this->input->post('amount_paid').'. Date : '.date('d-m-Y');
                 
                $this->sms_model->send_sms($message , $data[0]->phone);
            }
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/student_payment', 'refresh');
        }

        else if ($param1 == 'create_mass_invoice') {
            foreach ($this->input->post('student_id') as $id) {
                $this->db->order_by('invoice_id','DESC');
                $this->db->limit(1);
                $invoiceno = $this->db->get('invoice')->row()->invoice_no;
                if($invoiceno == 0 || $invoiceno == '')
                    $invoiceno =  1;
                else
                    $invoiceno +=1;
                $data['student_id']         = $id;
                $data['invoice_no']         = $invoiceno;
                $data['term_id']        =   $this->input->post('term');
                $data['description']        = $this->input->post('description');
                $data['amount']             = $this->input->post('amount');
                $data['amount_paid']        = $this->input->post('amount_paid');
                $data['due']                = $data['amount'] - $data['amount_paid'];
                $data['status']             = $this->input->post('status');
                $data['creation_timestamp'] = strtotime($this->input->post('date'));
                $data['fine_id'] = strtotime($this->input->post('fine_id'));
                $data['due_date'] = strtotime($this->input->post('due_date'));
                $data['year']               = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                
                $this->db->insert('invoice', $data);
                $invoice_id = $this->db->insert_id();
                foreach($_POST['titles'] as $item){ 
                    $cat_id = $this->db->get_where('income_category',['name' => $item])->row()->income_category_id;
                    $data1['invoice_id']        =   $invoice_id;
                    $data1['income_category_id']  =  $cat_id;
                    $item = preg_replace('/\s+/', '', $item);
                    $data1['amount']            =  $this->input->post($item);
                    $data1['due'] = $this->input->post($item) - $this->input->post('paid_'.$item);
                    $this->db->insert('invoice_student_master' , $data1);
                }
                $data2['invoice_id']        =   $invoice_id;
                $data2['student_id']        =   $id;
                $data2['description']       =   $this->input->post('description');
                $data2['payment_type']      =  'income';
                $data2['method']            =   $this->input->post('method');
                $data2['amount']            =   $this->input->post('amount_paid');
                $datas['status']    =   2;
                $data2['timestamp']         =   strtotime($this->input->post('date'));
                $data2['year']               =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

                $this->db->insert('payment' , $data2);
            }
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $this->input->post('class_id')))->row()->name;
                 $datas['description']    =   'Mass invoice has been created for class '.$class.'.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   2;
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/student_payment', 'refresh');
        }

        else if ($param1 == 'do_update') {
            $data['student_id']         = $this->input->post('student_id');
            $data['title']              = $this->input->post('title');
            $data['description']        = $this->input->post('description');
            $data['amount']             = $this->input->post('amount');
            $data['status']             = $this->input->post('status');
            $data['creation_timestamp'] = strtotime($this->input->post('date'));
            
            $this->db->where('invoice_id', $param2);
            $this->db->update('invoice', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?accountant/invoice', 'refresh');
        } 
        else if ($param1 == 'take_payment') {
            $invo = $this->db->get_where('invoice',['invoice_id' =>$param2])->row()->due;
            if($invo >= $this->input->post('amount')){
            $data['invoice_id']   =   $this->input->post('invoice_id');
            $data['student_id']   =   $this->input->post('student_id');
            $data['title']        =   $this->input->post('title');
            $data['description']  =   $this->input->post('description');
            $data['payment_type'] =   'income';
            $data['method']       =   $this->input->post('method');
            $data['bank']            =   $this->input->post('bank');
            $data['payment_ref']       =   $this->input->post('payment_ref');
            $data['payment_remarks']       =   $this->input->post('payment_remark');
            $data['cheque_dd']       =   $this->input->post('cheque');
            $data['payment_date']       =   $this->input->post('date_payment');
            $data['amount']       =   $this->input->post('amount');
            
            $data['timestamp']    =   strtotime($this->input->post('timestamp'));
            $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('payment' , $data);

            $status['status']   =   $this->input->post('status');
            $this->db->where('invoice_id' , $param2);
            $this->db->update('invoice' , array('status' => $status['status']));
            //krish
            $class_id = $this->db->get_where('enroll' , array('student_id' => $this->input->post('student_id')))->row()->class_id;
            $section_id = $this->db->get_where('enroll' , array('student_id' => $this->input->post('student_id')))->row()->section_id;
            foreach($_POST['category'] as $key => $val){
        $amount = $this->db->get_where('invoice_student_master',['income_category_id'=> $key,'invoice_id'=>$param2])->result_array();
                if($amount[0]['amount'] > $val){
                    $pending = $amount[0]['amount']-$val;
                    $due = $amount[0]['due'] - $pending;
                    $this->db->where(['income_category_id'=> $key,'invoice_id'=>$param2]);
                    $this->db->set('due', $due, FALSE);
                    $this->db->update('invoice_student_master');
                    $this->db->where('invoice_id' , $param2);
               
                $this->db->set('amount', 'amount - ' . $pending, FALSE);
                $this->db->set('due', 'due - ' . $pending, FALSE);
                $this->db->update('invoice');

                }
                else{
                    $pending = $val - $amount[0]['amount'];
                    $due = $amount[0]['due'] + $pending;
                    $this->db->where(['income_category_id'=> $key,'invoice_id'=>$param2]);
                    $this->db->set('due', $due, FALSE);
                    $this->db->update('invoice_student_master');
                    $this->db->where('invoice_id' , $param2);
                    $this->db->set('amount', 'amount + ' . $pending, FALSE);
                    $this->db->set('due', 'due + ' . $pending, FALSE);
                    $this->db->update('invoice');
                }
                $this->db->where(['income_category_id'=> $key,'invoice_id'=>$param2]);
                $this->db->set('amount', $val, FALSE);
                $this->db->update('invoice_student_master');
                
            }
            if($this->input->post('amount') != 0){
            $invoicem = $this->db->get_where('invoice_student_master',['invoice_id' =>$param2])->result_array();
            foreach ($invoicem as $key => $value) {
                if($this->input->post('id_'.$value['income_category_id']) !=''){
                $this->db->where(['income_category_id'=> $value['income_category_id'],'invoice_id'=>$param2]);
                $this->db->set('due', 'due - ' . $this->input->post('id_'.$value['income_category_id']), FALSE);
                $this->db->update('invoice_student_master');
                }
            }
            if($this->input->post('discount') =='')
                $disc = 0;
            else
                $disc = $this->input->post('discount');
            $data2['amount_paid']   =   $this->input->post('amount');
            if($disc >0){
                $newdue = $data2['amount_paid'] + $disc;
            }
            else
                $newdue = $data2['amount_paid'];
            $data2['status']        =   $this->input->post('status');
            $this->db->where('invoice_id' , $param2);
            $this->db->set('amount_paid', 'amount_paid + ' . $data2['amount_paid'], FALSE);
            $this->db->set('due', 'due - ' . $newdue, FALSE);
            $this->db->set('discount', $disc, FALSE);
            $this->db->update('invoice');
            $data=$this->db->get_where('student',['student_id' =>$this->input->post('student_id')])->result();
            if(isset($data)){
                //sms
                $message = 'Thank you for your Payment. Your invoice has been updated. Paid amount is '.$this->input->post('amount').'. Date : '.date('d-m-Y',strtotime($this->input->post('timestamp')));

                $this->sms_model->send_sms($message , $data[0]->phone);
            }
            $this->session->set_flashdata('flash_message' , get_phrase('payment_successfull'));
            }
           redirect(base_url() . 'index.php?accountant/income/'.$class_id.'/'.$section_id, 'refresh');
            }
          else{
           $this->session->set_flashdata('flash_message' ,get_phrase('payment_failed'));
            redirect(base_url() . 'index.php?accountant/income/'.$class_id.'/'.$section_id, 'refresh');
          }
         }
        else if ($param1 == 'delete') {
            $studentid = $this->db->get_where('invoice' , array('invoice_id' => $param2))->row()->student_id;
            $student = $this->db->get_where('student' , array('student_id' => $studentid))->row()->name;
            $this->db->where('invoice_id', $param2);
            $this->db->delete('payment');
            $this->db->where('invoice_id', $param2);
            $this->db->delete('invoice_student_master');
            $this->db->where('invoice_id', $param2);
            $this->db->delete('invoice');
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'Invoice of '.$student.' has been deleted.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   2;
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?accountant/income', 'refresh');
        }
        else{
            $page_data['page_name']  = 'income';
             $page_data['page_title'] = get_phrase('student_payments');
             $this->db->order_by('creation_timestamp', 'desc');
            $page_data['invoices'] = $this->db->get('invoice')->result_array();
            $this->load->view('backend/index', $page_data); 
        }
       }
   function other_income($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['title']               =   $this->input->post('title');
            $data['other_income_category_id'] =   $this->input->post('other_income_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'income';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $data['bank']            =   $this->input->post('bank');
            $data['payment_ref']       =   $this->input->post('payment_ref');
            $data['payment_remarks']       =   $this->input->post('payment_remark');
            $data['cheque_dd']       =   $this->input->post('cheque');
            $data['payment_date']       =   $this->input->post('date_payment');
            $this->db->insert('other_income' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/other_income', 'refresh');
        }

        if ($param1 == 'edit') {
            $data['title']               =   $this->input->post('title');
            $data['other_income_category_id'] =   $this->input->post('other_income_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'income';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->where('other_income_id' , $param2);
            $this->db->update('other_income' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?accountant/other_income', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('other_income_id' , $param2);
            $this->db->delete('other_income');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?accountant/other_income', 'refresh');
        }

        $page_data['page_name']  = 'other_income';
        $page_data['page_title'] = get_phrase('other_income');
        $this->load->view('backend/index', $page_data); 
    }
    //Krish
    function other_income_category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']   =   $this->input->post('name');
            $this->db->insert('other_income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/other_income_category');
        }
        if ($param1 == 'edit') {
            $data['name']   =   $this->input->post('name');
            $this->db->where('other_income_category_id' , $param2);
            $this->db->update('other_income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?accountant/other_income_category');
        }
        if ($param1 == 'delete') {
            $this->db->where('other_income_category_id' , $param2);
            $this->db->delete('other_income_category');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?accountant/other_income_category');
        }

        $page_data['page_name']  = 'other_income_category';
        $page_data['page_title'] = get_phrase('other_income_category');
        $this->load->view('backend/index', $page_data);
    }
    /**********ACCOUNTING********************/
    function income($class_id = '' ,$section_id = '')
    {
       if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
if ($this->input->post('class_id')>0) {
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            if ($page_data['section_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?accountant/income/' . $page_data['class_id'] . '/' .$page_data['section_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('income', 'Choose class and exam');
                redirect(base_url() . 'index.php?accountant/invoice/', 'refresh');
            }
        }
     else{
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['page_name']  = 'income';
        $page_data['page_title'] = get_phrase('student_payments');
        $this->load->view('backend/index', $page_data); 
      }
    }
function invoice_report($class_id = '' ,$section_id = '')
    {
       if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
         $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
         
         if ($this->input->post('start_timestamp') !='') {
           $this->db->where('timestamp <=',strtotime($this->input->post('end_timestamp')) );
           $this->db->where('timestamp >=', strtotime($this->input->post('start_timestamp')));         
         }
         $this->db->where('year' , $running_year);
         
         $this->db->order_by('timestamp' , 'DESC');
        $this->db->where('payment_type','income');
        $payments = $this->db->get('payment')->result_array();
        $page_data['invoices'] = $payments;
        $page_data['start_date'] = $this->input->post('start_timestamp');
        $page_data['end_date'] = $this->input->post('end_timestamp');
        $page_data['page_name']  = 'invoice_report';
        $page_data['page_title'] = get_phrase('report');
        $this->load->view('backend/index', $page_data); 
    }
    function income_search($class_id = '' ,$section_id = ''){
        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        $this->db->where('invoice.year' , $running_year);
        $this->db->join('enroll', 'invoice.student_id = enroll.student_id'); 
        $this->db->join('student', 'invoice.student_id = student.student_id'); 
        $this->db->like('student.name', $this->input->post('srch-term'));
    $this->db->order_by('invoice.creation_timestamp', 'desc');
        $page_data['invoices'] = $this->db->get('invoice')->result_array();

        $this->db->join('enroll', 'payment.student_id = enroll.student_id'); 
        $this->db->join('student', 'payment.student_id = student.student_id');
        $this->db->like('student.name', $this->input->post('srch-term')); 
    $this->db->where('payment_type' , 'income');
    $this->db->order_by('timestamp' , 'desc');
    $page_data['payments'] = $this->db->get('payment')->result_array();
        $page_data['page_name']  = 'income_search';
        $page_data['page_title'] = get_phrase('student_payments');
        $this->load->view('backend/index', $page_data); 
     }
    function incomesms($param = ''){
        if ($this->session->userdata('accountant_login') != 1)
             redirect('login', 'refresh');
        $message = 'Hi, This is from ';
        $edit_data = $this->db->get_where('invoice', array('invoice_id' => $param))->result_array();
        foreach ($edit_data as $row){
            $message .=  $this->db->get_where('settings', array('type' => 'system_name'))->row()->description.'...';
             $message .=$this->db->get_where('student', array('student_id' => $row['student_id']))->row()->name.' payment status on '.$row['title'].' is as follows...';
              $message .= 'Total Amount to pay : INR.'.$row['amount'];
              $message .= '....Amount to paid : INR.'.$row['amount_paid'];
              $message .= '....Amount Due : INR.'.$row['due'];
              $phoneno = $this->db->get_where('student', array('student_id' => $row['student_id']))->row()->phone; 
              $this->sms_model->send_sms($message,$phoneno);
        }
        

    }

    function get_invoices() {
        if ($this->session->userdata('accountant_login') != 1)
            redirect(site_url('login'), 'refresh');

        $columns = array(
            0 => 'invoice_id',
            1 => 'student',
            2 => 'title',
            3 => 'total',
            4 => 'paid',
            5 => 'status',
            6 => 'date',
            7 => 'options',
            8 => 'invoice_id'
        );

        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir   = $this->input->post('order')[0]['dir'];

        $totalData = $this->ajaxload->all_invoices_count();
        $totalFiltered = $totalData;

        if(empty($this->input->post('search')['value'])) {            
            $invoices = $this->ajaxload->all_invoices($limit,$start,$order,$dir);
        }
        else {
            $search = $this->input->post('search')['value']; 
            $invoices =  $this->ajaxload->invoice_search($limit,$start,$search,$order,$dir);
            $totalFiltered = $this->ajaxload->invoice_search_count($search);
        }

        $data = array();
        if(!empty($invoices)) {
            foreach ($invoices as $row) {

                if ($row->due == 0) {
                    $status = '<button class="btn btn-success btn-xs">'.get_phrase('paid').'</button>';
                    $payment_option = '';
                } else {
                    $status = '<button class="btn btn-danger btn-xs">'.get_phrase('unpaid').'</button>';
                    $payment_option = '<li><a href="#" onclick="invoice_pay_modal('.$row->invoice_id.')"><i class="entypo-bookmarks"></i>&nbsp;'.get_phrase('take_payment').'</a></li><li class="divider"></li>';
                }
                    
                
                $options = '<div class="btn-group"><button type="button" class="btn btn-default btn-sm dropdown-toggle" data-toggle="dropdown">
                                    Action <span class="caret"></span></button><ul class="dropdown-menu dropdown-default pull-right" role="menu">'.$payment_option.'<li><a href="#" onclick="invoice_view_modal('.$row->invoice_id.')"><i class="entypo-credit-card"></i>&nbsp;'.get_phrase('view_invoice').'</a></li><li class="divider"></li><li><a href="#" onclick="invoice_edit_modal('.$row->invoice_id.')"><i class="entypo-pencil"></i>&nbsp;'.get_phrase('edit').'</a></li><li class="divider"></li><li><a href="#" onclick="invoice_delete_confirm('.$row->invoice_id.')"><i class="entypo-trash"></i>&nbsp;'.get_phrase('delete').'</a></li></ul></div>';

                $nestedData['invoice_id'] = $row->invoice_id;
                $nestedData['student'] = $this->crud_model->get_type_name_by_id('student',$row->student_id);
                $nestedData['title'] = $row->title;
                $nestedData['total'] = $row->amount;
                $nestedData['paid'] = $row->amount_paid;
                $nestedData['status'] = $status;
                $nestedData['date'] = date('d M,Y', $row->creation_timestamp);
                $nestedData['options'] = $options;
                
                $data[] = $nestedData;
                
            }
        }
          
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),  
            "recordsTotal"    => intval($totalData),  
            "recordsFiltered" => intval($totalFiltered), 
            "data"            => $data   
        );
            
        echo json_encode($json_data);
    }

    function get_payments() {
        if ($this->session->userdata('accountant_login') != 1)
            redirect(site_url('login'), 'refresh');

        $columns = array(
            0 => 'payment_id',
            1 => 'title',
            2 => 'description',
            3 => 'method',
            4 => 'amount',
            5 => 'date',
            6 => 'options',
            7 => 'payment_id'
        );

        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir   = $this->input->post('order')[0]['dir'];

        $totalData = $this->ajaxload->all_payments_count();
        $totalFiltered = $totalData;

        if(empty($this->input->post('search')['value'])) {            
            $payments = $this->ajaxload->all_payments($limit,$start,$order,$dir);
        }
        else {
            $search = $this->input->post('search')['value']; 
            $payments =  $this->ajaxload->payment_search($limit,$start,$search,$order,$dir);
            $totalFiltered = $this->ajaxload->payment_search_count($search);
        }

        $data = array();
        if(!empty($payments)) {
            foreach ($payments as $row) {

                if ($row->method == 1)
                    $method = get_phrase('cash');
                else if ($row->method == 2)
                    $method = get_phrase('cheque');
                else if ($row->method == 3)
                    $method = get_phrase('card');
                else if ($row->method == 'Paypal')
                    $method = 'Paypal';
                else
                    $method = 'Stripe';
                    
                
                $options = '<a href="#" onclick="invoice_view_modal('.$row->invoice_id.')"><i class="entypo-credit-card"></i>&nbsp;'.get_phrase('view_invoice').'</a>';

                $nestedData['payment_id'] = $row->payment_id;
                $nestedData['title'] = $row->title;
                $nestedData['description'] = $row->description;
                $nestedData['method'] = $method;
                $nestedData['amount'] = $row->amount;
                $nestedData['date'] = date('d M,Y', $row->timestamp);
                $nestedData['options'] = $options;
                
                $data[] = $nestedData;
                
            }
        }
          
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),  
            "recordsTotal"    => intval($totalData),  
            "recordsFiltered" => intval($totalFiltered), 
            "data"            => $data   
        );
            
        echo json_encode($json_data);
    }

    function student_payment($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'student_payment';
        $page_data['page_title'] = get_phrase('create_student_payment');
        $this->load->view('backend/index', $page_data); 
    }

    function expense($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['title']               =   $this->input->post('title');
            $data['expense_category_id'] =   $this->input->post('expense_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'expense';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $data['bank']            =   $this->input->post('bank');
            $data['payment_ref']       =   $this->input->post('payment_ref');
            $data['payment_remarks']       =   $this->input->post('payment_remark');
            $data['cheque_dd']       =   $this->input->post('cheque');
            $data['payment_date']       =   $this->input->post('date_payment');
            $this->db->insert('payment' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/expense', 'refresh');
        }

        if ($param1 == 'edit') {
            $data['title']               =   $this->input->post('title');
            $data['expense_category_id'] =   $this->input->post('expense_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'expense';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->where('payment_id' , $param2);
            $this->db->update('payment' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?accountant/expense', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('payment_id' , $param2);
            $this->db->delete('payment');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?accountant/expense', 'refresh');
        }

        $page_data['page_name']  = 'expense';
        $page_data['page_title'] = get_phrase('expenses');
        $this->load->view('backend/index', $page_data); 
    }


    function income_category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']   =   $this->input->post('name');
            $this->db->insert('income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/income_category');
        }
        if ($param1 == 'edit') {
            $data['name']   =   $this->input->post('name');
            $this->db->where('income_category_id' , $param2);
            $this->db->update('income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?accountant/income_category');
        }
        if ($param1 == 'delete') {
            $this->db->where('income_category_id' , $param2);
            $this->db->delete('income_category');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?accountant/income_category');
        }

        $page_data['page_name']  = 'income_category';
        $page_data['page_title'] = get_phrase('income_category');
        $this->load->view('backend/index', $page_data);
    }
    function fines($param1 = '',$param2 = ''){
        if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
        if($this->input->post('fine') !=''){
            $data['fine'] = $this->input->post('amount');
            $data['type'] = $this->input->post('fine');
            $data['timestamp'] = strtotime(date('d-m-Y'));
            $this->db->insert('fine', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('fine_added_successfully'));
            redirect(base_url() . 'index.php?accountant/fines/' , 'refresh');
        }
        if($param1 == 'delete'){
            $this->db->where('fine_id', $param2);
            $this->db->delete('fine');
            $this->session->set_flashdata('flash_message' , get_phrase('fine_deleted_successfully'));
            redirect(base_url() . 'index.php?accountant/fines/' , 'refresh');
        }
        $this->db->order_by('fine_id','DESC');
        $page_data['fines'] = $this->db->get('fine')->result_array();
        $page_data['page_name']  = 'fines';
        $page_data['page_title'] = get_phrase('fines');
        $this->load->view('backend/index', $page_data);
    }

    function expense_category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']   =   $this->input->post('name');
            $this->db->insert('expense_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?accountant/expense_category');
        }
        if ($param1 == 'edit') {
            $data['name']   =   $this->input->post('name');
            $this->db->where('expense_category_id' , $param2);
            $this->db->update('expense_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?accountant/expense_category');
        }
        if ($param1 == 'delete') {
            $this->db->where('expense_category_id' , $param2);
            $this->db->delete('expense_category');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?accountant/expense_category');
        }

        $page_data['page_name']  = 'expense_category';
        $page_data['page_title'] = get_phrase('expense_category');
        $this->load->view('backend/index', $page_data);
    }
    
    // MANAGE OWN PROFILE AND CHANGE PASSWORD
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('accountant_login') != 1)
            redirect(site_url('login'), 'refresh');

        if ($param1 == 'update_profile_info') {
            $data['name']  = $this->input->post('name');
            $data['email'] = $this->input->post('email');
            $this->db->where('accountant_id', $this->session->userdata('accountant_id'));
            $this->db->update('accountant', $data);
            $this->session->set_flashdata('flash_message', get_phrase('account_updated'));
            redirect(base_url() . 'index.php?accountant/manage_profile/', 'refresh');
            redirect(site_url('accountant/manage_profile'), 'refresh');
        }

        if ($param1 == 'change_password') {
            $data['password']             = sha1($this->input->post('password'));
            $data['new_password']         = sha1($this->input->post('new_password'));
            $data['confirm_new_password'] = sha1($this->input->post('confirm_new_password'));
            
            $current_password = $this->db->get_where('accountant', array(
                'accountant_id' => $this->session->userdata('accountant_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('accountant_id', $this->session->userdata('accountant_id'));
                $this->db->update('accountant', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', get_phrase('password_updated'));
            } else {
                $this->session->set_flashdata('flash_message', get_phrase('password_mismatch'));
            }
            redirect(site_url('accountant/manage_profile'), 'refresh');
        }
        
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_title'] = get_phrase('manage_profile');
        $page_data['edit_data']  = $this->db->get_where('accountant', array(
            'accountant_id' => $this->session->userdata('accountant_id')
        ))->result_array();
        $this->load->view('backend/index', $page_data);
    }

    function get_expenses() {
        if ($this->session->userdata('accountant_login') != 1)
            redirect(site_url('login'), 'refresh');

        $columns = array(
            0 => 'payment_id',
            1 => 'title',
            2 => 'category',
            3 => 'method',
            4 => 'amount',
            5 => 'date',
            6 => 'options',
            7 => 'payment_id'
        );

        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir   = $this->input->post('order')[0]['dir'];

        $totalData = $this->ajaxload->all_expenses_count();
        $totalFiltered = $totalData;

        if(empty($this->input->post('search')['value'])) {            
            $expenses = $this->ajaxload->all_expenses($limit,$start,$order,$dir);
        }
        else {
            $search = $this->input->post('search')['value']; 
            $expenses =  $this->ajaxload->expense_search($limit,$start,$search,$order,$dir);
            $totalFiltered = $this->ajaxload->expense_search_count($search);
        }

        $data = array();
        if(!empty($expenses)) {
            foreach ($expenses as $row) {
                $category = $this->db->get_where('expense_category', array('expense_category_id' => $row->expense_category_id))->row()->name;
                if ($row->method == 1)
                    $method = get_phrase('cash');
                else if ($row->method == 2)
                    $method = get_phrase('cheque');
                else 
                    $method = get_phrase('card');
                $options = '<div class="btn-group"><button type="button" class="btn btn-default btn-sm dropdown-toggle" data-toggle="dropdown">
                                    Action <span class="caret"></span></button><ul class="dropdown-menu dropdown-default pull-right" role="menu"><li><a href="#" onclick="expense_edit_modal('.$row->payment_id.')"><i class="entypo-pencil"></i>&nbsp;'.get_phrase('edit').'</a></li><li class="divider"></li><li><a href="#" onclick="expense_delete_confirm('.$row->payment_id.')"><i class="entypo-trash"></i>&nbsp;'.get_phrase('delete').'</a></li></ul></div>';

                $nestedData['payment_id'] = $row->payment_id;
                $nestedData['title'] = $row->title;
                $nestedData['category'] = $category;
                $nestedData['method'] = $method;
                $nestedData['amount'] = $row->amount;
                $nestedData['date'] = date('d M,Y', $row->timestamp);
                $nestedData['options'] = $options;
                
                $data[] = $nestedData;
            }
        }
          
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),  
            "recordsTotal"    => intval($totalData),  
            "recordsFiltered" => intval($totalFiltered), 
            "data"            => $data   
        );
            
        echo json_encode($json_data);
    }
    function get_section($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/accountant/student_bulk_add_sections' , $page_data);
    }
    function get_sections_for_ssph($class_id) {
        $sections = $this->db->get_where('section', array('class_id' => $class_id))->result_array();
        $options = '';
        foreach ($sections as $row) {
            $options .= '<option value="'.$row['section_id'].'">'.$row['name'].'</option>';
        }
        echo '<select class="" name="section_id" id="section_id">'.$options.'</select>';
    }

    function get_students_for_ssph($class_id, $section_id) {
        $enrolls = $this->db->get_where('enroll', array('class_id' => $class_id, 'section_id' => $section_id))->result_array();
        $options = '';
        foreach ($enrolls as $row) {
            $name = $this->db->get_where('student', array('student_id' => $row['student_id']))->row()->name;
            $options .= '<option value="'.$row['student_id'].'">'.$name.'</option>';
        }
        echo '<select class="" name="student_id" id="student_id">'.$options.'</select>';
    }
    function transaction_report(){
       if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
            ))->row()->description;
            $newdata =  array();
        if($this->input->post('method')){
            $date  = $this->input->post('start_timestamp');
            $end_date  = $this->input->post('end_timestamp');
            $i=0;
            while (strtotime($date) <= strtotime($end_date)) {
                $date = date ("d-m-Y", strtotime($date));
                
                $amount = 0;
                $this->db->select_sum('amount');
                $this->db->where('year' , $running_year);
                $this->db->where(['method' => $this->input->post('method'),'payment_type' => 'income']);
                $this->db->where('timestamp =',strtotime($date) );
                $amount = $this->db->get('payment')->row()->amount;
                $this->db->select_sum('amount');
                $this->db->where('year' , $running_year);
                $this->db->where(['method' => $this->input->post('method'),'payment_type' => 'expense']);
                $this->db->where('timestamp =',strtotime($date) );
                $expense = $this->db->get('payment')->row()->amount;
                if(isset($amount) || isset($expense)){
                    $newdata[$i]['income'] = $amount;
                    $newdata[$i]['expense'] = $expense;
                    $newdata[$i]['profit'] = $amount - $expense;
                    $newdata[$i]['date'] = $date;
                    $i=$i+1;
                }
                $date = date ("d-m-Y", strtotime("+1 day", strtotime($date)));
	        }
	        $page_data['expense_details']  = $newdata;
	       $page_data['method']  = $this->input->post('method');
        }
        if($this->input->post('start_timestamp') !=''){
          $page_data['start_date']  = $this->input->post('start_timestamp');
          $page_data['end_date']  = $this->input->post('end_timestamp');
          $income_category = $this->db->get('income_category')->result_array();
          $income= array();
          $grandTotal = 0;
          
          foreach($income_category as $key=>$category){ 
            $income[$key]['name'] =  $category['name'];  
            $this->db->select_sum('invoice.amount_paid');
            $this->db->where('invoice.year' , $running_year);
            $this->db->join('invoice_student_master', 'invoice.invoice_id = invoice_student_master.invoice_id');
            $this->db->where('income_category_id', $category['income_category_id']);
            $this->db->where('invoice.creation_timestamp <=',strtotime($this->input->post('end_timestamp')) );
           $this->db->where('invoice.creation_timestamp >=', strtotime($this->input->post('start_timestamp')));
            $amount = $this->db->get('invoice')->row();
            $income[$key]['total'] =  $amount->amount_paid;   
            $grandTotal += $income[$key]['total'];
           }
           $page_data['income']  = $income;
           $page_data['grandTotal']  = $grandTotal;
           $expense_category = $this->db->get('expense_category')->result_array();
          $expense= array();
          $expenseTotal = 0;
          foreach($expense_category as $key=>$expen){ 
            $expense[$key]['name'] =  $expen['name'];  
            
            $this->db->select_sum('amount');
            $this->db->where('year' , $running_year);
            $this->db->where('expense_category_id', $expen['expense_category_id']);
            $this->db->where('timestamp <=',strtotime($this->input->post('end_timestamp')) );
            $this->db->where('timestamp >=', strtotime($this->input->post('start_timestamp')));
            $amount = $this->db->get('payment')->row();
            $expense[$key]['total'] =  $amount->amount;   
            $expenseTotal += $expense[$key]['total'];
           }
           $page_data['expense']  = $expense;
           $page_data['expenseTotal']  = $expenseTotal;
        }
        $page_data['page_name']  = 'transactional_report';
        $page_data['page_title'] = get_phrase('transactional_report');
        $this->load->view('backend/index', $page_data);
    }
    function categorized_report(){
        if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
       if($this->input->post('income_category_id') !=''){
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        $this->db->where('invoice.year' , $running_year);
        $this->db->join('enroll', 'invoice.student_id = enroll.student_id'); 
        $this->db->join('student', 'invoice.student_id = student.student_id'); 
        $this->db->join('invoice_student_master', 'invoice.invoice_id = invoice_student_master.invoice_id');
        $this->db->where('income_category_id' , $this->input->post('income_category_id'));
    $this->db->order_by('invoice.creation_timestamp', 'desc');
        $page_data['invoices'] = $this->db->get('invoice')->result_array();

        $this->db->join('enroll', 'payment.student_id = enroll.student_id'); 
        $this->db->join('student', 'payment.student_id = student.student_id'); 
    $this->db->where('payment_type' , 'income');
    $this->db->order_by('timestamp' , 'desc');
        $this->db->where('income_category_id' , $this->input->post('income_category_id'));
        $this->db->join('invoice_student_master', 'payment.invoice_id = invoice_student_master.invoice_id');
    $page_data['payments'] = $this->db->get('payment')->result_array();
        $page_data['income_id'] = $this->input->post('income_category_id');
        }
        $page_data['page_name']  = 'categorized_report';
        $page_data['page_title'] = get_phrase('category_based_report');
        $this->load->view('backend/index', $page_data);
    }
    function expense_report(){
        if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
       if($this->input->post('expense_category_id') !=''){
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        
        $this->db->where('year' , $running_year);
    $this->db->order_by('timestamp' , 'desc');
        $this->db->where('expense_category_id' , $this->input->post('expense_category_id'));
    $page_data['invoices'] = $this->db->get('payment')->result_array();
        $page_data['expense_id'] = $this->input->post('expense_category_id');
        }
        $page_data['page_name']  = 'expense_report';
        $page_data['page_title'] = get_phrase('expense_report');
        $this->load->view('backend/index', $page_data);
    }
    function other_income_category_report(){
       if ($this->session->userdata('accountant_login') != 1)
            redirect(base_url(), 'refresh');
       if($this->input->post('other_income_category_id') !=''){
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        
        $this->db->where('year' , $running_year);
    $this->db->order_by('timestamp' , 'desc');
        $this->db->where('other_income_category_id' , $this->input->post('other_income_category_id'));
    $page_data['invoices'] = $this->db->get('other_income')->result_array();
        $page_data['income_id'] = $this->input->post('other_income_category_id');
        }
        $page_data['page_name']  = 'other_income_category_report';
        $page_data['page_title'] = get_phrase('other_income_category_report');
        $this->load->view('backend/index', $page_data);
    }
    function get_payment_history_for_ssph($student_id) {
        $page_data['student_id'] = $student_id;
        $this->load->view('backend/accountant/student_specific_payment_history_table', $page_data);
    }
}
















