<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');



class Administrator extends CI_Controller
{
    
    
    function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('session');
        
       /*cache control*/
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
        
    }
    
    /***default functin, redirects to login page if no admin logged in yet***/
    public function index()
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($this->session->userdata('administrator_login') == 1)
            redirect(base_url() . 'index.php?administrator/dashboard', 'refresh');
    }
 
   public function update_student_details()
    {
        if($this->input->post('type') =='roll'){
            $data['roll']      = $this->input->post('roll');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('enroll', $data);
        }
        else if($this->input->post('type') =='name'){
            $data['name']      = $this->input->post('name');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('student', $data);
        }
        else if($this->input->post('type') =='address'){
            $data['address']      = $this->input->post('address');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('student', $data);
        }
      else if($this->input->post('type') =='phone'){
            $data['phone']      = $this->input->post('phone');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('student', $data);
        }
        
    }
    
    /***ADMIN DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'dashboard';
        $page_data['page_title'] = get_phrase('administrator_dashboard');
        $this->load->view('backend/index', $page_data);
    }
    
    
    /****MANAGE STUDENTS CLASSWISE*****/
    function student_add()
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
            
        $page_data['page_name']  = 'student_add';
        $page_data['page_title'] = get_phrase('add_student');
        $this->load->view('backend/index', $page_data);
    }
    
    function student_bulk_add($param1 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        if($param1 == 'add_bulk_student') {

            $names     = $this->input->post('name');
            $rolls     = $this->input->post('roll');
            $emails    = $this->input->post('email');
            $passwords = $this->input->post('password');
            $phones    = $this->input->post('phone');
            $addresses = $this->input->post('address');
            $genders   = $this->input->post('sex');

            $student_entries = sizeof($names);
            for($i = 0; $i < $student_entries; $i++) {
                $data['name']     =   $names[$i];
                $data['email']    =   $emails[$i];
                $data['password'] =   sha1($passwords[$i]);
                $data['phone']    =   $phones[$i];
                $data['address']  =   $addresses[$i];
                $data['sex']      =   $genders[$i];

                //validate here, if the row(name, email, password) is empty or not 
                if($data['name'] == '' || $data['email'] == '' || $data['password'] == '')
                    continue;

                $this->db->insert('student' , $data);
                $student_id = $this->db->insert_id();

                $data2['enroll_code']   =   substr(md5(rand(0, 1000000)), 0, 7);
                $data2['student_id']    =   $student_id;
                $data2['class_id']      =   $this->input->post('class_id');
                if($this->input->post('section_id') != '') {
                    $data2['section_id']    =   $this->input->post('section_id');
                }
                $data2['roll']          =   $rolls[$i];
                $data2['date_added']    =   strtotime(date("Y-m-d H:i:s"));
                $data2['year']          =   $this->db->get_where('settings' , array(
                                                'type' => 'running_year'
                                            ))->row()->description;

                $this->db->insert('enroll' , $data2);

            }
            $this->session->set_flashdata('flash_message' , get_phrase('students_added'));
            redirect(base_url() . 'index.php?administrator/student_bulk_add' , 'refresh');
        }           

        $page_data['page_name']  = 'student_bulk_add';
        $page_data['page_title'] = get_phrase('add_bulk_student');
        $this->load->view('backend/index', $page_data);
    }

    function get_sections($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/accountant/student_bulk_add_sections' , $page_data);
    }
    
   
    function pending_student($class_id = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect('login', 'refresh');
            
        $page_data['page_name']     = 'pending_student';
        $page_data['page_title']    = get_phrase('pending_student'). " - ".get_phrase('class')." : ".
                                            $this->crud_model->get_class_name($class_id);
        $page_data['class_id']  = $class_id;
        $this->load->view('backend/index', $page_data);
    }
     /***Krish***/
    
    function student_information($class_id = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect('login', 'refresh');
            
        $page_data['page_name']     = 'student_information';
        $page_data['page_title']    = get_phrase('student_information'). " - ".get_phrase('class')." : ".
                                            $this->crud_model->get_class_name($class_id);
        $page_data['class_id']  = $class_id;
        $this->load->view('backend/index', $page_data);
    }

    
    //Krish
    function student($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect('login', 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        if ($param1 == 'create') {
            $data['name']           = $this->input->post('name');
            $data['birthday']       = $this->input->post('birthday');
            $data['sex']            = $this->input->post('sex');
            $data['address']        = $this->input->post('address');
            $data['father_name']          = $this->input->post('father_name');
            $data['phone']          = $this->input->post('phone');
            $data['mother_name']          = $this->input->post('mother_name');
            $data['mother_phone']          = $this->input->post('mother_phone');
            $data['aadhar']          = $this->input->post('aadhar');
            $data['religion']          = $this->input->post('caste');
            $data['religion_category']          = $this->input->post('category');
            $data['nationality']          = $this->input->post('nation');
            $data['email']          = $this->input->post('email');
            if($this->input->post('username') == 1)
             $data['user_name']          = $this->input->post('admission'); 
            else
              $data['user_name']          = $this->input->post('phone');      
        $data['admission_no']          = $this->input->post('admission');
            $data['password']       = sha1($this->input->post('password'));
            $data['parent_id']      = $this->input->post('parent_id');
            $data['dormitory_id']  = $this->input->post('dormitory_id');
            $this->db->insert('student', $data);
            $student_id = $this->db->insert_id();
            foreach($this->input->post('transport_id') as $value){
               $data1['student_id'] = $student_id;
               $data1['transport_id'] = $value;
               $this->db->insert('transport_student', $data1);
            }
            
            $data2['student_id']     = $student_id;
            $data2['enroll_code']    = substr(md5(rand(0, 1000000)), 0, 7);
            $data2['class_id']       = $this->input->post('class_id');
            if ($this->input->post('section_id') != '') {
                $data2['section_id'] = $this->input->post('section_id');
            }
           
            $data2['roll']           = $this->input->post('roll');;
            $data2['date_added']     = strtotime(date("Y-m-d H:i:s"));
            $data2['year']           = $running_year;
            $this->db->insert('enroll', $data2);
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/student_image/' . $student_id . '.jpg');
            //sms
            $school=$this->db->get_where('settings',['settings_id',1])->result();
            $message = 'Welcome to '.$this->db->get_where('settings' , array('type'=>'system_name'))->row()->description.'. The admission for '.$data['name'].' has been initaited. For future reference, use Admission No : '.$data['admission_no'];
            $this->sms_model->send_sms($message , $this->input->post('phone'));

            $this->session->set_flashdata('flash_message' , get_phrase('data_added_&_SMS_sent_successfully'));


            $this->email_model->account_opening_email('student', $data['email']); //SEND EMAIL ACCOUNT OPENING EMAIL
            redirect(base_url() . 'index.php?administrator/student_add/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']           = $this->input->post('name');
            $data['birthday']       = $this->input->post('birthday');
            $data['sex']            = $this->input->post('sex');
            $data['address']        = $this->input->post('address');
            $data['phone']          = $this->input->post('phone');
            $data['admission_no']        = $this->input->post('admission_no');
            $data['email']          = $this->input->post('email');
            $data['parent_id']      = $this->input->post('parent_id');
            $data['dormitory_id']   = $this->input->post('dormitory_id');

            if(count($this->db->get_where('transport_student',['student_id' =>$param2])->result())>0){
               $this->db->where('student_id', $param2);
               $this->db->delete('transport_student');
            }
            foreach($this->input->post('transport_id') as $value){
               $details=$this->db->get_where('transport_student',['student_id' =>$param2,'transport_id' =>$value])->result();
               if(count($details) == 0){
               $data1['student_id'] = $param2;
               $data1['transport_id'] = $value;
               $this->db->insert('transport_student', $data1);
              }
            }
            
           
            $this->db->where('student_id', $param2);
            $this->db->update('student', $data);

            $data2['section_id']    =   $this->input->post('section_id');
            $data2['roll']          =   $this->input->post('roll');
            $running_year = $this->db->get_where('settings' , array('type'=>'running_year'))->row()->description;
            $this->db->where('student_id' , $param2);
            $this->db->where('year' , $running_year);
            $this->db->update('enroll' , array(
                'section_id' => $data2['section_id'] , 'roll' => $data2['roll']
            ));

            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/student_image/' . $param2 . '.jpg');
            $this->crud_model->clear_cache();
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/student_information/' . $param3, 'refresh');
        }
        if ($param2 == 'delete') {
            $this->db->where('student_id', $param3);
            $this->db->delete('student');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/student_information/' . $param1, 'refresh');
        }
    } 
    //krish
      function delete_student($student_id = '', $class_id = '') {
      $this->crud_model->delete_student($student_id);
      $this->session->set_flashdata('flash_message' , get_phrase('student_deleted'));
      redirect(base_url() . 'index.php?administrator/student_information/' . $class_id, 'refresh');
    }
    
    //krish 
    function student_profile_print($student_id = '' ) {
      $student_info =   $this->db->get_where('enroll' , array(
    'student_id' => $student_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
    ))->result();
       $system_name        =   $this->db->get_where('settings' , array('type'=>'system_name'))->row()->description;
            $code = $this->db->get_where('settings' , array('type'=>'system_code'))->row()->description;
            $affiliation = $this->db->get_where('settings' , array('type'=>'affiliation'))->row()->description;
            $line1        = $this->db->get_where('settings' , array('type'=>'address'))->row()->description;
            $line2        = $this->db->get_where('settings' , array('type'=>'phone'))->row()->description;
            $line3        = $this->db->get_where('settings' , array('type'=>'system_email'))->row()->description;
            $title='<center><h3 style="font-weight: 100;margin-left:300px">'.$system_name.'</h3></center>';
            $image = $student_id.'.jpg';
            $this->load->helper('pdf_helper');
            $html ='<html><body style="border:1px solid #000;"><div style="width:100%;padding:10px"><div style="width:100%; margin:0px auto;">
            <div style="float:left;width:150px"><br>
                    <img src="uploads/logo.png" style="width:60px;height:60px;padding-left:40px"><br>
                    <div style="margin-top:20px;margin-bottom:10px;">School Code : '.$code.'<br><br></div>
            </div>
            <div style="float:left;width:500px;height:auto"><center><h3>'.$system_name.'</h3>';
            if($affiliation !='')
              $html .=$affiliation.'.<br>';

             $html .=$line1.', Ph.'.$line2.'<br> '.$line3.'<br><br></center></div>
            </div><div style="width:100px">';
           if($affiliation !='')
            $html .='<br>';
           $html .='<br><br></div><br><br><br><div style="border-bottom:1px solid black;height:20px;margin-top:20px"></div>
            <div style="padding:20px"><center><h3><u>Student Information</u></h3></center><br>
          <div  style="width:10%;float:right;" >
             <img src="uploads/student_image/'.$student_id.'.jpg" style="width:80px;height:80px;"></div>
         <div  style="width:80%"><table width="100%"><tr><td width="40%"><b>Admission No.</b></td><td width="10%">:</td><td 
 width="40%">'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->admission_no.'</td></tr>
          <tr><td><b>Name</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->name.'</td></tr>
          <tr><td><b>Class</b></td><td>:</td><td>'.$this->crud_model->get_class_name($student_info[0]->class_id).'</td></tr>
          <tr><td><b>Section</b></td><td>:</td><td>'.$this->db->get_where('section' , array('section_id' => $student_info[0]->section_id))->row()->name.'</td></tr>
          
 <tr><td><b>Date of Birth</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->birthday.'</td></tr>
         <tr><td><b>Gender</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->sex.'</td></tr>
         <tr><td><b>Phone</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->phone.'</td></tr> 
        <tr><td><b>Email</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->email.'</td></tr>  
        <tr><td><b>Father</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->father_name.'</td></tr>  
        <tr><td><b>Mother</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->mother_name.'</td></tr>  
       <tr><td><b>Address</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->address.'</td></tr>';
$issuetc = $this->db->get_where('student' , array('student_id' => $student_id))->row()->issue_tc;
if($issuetc == 1)
$html .='
 <tr><td><b>TC issued on</b></td><td>:</td><td>'.$this->db->get_where('tc_details' , array('student_id' => $student_id))->row()->issue_date.'</td></tr>';
$html .='</table></div></div></body></html>';

           include(APPPATH."libraries/dompdf/autoload.inc.php");
            $dompdf = new Dompdf\Dompdf(); 
            $dompdf->loadHtml($html);// (Optional) Setup the paper size and orientation
            $dompdf->setPaper('A4', 'portrait');// Render the HTML as PDF
            $dompdf->render();// Get the generated PDF file contents
            $pdf = $dompdf->output();// Output the generated PDF to Browser
            $dompdf->stream();
    }
   
    //Krish
    function changeStudentStatus($param='',$param1='',$param2=''){
      if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
       $this->db->where('student_id', $param);
       $this->db->update('student', ['alumni'=>1]);
       $this->issued_tc($param1,$param2);
    }

    
    /****MANAGE TEACHERS*****/
    function teacher($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']        = $this->input->post('name');
            $data['birthday']    = $this->input->post('birthday');
            $data['sex']         = $this->input->post('sex');
            $data['address']     = $this->input->post('address');
            $data['phone']       = $this->input->post('phone');
            $data['email']       = $this->input->post('email');
            $data['password']    = sha1($this->input->post('password'));
            $this->db->insert('teacher', $data);
            $teacher_id = $this->db->insert_id();
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/teacher_image/' . $teacher_id . '.jpg');
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            $this->email_model->account_opening_email('teacher', $data['email']); //SEND EMAIL ACCOUNT OPENING EMAIL
            redirect(base_url() . 'index.php?administrator/teacher/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']        = $this->input->post('name');
            $data['birthday']    = $this->input->post('birthday');
            $data['sex']         = $this->input->post('sex');
            $data['address']     = $this->input->post('address');
            $data['phone']       = $this->input->post('phone');
            $data['email']       = $this->input->post('email');
            
            $this->db->where('teacher_id', $param2);
            $this->db->update('teacher', $data);
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/teacher_image/' . $param2 . '.jpg');
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/teacher/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_teacher_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('teacher', array(
                'teacher_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('teacher_id', $param2);
            $this->db->delete('teacher');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/teacher/', 'refresh');
        }
        $page_data['teachers']   = $this->db->get('teacher')->result_array();
        $page_data['page_name']  = 'teacher';
        $page_data['page_title'] = get_phrase('manage_teacher');
        $this->load->view('backend/index', $page_data);
    }
    
    /****MANAGE SUBJECTS*****/
    function subject($param1 = '', $param2 = '' , $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']       = $this->input->post('name');
            $data['class_id']   = $this->input->post('class_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['year']       = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('subject', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?administrator/subject/'.$data['class_id'], 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']       = $this->input->post('name');
            $data['class_id']   = $this->input->post('class_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['year']       = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            
            $this->db->where('subject_id', $param2);
            $this->db->update('subject', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/subject/'.$data['class_id'], 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('subject', array(
                'subject_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('subject_id', $param2);
            $this->db->delete('subject');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/subject/'.$param3, 'refresh');
        }
        $page_data['class_id']   = $param1;
        $page_data['subjects']   = $this->db->get_where('subject' , array('class_id' => $param1))->result_array();
        $page_data['page_name']  = 'subject';
        $page_data['page_title'] = get_phrase('manage_subject');
        $this->load->view('backend/index', $page_data);
    }
    
    /****MANAGE CLASSES*****/
    function classes($param1 = '', $param2 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']         = $this->input->post('name');
            $data['name_numeric'] = $this->input->post('name_numeric');
            $data['teacher_id']   = $this->input->post('teacher_id');
            $this->db->insert('class', $data);
            $class_id = $this->db->insert_id();
            //create a section by default
            $data2['class_id']  =   $class_id;
            $data2['name']      =   'A';
            $this->db->insert('section' , $data2);

            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?administrator/classes/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']         = $this->input->post('name');
            $data['name_numeric'] = $this->input->post('name_numeric');
            $data['teacher_id']   = $this->input->post('teacher_id');
            
            $this->db->where('class_id', $param2);
            $this->db->update('class', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/classes/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('class', array(
                'class_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('class_id', $param2);
            $this->db->delete('class');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/classes/', 'refresh');
        }
        $page_data['classes']    = $this->db->get('class')->result_array();
        $page_data['page_name']  = 'class';
        $page_data['page_title'] = get_phrase('manage_class');
        $this->load->view('backend/index', $page_data);
    }

    // ACADEMIC SYLLABUS
    function academic_syllabus($class_id = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        // detect the first class
        if ($class_id == '')
            $class_id           =   $this->db->get('class')->first_row()->class_id;

        $page_data['page_name']  = 'academic_syllabus';
        $page_data['page_title'] = get_phrase('academic_syllabus');
        $page_data['class_id']   = $class_id;
        $this->load->view('backend/index', $page_data);
    }

    function upload_academic_syllabus()
    {
        $data['academic_syllabus_code'] =   substr(md5(rand(0, 1000000)), 0, 7);
        $data['title']                  =   $this->input->post('title');
        $data['description']            =   $this->input->post('description');
        $data['class_id']               =   $this->input->post('class_id');
        $data['uploader_type']          =   $this->session->userdata('login_type');
        $data['uploader_id']            =   $this->session->userdata('login_user_id');
        $data['year']                   =   $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
        $data['timestamp']              =   strtotime(date("Y-m-d H:i:s"));
        //uploading file using codeigniter upload library
        $files = $_FILES['file_name'];
        $this->load->library('upload');
        $config['upload_path']   =  'uploads/syllabus/';
        $config['allowed_types'] =  '*';
        $_FILES['file_name']['name']     = $files['name'];
        $_FILES['file_name']['type']     = $files['type'];
        $_FILES['file_name']['tmp_name'] = $files['tmp_name'];
        $_FILES['file_name']['size']     = $files['size'];
        $this->upload->initialize($config);
        $this->upload->do_upload('file_name');

        $data['file_name'] = $_FILES['file_name']['name'];

        $this->db->insert('academic_syllabus', $data);
        $this->session->set_flashdata('flash_message' , get_phrase('syllabus_uploaded'));
        redirect(base_url() . 'index.php?administrator/academic_syllabus/' . $data['class_id'] , 'refresh');

    }

    function download_academic_syllabus($academic_syllabus_code)
    {
        $file_name = $this->db->get_where('academic_syllabus', array(
            'academic_syllabus_code' => $academic_syllabus_code
        ))->row()->file_name;
        $this->load->helper('download');
        $data = file_get_contents("uploads/syllabus/" . $file_name);
        $name = $file_name;

        force_download($name, $data);
    }

    /****MANAGE SECTIONS*****/
    function section($class_id = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        // detect the first class
        if ($class_id == '')
            $class_id           =   $this->db->get('class')->first_row()->class_id;

        $page_data['page_name']  = 'section';
        $page_data['page_title'] = get_phrase('manage_sections');
        $page_data['class_id']   = $class_id;
        $this->load->view('backend/index', $page_data);    
    }

    function sections($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']       =   $this->input->post('name');
            $data['nick_name']  =   $this->input->post('nick_name');
            $data['class_id']   =   $this->input->post('class_id');
            $data['teacher_id'] =   $this->input->post('teacher_id');
            $this->db->insert('section' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?administrator/section/' . $data['class_id'] , 'refresh');
        }

        if ($param1 == 'edit') {
            $data['name']       =   $this->input->post('name');
            $data['nick_name']  =   $this->input->post('nick_name');
            $data['class_id']   =   $this->input->post('class_id');
            $data['teacher_id'] =   $this->input->post('teacher_id');
            $this->db->where('section_id' , $param2);
            $this->db->update('section' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/section/' . $data['class_id'] , 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('section_id' , $param2);
            $this->db->delete('section');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/section' , 'refresh');
        }
    }

    function get_class_section($class_id)
    {
        $sections = $this->db->get_where('section' , array(
            'class_id' => $class_id
        ))->result_array();
        foreach ($sections as $row) {
            echo '<option value="' . $row['section_id'] . '">' . $row['name'] . '</option>';
        }
    }

    function get_class_subject($class_id)
    {
        $subjects = $this->db->get_where('subject' , array(
            'class_id' => $class_id
        ))->result_array();
        foreach ($subjects as $row) {
            echo '<option value="' . $row['subject_id'] . '">' . $row['name'] . '</option>';
        }
    }

    function get_class_students($class_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        foreach ($students as $row) {
           $this->db->where(['student_id' =>$row['student_id'],'alumni' =>0]);
            $checkStudent = $this->db->get('student')->result_array();
            if(count($checkStudent)>0){
            $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<option value="' . $row['student_id'] . '">' . $name . '</option>';
        } }
    }

    function get_class_students_mass($class_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        echo '<div class="form-group">
                <label class="col-sm-3 control-label">' . get_phrase('students') . '</label>
                <div class="col-sm-9">';
        foreach ($students as $row) {
          $this->db->where(['student_id' =>$row['student_id'],'alumni' =>0]);
           $checkStudent = $this->db->get('student')->result_array();
            if(count($checkStudent)>0){
             $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<div class="checkbox">
                    <label><input type="checkbox" class="checks" name="student_id[]" value="' . $row['student_id'] . '">' . $name .'</label>
                </div>';
        } }
        echo '<br><button type="button" class="btn btn-default" onClick="select()">'.get_phrase('select_all').'</button>';
        echo '<button style="margin-left: 5px;" type="button" class="btn btn-default" onClick="unselect()"> '.get_phrase('select_none').' </button>';
        echo '</div></div>';
    }



    /****MANAGE EXAMS**** Krish-updated*/
    function exam($param1 = '', $param2 = '' , $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']    = $this->input->post('name');
            $data['date']    = $this->input->post('date');
            $data['total_mark']    = $this->input->post('total_mark');
            $data['comment'] = $this->input->post('comment');
            $data['year']    = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            if($this->input->post('class_id') =='-1')
            {
                $classes = $this->db->get('class')->result();
                foreach ($classes as $key => $value) {
                    $data['class_id'] = $value->class_id;
                    $this->db->insert('exam', $data);
                }
            }
            else{

            $data['class_id'] = $this->input->post('class_id');
            $this->db->insert('exam', $data);
           }
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?administrator/exam/', 'refresh');
        }
        if ($param1 == 'edit' && $param2 == 'do_update') {
            $data['name']    = $this->input->post('name');
            $data['date']    = $this->input->post('date');
            $data['total_mark']    = $this->input->post('total_mark');
            $data['comment'] = $this->input->post('comment');
            $data['year']    = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            
            $this->db->where('exam_id', $param3);
            $this->db->update('exam', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/exam/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('exam', array(
                'exam_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('exam_id', $param2);
            $this->db->delete('exam');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/exam/', 'refresh');
        }
        $page_data['exams']      = $this->db->get('exam')->result_array();
        $page_data['page_name']  = 'exam';
        $page_data['page_title'] = get_phrase('manage_exam');
        $this->load->view('backend/index', $page_data);
    }
   /*** Default Numbers -Krish ***/
   function default_numbers($param1 = '',$param2 = ''){
     if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
    if ($param1 == 'create') {
        $data['name']   = $this->input->post('name');
            $data['designation']   = $this->input->post('designation');
            $data['number']     = $this->input->post('number');
            $this->db->insert('default_sms', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added successfully'));
            redirect(base_url() . 'index.php?administrator/default_numbers', 'refresh');
    }
    if ($param1 == 'delete') {
            $this->db->where('id', $param2);
            $this->db->delete('default_sms');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/default_numbers', 'refresh');
    }
    $page_data['dNumbers']      = $this->db->get('default_sms')->result_array();
    $page_data['page_name']  = 'default_numbers';
        $page_data['page_title'] = get_phrase('default_numbers');
        $this->load->view('backend/index', $page_data);
   }
  /****** SEND EXAM MARKS VIA SMS ********/
    function exam_marks_sms($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'send_sms') {

            $exam_id    =   $this->input->post('exam_id');
            $section_id = $this->input->post('section_id');
            $class_id   =   $this->input->post('class_id');
            $receiver   =   $this->input->post('receiver');
            if ($exam_id != '' && $class_id != '' && $receiver != '' && $section_id !='') {
            // get all the students of the selected class
            $students = $this->db->get_where('enroll' , array(
                'class_id' => $class_id,
                'section_id' => $section_id,
                    'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
            ))->result_array();
            // get the marks of the student for selected exam
            foreach ($students as $row) {
                if ($receiver == 'student')
                    $receiver_phone = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->phone;
                if ($receiver == 'parent') {
                    $parent_id =  $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->parent_id;
                    if($parent_id != '' || $parent_id != null) {
                        $receiver_phone = $this->db->get_where('parent' , array('parent_id' => $row['parent_id']))->row()->phone;
                        if($receiver_phone == null){
                          $this->session->set_flashdata('error_message' , get_phrase('parent_phone_number_is_not_found'));
                        }
                    }
                }
                $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                $this->db->where('exam_id' , $exam_id);
                $this->db->where('student_id' , $row['student_id']);
                $this->db->where('year', $running_year);
                $marks = $this->db->get('mark')->result_array();
                $student_name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
                $exam_name       = $this->db->get_where('exam' , array('exam_id' => $this->input->post('exam_id')))->row()->name;
                $message='';
                $message .="".$student_name." \n"; 
                $message .="Exam:".$exam_name." \n"; 
                foreach ($marks as $row2) {
                     
                    $subject       = $this->db->get_where('subject' , array('subject_id' => $row2['subject_id']))->row()->name;
                    $mark_obtained = $row2['mark_obtained'];
                    
                    $message      .= $subject . ' : ' . $mark_obtained ." \n";
                }
                // send sms
              $this->sms_model->send_sms( $message , $receiver_phone );
            }
       
            $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
          }
          else{
            $this->session->set_flashdata('error_message' , get_phrase('select_all_the_fields'));
          }
            redirect(base_url() . 'index.php?administrator/exam_marks_sms' , 'refresh');
        }

        $page_data['page_name']  = 'exam_marks_sms';
        $page_data['page_title'] = get_phrase('send_marks_by_sms');
        $this->load->view('backend/index', $page_data);
    }

    /****MANAGE EXAM MARKS*****/
    function marks2($exam_id = '', $class_id = '', $subject_id = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['subject_id'] = $this->input->post('subject_id');
            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0 && $page_data['subject_id'] > 0) {
                redirect(base_url() . 'index.php?administrator/marks2/' . $page_data['exam_id'] . '/' . $page_data['class_id'] . '/' . $page_data['subject_id'], 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose exam, class and subject');
                redirect(base_url() . 'index.php?administrator/marks2/', 'refresh');
            }
        }
        if ($this->input->post('operation') == 'update') {
            $students = $this->db->get_where('enroll' , array('class_id' => $class_id , 'year' => $running_year))->result_array();
            foreach($students as $row) {
                $data['mark_obtained'] = $this->input->post('mark_obtained_' . $row['student_id']);
                $data['comment']       = $this->input->post('comment_' . $row['student_id']);
                
                $this->db->where('mark_id', $this->input->post('mark_id_' . $row['student_id']));
                $this->db->update('mark', array('mark_obtained' => $data['mark_obtained'] , 'comment' => $data['comment']));
            }
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/marks2/' . $this->input->post('exam_id') . '/' . $this->input->post('class_id') . '/' . $this->input->post('subject_id'), 'refresh');
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['subject_id'] = $subject_id;
        
        $page_data['page_info'] = 'Exam marks';
        
        $page_data['page_name']  = 'marks2';
        $page_data['page_title'] = get_phrase('manage_exam_marks');
        $this->load->view('backend/index', $page_data);
    }

    function marks_manage()
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  =   'marks_manage';
        $page_data['page_title'] = get_phrase('manage_exam_marks');
        $this->load->view('backend/index', $page_data);
    }

    function marks_manage_view($exam_id = '' , $class_id = '' , $section_id = '' , $subject_id = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['exam_id']    =   $exam_id;
        $page_data['class_id']   =   $class_id;
        $page_data['subject_id'] =   $subject_id;
        $page_data['section_id'] =   $section_id;
        $page_data['page_name']  =   'marks_manage_view';
        $page_data['page_title'] = get_phrase('manage_exam_marks');
        $this->load->view('backend/index', $page_data);
    }

    function marks_selector()
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');

        $data['exam_id']    = $this->input->post('exam_id');
        $data['class_id']   = $this->input->post('class_id');
        $data['section_id'] = $this->input->post('section_id');
        $data['subject_id'] = $this->input->post('subject_id');
        $data['year']       = $this->db->get_where('settings' , array('type'=>'running_year'))->row()->description;
        $query = $this->db->get_where('mark' , array(
                    'exam_id' => $data['exam_id'],
                        'class_id' => $data['class_id'],
                            'section_id' => $data['section_id'],
                                'subject_id' => $data['subject_id'],
                                    'year' => $data['year']
                ));
        if($query->num_rows() < 1) {
            $students = $this->db->get_where('enroll' , array(
                'class_id' => $data['class_id'] , 'section_id' => $data['section_id'] , 'year' => $data['year']
            ))->result_array();
            foreach($students as $row) {
                $data['student_id'] = $row['student_id'];
                $this->db->insert('mark' , $data);
            }
        }
        redirect(base_url() . 'index.php?administrator/marks_manage_view/' . $data['exam_id'] . '/' . $data['class_id'] . '/' . $data['section_id'] . '/' . $data['subject_id'] , 'refresh');
        
    }
//Krish
    function marks_update($exam_id = '' , $class_id = '' , $section_id = '' , $subject_id = '')
    {
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $marks_of_students = $this->db->get_where('mark' , array(
            'exam_id' => $exam_id,
                'class_id' => $class_id,
                    'section_id' => $section_id,
                        'year' => $running_year,
                            'subject_id' => $subject_id
        ))->result_array();
        if($this->input->post('total_mark')!='')
             $total  = $this->input->post('total_mark');
        else
             $total = $this->db->get_where('exam',['exam_id' =>$exam_id])->row()->total_mark;
        foreach($marks_of_students as $row) {
            $obtained_marks = $this->input->post('marks_obtained_'.$row['mark_id']);
            $comment = $this->input->post('comment_'.$row['mark_id']);
            $percentage = ($obtained_marks/$total)*100;
            $this->db->where('mark_id' , $row['mark_id']);
            $this->db->update('mark' , array('mark_obtained' => $obtained_marks ,'mark_total'=>$total,'percentage' => $percentage , 'comment' => $comment));
        }
          //log
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
                 $section = $this->db->get_where('section' , array('section_id' => $section_id))->row()->name;
                 $exam = $this->db->get_where('exam',['exam_id' =>$exam_id])->row()->name;
                 $subject = $this->db->get_where('subject',['subject_id' =>$subject_id])->row()->name;
                 $data['description']    =   'Mark of '.$class.' '.$section.' added<br>Exam : '.$exam.'<br>Subject : '.$subject;
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $data['status']       =  1; 
                 $this->db->insert('log' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('marks_updated'));
        redirect(base_url().'index.php?administrator/marks_manage_view/'.$exam_id.'/'.$class_id.'/'.$section_id.'/'.$subject_id , 'refresh');
    }

    function marks_get_subject($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/accountant/marks_get_subject' , $page_data);
    }

    // TABULATION SHEET
    function tabulation_sheet($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');        
        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?administrator/tabulation_sheet/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?administrator/tabulation_sheet/', 'refresh');
            }
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'Exam marks';
        
        $page_data['page_name']  = 'tabulation_sheet';
        $page_data['page_title'] = get_phrase('exam_report');
        $this->load->view('backend/index', $page_data);
    
    }

    function tabulation_sheet_print_view($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['exam_id']  = $exam_id;
        $this->load->view('backend/accountant/tabulation_sheet_print_view' , $page_data);
    }
    function examwise_rank_sheet_print_view($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['exam_id']  = $exam_id;
        $this->load->view('backend/accountant/examwise_rank_sheet_print_view' , $page_data);
    }

    function subject_report($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?administrator/subject_report/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?administrator/subject_report/', 'refresh');
            }
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'subject_report';
        
        $page_data['page_name']  = 'subject_report';
        $page_data['page_title'] = get_phrase('subject_report');
        $this->load->view('backend/index', $page_data);    
    }

    function get_subject_details(){
        $this->db->select('student.name as name,student.student_id,subject.name as sname,mark_obtained,exam.name as exname,exam.exam_id,roll');
        $this->db->join('student','student.student_id = mark.student_id');
        $this->db->join('subject','subject.subject_id = mark.subject_id');
        $this->db->join('exam','exam.exam_id = mark.exam_id');
        $this->db->join('enroll','enroll.student_id = student.student_id');
        $this->db->order_by('roll');
        $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $this->input->post('subject_id'),'mark.class_id' => $this->input->post('class_id'),'mark.section_id' => $this->input->post('section_id')])->result();
        foreach($data as $key =>$val){
            $arr['exam'][$val->exam_id]=$val->exname;
            $arr['student'][$val->roll]['name']=$val->name;
            $arr['mark'][$val->roll][$val->exam_id]=$val->mark_obtained;
            $arr['roll'][$val->roll]=$val->roll;
        }
        //usort($arr['student'], 'sort_by_order');
        echo (json_encode($arr));
        //json_encode($this->db->get_where('section', $data));
    }

    function subject_report_print_view($class_id = '', $section_id = '', $subject_id = ''){
        if($class_id!='' && $section_id !='' && $subject_id !=''){
            $this->db->select('student.name as name,student.student_id,subject.name as sname,mark_obtained,exam.name as exname,exam.exam_id,roll');
            $this->db->join('student','student.student_id = mark.student_id');
            $this->db->join('subject','subject.subject_id = mark.subject_id');
            $this->db->join('exam','exam.exam_id = mark.exam_id');
            $this->db->join('enroll','enroll.student_id = student.student_id');
            $this->db->order_by('roll');
            $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $subject_id,'mark.class_id' => $class_id,'mark.section_id' => $section_id])->result();
            $page_data['subject_id']    = $subject_id;
            $page_data['class_id']   = $class_id;
            $page_data['section_id'] = $section_id;
            foreach($data as $key =>$val){
                $page_data['exam'][$val->exam_id]=$val->exname;
                $page_data['student'][$val->roll]['name']=$val->name;
                $page_data['mark'][$val->roll][$val->exam_id]=$val->mark_obtained;
                $page_data['roll'][$val->roll]=$val->roll;
            }
            $this->load->view('backend/accountant/subject_report_print_view' , $page_data);
        }
    }

    function exam_wise_ranking($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?administrator/exam_wise_ranking/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?administrator/exam_wise_ranking/', 'refresh');
            }
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'Exam Wise Ranking';
        
        $page_data['page_name']  = 'exam_wise_ranking';
        $page_data['page_title'] = get_phrase('exam_wise_ranking');
        $this->load->view('backend/index', $page_data);
    
    }

    function subject_ranking($class_id = '' ,$section_id = '', $subject_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($this->input->post('operation') == 'selection') {
            $page_data['subject_id']    = $this->input->post('subject_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            
            if ($page_data['subject_id'] > 0 && $page_data['class_id'] > 0 && $page_data['section_id'] > 0) {
                redirect(base_url() . 'index.php?administrator/subject_ranking/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['subject_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?administrator/subject_ranking/', 'refresh');
            }
        }
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['subject_id'] = $subject_id;
        
        $page_data['page_info'] = 'Subject Ranking';
        
        $page_data['page_name']  = 'subject_ranking';
        $page_data['page_title'] = get_phrase('subject_ranking');
        if($class_id!='' && $section_id !='' && $subject_id !=''){
            $this->db->select('student.name as name,student.student_id,subject.name as sname,mark_obtained,exam.name as exname,exam.exam_id,roll');
            $this->db->join('student','student.student_id = mark.student_id');
            $this->db->join('subject','subject.subject_id = mark.subject_id');
            $this->db->join('exam','exam.exam_id = mark.exam_id');
            $this->db->join('enroll','enroll.student_id = student.student_id');
            $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $subject_id,'mark.class_id' => $class_id,'mark.section_id' => $section_id])->result();
            $page_data['subject_id']    = $subject_id;
            $page_data['class_id']   = $class_id;
            $page_data['section_id'] = $section_id;
            foreach($data as $key =>$val){
                $page_data['exam'][$val->exam_id]=$val->exname;
                $page_data['student'][$val->roll]['name']=$val->name;
                $page_data['mark'][$val->roll][$val->exam_id]=$val->mark_obtained;
                $page_data['roll'][$val->roll]=$val->roll;
            }
        }
        $this->load->view('backend/index', $page_data);
    
    }
    function subject_ranking_print_view($class_id = '' ,$section_id = '', $subject_id = '') {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['subject_id']  = $subject_id;
        $this->load->view('backend/accountant/subject_ranking_print_view' , $page_data);

    }

    function get_sectiones(){
        $data['class_id']=$this->input->post('class_id');
        echo (json_encode($this->db->get_where('section', $data)->result()));
    }

    function get_subject_details_order(){
        $this->db->join('student','student.student_id = mark.student_id');
        $this->db->group_by('student.student_id');
        $this->db->order_by('mark_obtained','DESC');
        $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $this->input->post('subject_id'),'mark.class_id' => $this->input->post('class_id'),'section_id' => $this->input->post('section_id')])->result();
        echo (json_encode($data));
        //json_encode($this->db->get_where('section', $data));
    }
    function get_exam_order(){
        $this->db->join('student','student.student_id = mark.student_id');
        $this->db->group_by('student.student_id');
        $vals=$this->db->get_where('mark', [ 'mark.exam_id'=> $this->input->post('exam_id'),'mark.class_id' => $this->input->post('class_id'),'section_id' => $this->input->post('section_id')])->result();
        foreach($vals as $key=>$val){
        $this->db->join('student','student.student_id = mark.student_id');   
        $data[$key]=$this->db->get_where('mark',['student_id'=>$val->id])->result;
      }
        echo (json_encode($data));
    }
    
    /****MANAGE GRADES*****/
    function grade($param1 = '', $param2 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']        = $this->input->post('name');
            $data['grade_point'] = $this->input->post('grade_point');
            $data['mark_from']   = $this->input->post('mark_from');
            $data['mark_upto']   = $this->input->post('mark_upto');
            $data['comment']     = $this->input->post('comment');
            $this->db->insert('grade', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?administrator/grade/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']        = $this->input->post('name');
            $data['grade_point'] = $this->input->post('grade_point');
            $data['mark_from']   = $this->input->post('mark_from');
            $data['mark_upto']   = $this->input->post('mark_upto');
            $data['comment']     = $this->input->post('comment');
            
            $this->db->where('grade_id', $param2);
            $this->db->update('grade', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/grade/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('grade', array(
                'grade_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('grade_id', $param2);
            $this->db->delete('grade');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/grade/', 'refresh');
        }
        $page_data['grades']     = $this->db->get('grade')->result_array();
        $page_data['page_name']  = 'grade';
        $page_data['page_title'] = get_phrase('manage_grade');
        $this->load->view('backend/index', $page_data);
    }
    
    /**********MANAGING CLASS ROUTINE******************/
    function class_routine($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['class_id']       = $this->input->post('class_id');
            if($this->input->post('section_id') != '') {
                $data['section_id'] = $this->input->post('section_id');
            }
            $data['subject_id']     = $this->input->post('subject_id');
            $data['period_number']  = $this->input->post('period');
            $data['time_start']     = $this->input->post('time_start') + (12 * ($this->input->post('starting_ampm') - 1));
            $data['time_end']       = $this->input->post('time_end') + (12 * ($this->input->post('ending_ampm') - 1));
            $data['time_start_min'] = $this->input->post('time_start_min');
            $data['time_end_min']   = $this->input->post('time_end_min');
            $data['day']            = $this->input->post('day');
            $data['year']           = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('class_routine', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?administrator/class_routine_add/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['class_id']       = $this->input->post('class_id');
            if($this->input->post('section_id') != '') {
                $data['section_id'] = $this->input->post('section_id');
            }
            $data['period_number']  = $this->input->post('period');
            $data['subject_id']     = $this->input->post('subject_id');
            $data['time_start']     = $this->input->post('time_start') + (12 * ($this->input->post('starting_ampm') - 1));
            $data['time_end']       = $this->input->post('time_end') + (12 * ($this->input->post('ending_ampm') - 1));
            $data['time_start_min'] = $this->input->post('time_start_min');
            $data['time_end_min']   = $this->input->post('time_end_min');
            $data['day']            = $this->input->post('day');
            $data['year']           = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            
            $this->db->where('class_routine_id', $param2);
            $this->db->update('class_routine', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/class_routine_view/' . $data['class_id'], 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('class_routine', array(
                'class_routine_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $class_id = $this->db->get_where('class_routine' , array('class_routine_id' => $param2))->row()->class_id;
            $this->db->where('class_routine_id', $param2);
            $this->db->delete('class_routine');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?administrator/class_routine_view/' . $class_id, 'refresh');
        }
        
    }

    function class_routine_add()
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'class_routine_add';
        $page_data['page_title'] = get_phrase('add_class_routine');
        $this->load->view('backend/index', $page_data);
    }

    function class_routine_view($class_id)
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'class_routine_view';
        $page_data['class_id']  =   $class_id;
        $page_data['page_title'] = get_phrase('class_routine');
        $this->load->view('backend/index', $page_data);
    }

    function class_routine_print_view($class_id , $section_id)
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect('login', 'refresh');
        $page_data['class_id']   =   $class_id;
        $page_data['section_id'] =   $section_id;
        $this->load->view('backend/accountant/class_routine_print_view' , $page_data);
    }

    function get_class_section_subject($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/accountant/class_routine_section_subject_selector' , $page_data);
    }

    function section_subject_edit($class_id , $class_routine_id)
    {
        $page_data['class_id']          =   $class_id;
        $page_data['class_routine_id']  =   $class_routine_id;
        $this->load->view('backend/accountant/class_routine_section_subject_edit' , $page_data);
    }
    //staff attendance - kriss
    function staff_attendance(){
        $page_data['page_name']  =  'staff_attendance';
        $page_data['page_title'] =  get_phrase('staff_attendance');
        $this->load->view('backend/index', $page_data);
    }
    function staff_attendance_selector()
    {
        $data['year']       = $this->input->post('year');
        $data['timestamp']  = strtotime($this->input->post('timestamp'));

        $query = $this->db->get_where('teacher_attendance' ,array(
                    'year'=>$data['year'],
                        'timestamp'=>$data['timestamp']
        ));
        if($query->num_rows() < 1) {
            
            $staffs = $this->db->get('teacher')->result_array();
          
            foreach($staffs as $row) {
                $attn_data['teacher_id'] = $row['teacher_id'];
                $attn_data['year']       = $data['year'];
                $attn_data['timestamp']  = $data['timestamp'];
                $this->db->insert('teacher_attendance' , $attn_data);  
            }
            
        }
        redirect(base_url().'index.php?administrator/manage_staff_attendance_view/'.$data['timestamp'],'refresh');
    }
    function manage_staff_attendance_view($timestamp = '')
    {
        if($this->session->userdata('administrator_login')!=1)
            redirect(base_url() , 'refresh');
        
        $page_data['timestamp'] = $timestamp;
        $page_data['page_name'] = 'manage_staff_attendance_view';
        
        $page_data['page_title'] = get_phrase('manage_staff_attendance');
        $this->load->view('backend/index', $page_data);
    }
    function staff_attendance_update($timestamp = ''){
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $active_sms_service = $this->db->get_where('settings' , array('type' => 'active_sms_service'))->row()->description;
        
        $attendance_of_staffs = $this->db->get_where('teacher_attendance' , array(
            'year'=>$running_year,'timestamp'=>$timestamp
        ))->result_array();
        foreach($attendance_of_staffs as $row) {
            $attendance_status = $this->input->post('status_'.$row['teacher_attendance_id']);
            $data['attendance'] = $attendance_status;
            $this->db->where('teacher_attendance_id' , $row['teacher_attendance_id']);
            $this->db->update('teacher_attendance' , $data);

           //sms
         if($row['attendance'] == 0){
           if ($active_sms_service != '' || $active_sms_service != 'disabled') {
             $teacher_name   = $this->db->get_where('teacher' , array('teacher_id' => $row['teacher_id']))->row()->name;
             $message ='Your are absent on today ('. date("d/m/y",$timestamp).'). If not, Please contact the school.';
             $receiver_phone = $this->db->get_where('teacher' , array('teacher_id' => $row['teacher_id']))->row()->phone;
            // $this->sms_model->send_sms($message,$receiver_phone);
           }
         }
       }
        $data=array();
        $data['user_id']       =   $this->session->userdata('login_user_id');
        $data['name']       =   $this->session->userdata('name');
        $data['device']       =   'web';
        $data['description']    =   'Staff attendance';
        $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
        $data['status']    =   3;
        $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $this->db->insert('log' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('attendance_updated'));
        redirect(base_url().'index.php?administrator/manage_staff_attendance_view/'.$timestamp, 'refresh');
    }
    function staff_attendance_report(){
         $page_data['month']        = date('m');
         $page_data['page_name']    = 'staff_attendance_report';
         $page_data['page_title']   = get_phrase('staff_attendance_report');
         $this->load->view('backend/index',$page_data);
    }
    function staff_attendance_report_selector(){
        $data['month']  = $this->input->post('month');
        redirect(base_url().'index.php?administrator/staff_attendance_report_view/'.$data['month'],'refresh');
    }
    function staff_attendance_report_view($month=''){
       if($this->session->userdata('administrator_login')!=1)
            redirect(base_url() , 'refresh');
        
        $page_data['month']    = $month;
        $page_data['page_name'] = 'staff_attendance_report_view';
        $page_data['page_title'] = get_phrase('attendance_report');
        $this->load->view('backend/index', $page_data);
   }
   function staff_attendance_report_print_view($month=''){
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['month'] = $month;
        $this->load->view('backend/accountant/staff_attendance_report_print_view' , $page_data);
   }
   function staff_attendance_period(){
       $page_data['page_name']    = 'staff_attendance_report_period';
       $page_data['page_title']   = get_phrase('attendance_report');
       $this->load->view('backend/index',$page_data);
   }
   function staff_attendance_report_period_selector()
    { 
        $data['year']       = $this->input->post('year');
        $data['startdate']  = $this->input->post('start_date');
        $data['enddate']  = $this->input->post('end_date');
        redirect(base_url().'index.php?administrator/staff_attendance_report_period_view'.'/'.$data['startdate'].'/'.$data['enddate'],'refresh');
    }
    function staff_attendance_report_period_view($startdate= '' ,$enddate= '') {
         
        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $page_data['startdates'] = strtotime($startdate);
        $page_data['enddates'] = strtotime($enddate);
        $page_data['page_name'] = 'staff_attendance_report_period_view';
        
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $page_data['page_title'] = get_phrase('attendance_report');
        $this->load->view('backend/index', $page_data);
     }
     function staff_attendance_report_period_print_view($startdate = '', $enddate = '') {
         if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $this->load->view('backend/accountant/staff_attendance_report_period_print_view' , $page_data);
    }
    function manage_attendance()
    {
        if($this->session->userdata('administrator_login')!=1)
            redirect(base_url() , 'refresh');
        
        $page_data['page_name']  =  'manage_attendance';
        $page_data['page_title'] =  get_phrase('manage_attendance_of_class');
        $this->load->view('backend/index', $page_data);
    }

    function manage_attendance_view($class_id = '' , $section_id = '' , $timestamp = '')
    {
        if($this->session->userdata('administrator_login')!=1)
            redirect(base_url() , 'refresh');
        $class_name = $this->db->get_where('class' , array(
            'class_id' => $class_id
        ))->row()->name;
        $page_data['class_id'] = $class_id;
        $page_data['timestamp'] = $timestamp;
        $page_data['page_name'] = 'manage_attendance_view';
        $section_name = $this->db->get_where('section' , array(
            'section_id' => $section_id
        ))->row()->name;
        $page_data['section_id'] = $section_id;
        $page_data['page_title'] = get_phrase('manage_attendance_of_class') . ' ' . $class_name . ' : ' . get_phrase('section') . ' ' . $section_name;
        $this->load->view('backend/index', $page_data);
    }
    function get_section($class_id) {
          $page_data['class_id'] = $class_id; 
          $this->load->view('backend/accountant/manage_attendance_section_holder' , $page_data);
    }
    function approveStudent($studId = '',$classid = ''){

        $data=array('status'=>1);
        
        $this->db->where('student_id',$studId);
        $this->db->update('student',$data);

        $this->db->where('student_id',$studId);
        $this->db->update('enroll',$data);

       
        redirect(base_url().'index.php?administrator/pending_student/'.$classid);

    }
    
    
    //1632-1704 (student_sms to mass_sms) -->krish
    function student_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('administrator_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'student_sms';
        $page_data['page_title'] = 'SEND SMS TO STUDENTS';
        $this->load->view('backend/index', $page_data); 
    }
    //krish
    function student_voice_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('administrator_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'student_voice_sms';
        $page_data['page_title'] = 'SEND VOICE SMS TO STUDENTS';
        $this->load->view('backend/index', $page_data); 
    }
    
    function get_session_changer()
    {
        $this->load->view('backend/accountant/change_session');
    }

    function change_session()
    {
        $data['description'] = $this->input->post('running_year');
        $this->db->where('type' , 'running_year');
        $this->db->update('settings' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('session_changed')); 
        redirect(base_url() . 'index.php?administrator/dashboard/', 'refresh'); 
    }
    
    /***** UPDATE PRODUCT *****/
    
    function update( $task = '', $purchase_code = '' ) {
        
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
            
        // Create update directory.
        $dir    = 'update';
        if ( !is_dir($dir) )
            mkdir($dir, 0777, true);
        
        $zipped_file_name   = $_FILES["file_name"]["name"];
        $path               = 'update/' . $zipped_file_name;
        
        move_uploaded_file($_FILES["file_name"]["tmp_name"], $path);
        
        // Unzip uploaded update file and remove zip file.
        $zip = new ZipArchive;
        $res = $zip->open($path);
        if ($res === TRUE) {
            $zip->extractTo('update');
            $zip->close();
            unlink($path);
        }
        
        $unzipped_file_name = substr($zipped_file_name, 0, -4);
        $str                = file_get_contents('./update/' . $unzipped_file_name . '/update_config.json');
        $json               = json_decode($str, true);
        

            
        // Run php modifications
        require './update/' . $unzipped_file_name . '/update_script.php';
        
        // Create new directories.
        if(!empty($json['directory'])) {
            foreach($json['directory'] as $directory) {
                if ( !is_dir( $directory['name']) )
                    mkdir( $directory['name'], 0777, true );
            }
        }
        
        // Create/Replace new files.
        if(!empty($json['files'])) {
            foreach($json['files'] as $file)
                copy($file['root_directory'], $file['update_directory']);
        }
        
        $this->session->set_flashdata('flash_message' , get_phrase('product_updated_successfully'));
        redirect(base_url() . 'index.php?administrator/system_settings');
    }

    /*****SMS SETTINGS*********/
    function sms_settings($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'skysms') {

            $data['description'] = $this->input->post('skysms_user');
            $this->db->where('type' , 'skysms_user');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('skysms_password');
            $this->db->where('type' , 'skysms_password');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('skysms_sender_id');
            $this->db->where('type' , 'skysms_sender_id');
            $this->db->update('settings' , $data);

            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/sms_settings/', 'refresh');
        }

       if ($param1 == 'malayalam') {

            $data['description'] = $this->input->post('malayalam_user');
            $this->db->where('type' , 'malayalam_user');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('malayalam_sender_id');
            $this->db->where('type' , 'malayalam_sender_id');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('malayalam_api');
            $this->db->where('type' , 'malayalam_api');
            $this->db->update('settings' , $data);

            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/sms_settings/', 'refresh');
        }

        if ($param1 == 'active_service') {

            $data['description'] = $this->input->post('active_sms_service');
            $this->db->where('type' , 'active_sms_service');
            $this->db->update('settings' , $data);

            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?administrator/sms_settings/', 'refresh');
        }

        $page_data['page_name']  = 'sms_settings';
        $page_data['page_title'] = get_phrase('sms_settings');
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('backend/index', $page_data);
    }
    /*****LANGUAGE SETTINGS*********/
    function manage_language($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        
        if ($param1 == 'edit_phrase') {
            $page_data['edit_profile']  = $param2;  
        }
        if ($param1 == 'update_phrase') {
            $language   =   $param2;
            $total_phrase   =   $this->input->post('total_phrase');
            for($i = 1 ; $i < $total_phrase ; $i++)
            {
                //$data[$language]  =   $this->input->post('phrase').$i;
                $this->db->where('phrase_id' , $i);
                $this->db->update('language' , array($language => $this->input->post('phrase'.$i)));
            }
            redirect(base_url() . 'index.php?administrator/manage_language/edit_phrase/'.$language, 'refresh');
        }
        if ($param1 == 'do_update') {
            $language        = $this->input->post('language');
            $data[$language] = $this->input->post('phrase');
            $this->db->where('phrase_id', $param2);
            $this->db->update('language', $data);
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?administrator/manage_language/', 'refresh');
        }
        if ($param1 == 'add_phrase') {
            $data['phrase'] = $this->input->post('phrase');
            $this->db->insert('language', $data);
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?administrator/manage_language/', 'refresh');
        }
        if ($param1 == 'add_language') {
            $language = $this->input->post('language');
            $this->load->dbforge();
            $fields = array(
                $language => array(
                    'type' => 'LONGTEXT'
                )
            );
            $this->dbforge->add_column('language', $fields);
            
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?administrator/manage_language/', 'refresh');
        }
        if ($param1 == 'delete_language') {
            $language = $param2;
            $this->load->dbforge();
            $this->dbforge->drop_column('language', $language);
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            
            redirect(base_url() . 'index.php?administrator/manage_language/', 'refresh');
        }
        $page_data['page_name']        = 'manage_language';
        $page_data['page_title']       = get_phrase('manage_language');
        //$page_data['language_phrases'] = $this->db->get('language')->result_array();
        $this->load->view('backend/index', $page_data); 
    }
    
    /*****BACKUP / RESTORE / DELETE DATA PAGE**********/
    function backup_restore($operation = '', $type = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($operation == 'create') {
            $this->crud_model->create_backup($type);
        }
        if ($operation == 'restore') {
            $this->crud_model->restore_backup();
            $this->session->set_flashdata('backup_message', 'Backup Restored');
            redirect(base_url() . 'index.php?administrator/backup_restore/', 'refresh');
        }
        if ($operation == 'delete') {
            $this->crud_model->truncate($type);
            $this->session->set_flashdata('backup_message', 'Data removed');
            redirect(base_url() . 'index.php?administrator/backup_restore/', 'refresh');
        }
        
        $page_data['page_info']  = 'Create backup / restore from backup';
        $page_data['page_name']  = 'backup_restore';
        $page_data['page_title'] = get_phrase('manage_backup_restore');
        $this->load->view('backend/index', $page_data);
    }
    
    /******MANAGE OWN PROFILE AND CHANGE PASSWORD***/
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('administrator_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'update_profile_info') {
            $data['name']  = $this->input->post('name');
            $data['email'] = $this->input->post('email');
            
            $this->db->where('administrator_id', $this->session->userdata('administrator_id'));
            $this->db->update('administrator', $data);
            $this->session->set_flashdata('flash_message', get_phrase('account_updated'));
            redirect(base_url() . 'index.php?administrator/manage_profile/', 'refresh');
        }
        if ($param1 == 'change_password') {
            $data['password']             = sha1($this->input->post('password'));
            $data['new_password']         = sha1($this->input->post('new_password'));
            $data['confirm_new_password'] = sha1($this->input->post('confirm_new_password'));
            
            $current_password = $this->db->get_where('administrator', array(
                'administrator_id' => $this->session->userdata('administrator_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('administrator_id', $this->session->userdata('administrator_id'));
                $this->db->update('administrator', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', get_phrase('password_updated'));
            } else {
                $this->session->set_flashdata('flash_message', get_phrase('password_mismatch'));
            }
            redirect(base_url() . 'index.php?administrator/manage_profile/', 'refresh');
        }
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_title'] = get_phrase('manage_profile');
        $page_data['edit_data']  = $this->db->get_where('admin', array(
            'admin_id' => $this->session->userdata('admin_id')
        ))->result_array();
        $this->load->view('backend/index', $page_data);
    }

    function get_class_sections($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/accountant/get_sections' , $page_data);
    }



     function get_class_section_students_mass($class_id,$section_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id ,'section_id' => $section_id, 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        echo '<div class="form-group">
                <label class="col-sm-3 control-label">' . get_phrase('students') . '</label>
                <div class="col-sm-9">';
        foreach ($students as $row) {
             $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<div class="checkbox">
                    <label><input type="checkbox" class="check" name="student_id[]" value="' . $row['student_id'] . '">' . $name .'</label>
                </div>';
        }
        echo '<br><button type="button" class="btn btn-default" onClick="select()">'.get_phrase('select_all').'</button>';
        echo '<button style="margin-left: 5px;" type="button" class="btn btn-default" onClick="unselect()"> '.get_phrase('select_none').' </button>';
        echo '</div></div>';
    }
    function send_sms_from_transport( $trans_id ){
         $message  = $this->input->post('smstext');
         $this->db->join('transport_student','transport_student.student_id = student.student_id');
        $transport_students = $this->db->get_where('student', array('transport_student.transport_id' => $trans_id))->result_array();
       $data='';
        foreach($transport_students as $row) {
            $this->sms_model->send_sms($message , $row['phone']);
        }
       
        $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
        redirect(base_url() . 'index.php?administrator/transport' , 'refresh');
    }

    function send_sms_to_group( $group_id ){
         $message  = $this->input->post('smstext');
        $group_students = $this->db->query('select s.* from student s inner join students_in_group g on s.student_id = g.student_id where g.groupid ='.$group_id,false)->result_array();
       
        foreach($group_students as $row) {
           
            $this->sms_model->send_sms($message , $row['phone']);

        }
        $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
        redirect(base_url() . 'index.php?administrator/group' , 'refresh');
    }
    
}
