<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/* 	
 * 	@author : Team Edumia
 * 	23rd May, 2013
 * Team Edumia
 * 	www.edumia.net
 */

class Login extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->model('crud_model');
        $this->load->database();
        $this->load->library('session');
        /* cache control */
        $this->output->set_header('Last-Modified: ' . gmdate("D, d M Y H:i:s") . ' GMT');
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
        $this->output->set_header("Expires: Mon, 26 Jul 2010 05:00:00 GMT");
    }

    //Default function, redirects to logged in user area
    public function index() {
        date_default_timezone_set('Asia/Kolkata');
            $date=date("Y-m-d h:i:sa");
           
            $data['name'] = $this->session->userdata('name');
            $data['date_time'] = $date;
            $data['date'] = date("Y-m-d");
             $data['ip']       =   $_SERVER['REMOTE_ADDR'];
            $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
            $data['device'] = 'web';
            $data['type'] = $this->session->userdata('login_type');
           
             if(!empty($data['name'])) 
            {

                $this->db->insert('login_details',$data);
            }

        if ($this->session->userdata('admin_login') == 1)
            redirect(base_url() . 'index.php?admin/dashboard', 'refresh');

        if ($this->session->userdata('teacher_login') == 1)
            redirect(base_url() . 'index.php?teacher/dashboard', 'refresh');

        if ($this->session->userdata('student_login') == 1)
            redirect(base_url() . 'index.php?student/dashboard', 'refresh');

        if ($this->session->userdata('parent_login') == 1)
            redirect(base_url() . 'index.php?parents/dashboard', 'refresh');
        if ($this->session->userdata('accountant_login') == 1)
            redirect(base_url() . 'index.php?accountant/dashboard', 'refresh');
        if ($this->session->userdata('administrator_login') == 1)
            redirect(base_url() . 'index.php?administrator/dashboard', 'refresh');

        $this->load->view('backend/login');
    }

    //Ajax login function 
    function ajax_login() {
        $response = array();

        //Recieving post input of email, password from ajax request
        $email = $_POST["email"];
        $password = sha1($_POST["password"]);
        $response['submitted_data'] = $_POST;

        //Validating login
        $login_status = $this->validate_login($email, $password);
        $response['login_status'] = $login_status;

        if ($login_status == 'success') {
            $response['redirect_url'] = '';
        }
        //Replying ajax request with validation response
        echo json_encode($response);
    }

    //Validating login from ajax request
    function validate_login($email = '', $password = '') {
        $credential = array('user_name' => $email, 'password' => $password);
        
        // Checking login credential for admin
        $query = $this->db->get_where('admin', $credential);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('admin_login', '1');
            $this->session->set_userdata('admin_id', $row->admin_id);
            $this->session->set_userdata('login_user_id', $row->admin_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'admin');
            return 'success';
        }

        // Checking login credential for teacher
        $query = $this->db->get_where('teacher', $credential);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('teacher_login', '1');
            $this->session->set_userdata('teacher_id', $row->teacher_id);
            $this->session->set_userdata('login_user_id', $row->teacher_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'teacher');
            return 'success';
        }
        
         // Checking login credential for hostel warden
        $query = $this->db->get_where('hostel_warden', $credential);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('hostel_warden_login', '1');
            $this->session->set_userdata('hostel_warden_id', $row->hostel_warden_id);
            $this->session->set_userdata('login_user_id', $row->hostel_warden_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'hostel_warden');
            return 'success';
        }

        // Checking login credential for student 
        $this->db->where('alumni',0);
        $query = $this->db->get_where('student', $credential);
        if($query->num_rows() == 0)
        	$query = $this->db->get_where('student', ['phone' => $email, 'password' => $password]);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('student_login', '1');
            $this->session->set_userdata('student_id', $row->student_id);
            $this->session->set_userdata('login_user_id', $row->student_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'student');
            return 'success';
        }

        // Checking login credential for parent
        $query = $this->db->get_where('parent', $credential);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('parent_login', '1');
            $this->session->set_userdata('parent_id', $row->parent_id);
            $this->session->set_userdata('login_user_id', $row->parent_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'parent');
            return 'success';
        }
        // Checking login credential for accountant
        $query = $this->db->get_where('accountant', $credential);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('accountant_login', '1');
            $this->session->set_userdata('accountant_id', $row->accountant_id);
            $this->session->set_userdata('login_user_id', $row->accountant_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'accountant');
            return 'success';
        }
        
        // Checking login credential for administrator
        $query = $this->db->get_where('administrator', $credential);
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $this->session->set_userdata('administrator_login', '1');
            $this->session->set_userdata('administrator_id', $row->administrator_id);
            $this->session->set_userdata('login_user_id', $row->administrator_id);
            $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', 'administrator');
            return 'success';
        }
        
        return 'invalid';
    }

    /*     * *DEFAULT NOR FOUND PAGE**** */

    function four_zero_four() {
        $this->load->view('four_zero_four');
    }

    // PASSWORD RESET BY EMAIL
    function forgot_password()
    {
        $this->load->view('backend/forgot_password');
    }
    function ajax_password_reset(){
        $resp                   = array();
        $resp['status']         = 'false';
        
        $id = $this->session->userdata('id');
        $type = $this->session->userdata('type');
        $otp = $this->session->userdata('otp');
        $resp['otp']         = $otp;
        $resp['type']         = $type;
        // Checking credential for admin
        $query = $this->db->get_where($type , array('otp' => $otp,$type.'_id' =>$id));
        if ($query->num_rows() > 0) 
        {
            $row = $query->row();
            $this->db->where($type.'_id' , $id);
            $resp['status']         = 'true';
            $this->session->set_userdata($type.'_login', '1');
            $this->session->set_userdata($type.'_id', $id);
            $this->session->set_userdata('login_user_id', $id);
             $this->db->update($type , array('password' => sha1($_POST['new_password'])));
           $this->session->set_userdata('name', $row->name);
            $this->session->set_userdata('login_type', $type);
            $this->db->where('otp !=' , 0);
            $this->db->update($type , array('otp' => 0));
        }
        echo json_encode($resp);
    }
    function ajax_forgot_password()
    {
        $resp                   = array();
        $resp['status']         = 'false';
        $email                  = $_POST["email"];
        $reset_account_type     = '';
        //resetting user password here
        $new_password           =  mt_rand(100000, 999999);

        // Checking credential for admin
        $query = $this->db->get_where('admin' , array('email' => $email));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'admin';
            $this->db->where('email' , $email);
            $this->db->update('admin' , array('otp' => $new_password));
            $resp['status']         = 'true';
        }
        // Checking credential for student
        $query = $this->db->get_where('student' , array('email' => $email));
        if ($query->num_rows() > 0) 
        {
            $phone = $query->row()->phone;
            $reset_account_type     =   'student';
            $this->db->where('email' , $email);
            $this->db->update('student' , array('otp' => $new_password));
            $resp['status']         = 'true';
			
        }
        // Checking credential for teacher
        $query = $this->db->get_where('teacher' , array('email' => $email));
        if ($query->num_rows() > 0) 
        {
            $phone = $query->row()->phone;
            $reset_account_type     =   'teacher';
            $this->db->where('email' , $email);
            $this->db->update('teacher' , array('otp' => $new_password));
            $resp['status']         = 'true';
        }
        // Checking credential for parent
        $query = $this->db->get_where('parent' , array('email' => $email));
        if ($query->num_rows() > 0) 
        {
            $phone = $query->row()->phone;
            $reset_account_type     =   'parent';
            $this->db->where('email' , $email);
            $this->db->update('parent' , array('otp' => $new_password));
            $resp['status']         = 'true';
        }
        // Checking credential for accountant
        $query = $this->db->get_where('accountant' , array('email' => $email));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'accountant';
            $this->db->where('email' , $email);
            $this->db->update('accountant' , array('otp' => $new_password));
            $resp['status']         = 'true';
        }
        if($resp['status'] == 'true'){
            // send new password to user email  
            $this->email_model->password_reset_email($new_password , $reset_account_type , $email);
        }

        $resp['submitted_data'] = $_POST;

        echo json_encode($resp);
    }
    function ajax_forgot_password_phone()
    {
        $resp                   = array();
        $resp['status']         = 'false';
        $phone                  = $_POST["phone"];
        $reset_account_type     = '';
        //resetting user password here
        $new_password           =  mt_rand(100000, 999999);;

        
        // Checking credential for student
        $query = $this->db->get_where('student' , array('phone' => $phone));
        if ($query->num_rows() > 0) 
        {
            $phone = $query->row()->phone;
            $reset_account_type     =   'student';
            $this->db->where('phone' , $phone);
            $this->db->update('student' , array('otp' => $new_password));
            $resp['status']         = 'true';
			
        }
        // Checking credential for teacher
        $query = $this->db->get_where('teacher' , array('phone' => $phone));
        if ($query->num_rows() > 0) 
        {
            $phone = $query->row()->phone;
            $reset_account_type     =   'teacher';
            $this->db->where('phone' , $phone);
            $this->db->update('teacher' , array('otp' => $new_password));
            $resp['status']         = 'true';
        }
        // Checking credential for parent
        $query = $this->db->get_where('parent' , array('phone' => $phone));
        if ($query->num_rows() > 0) 
        {
            $phone = $query->row()->phone;
            $reset_account_type     =   'parent';
            $this->db->where('phone' , $phone);
            $this->db->update('parent' , array('otp' => $new_password));
            $resp['status']         = 'true';
        }
        if($resp['status'] == 'true'){
            $email_msg	.=	"Your otp is : ".$new_password." ";
            $this->sms_model->send_sms($email_msg,$phone);
        }

        $resp['submitted_data'] = $_POST;

        echo json_encode($resp);
    }
    function ajax_check_otp()
    {
        $resp                   = array();
        $resp['status']         = 'false';
        $otp                  = $_POST["otp"];
        $reset_account_type     = '';
        
        // Checking credential for admin
        $query = $this->db->get_where('admin' , array('otp' => $otp));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'admin';
            $this->session->set_userdata('otp', $otp);
            $this->session->set_userdata('id', $query->row()->admin_id);
            $this->session->set_userdata('type', 'admin');
            $resp['status']         = 'true';
        }
        // Checking credential for student
        $query = $this->db->get_where('student' , array('otp' => $otp));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'student';
            $this->session->set_userdata('otp', $otp);
            $this->session->set_userdata('id', $query->row()->student_id);
            $this->session->set_userdata('type', 'student');
            $resp['status']         = 'true';
        }
        // Checking credential for teacher
        $query = $this->db->get_where('teacher' , array('otp' => $otp));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'teacher';
            $this->session->set_userdata('otp', $otp);
            $this->session->set_userdata('type', 'teacher');
            $this->session->set_userdata('id', $query->row()->teacher_id);
            $resp['status']         = 'true';
        }
        // Checking credential for parent
        $query = $this->db->get_where('parent' , array('otp' => $otp));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'parent';
            $this->session->set_userdata('otp', $otp);
            $this->session->set_userdata('id', $query->row()->parent_id);
            $this->session->set_userdata('type', 'parent');
            $resp['status']         = 'true';
        }
        // Checking credential for accountant
        $query = $this->db->get_where('accountant' , array('otp' => $otp));
        if ($query->num_rows() > 0) 
        {
            $reset_account_type     =   'accountant';
            $this->session->set_userdata('otp', $otp);
            $this->session->set_userdata('type', 'accountant');
            $this->session->set_userdata('id', $query->row()->accountant_id);
            $resp['status']         = 'true';
        }

        $resp['submitted_data'] = $_POST;

        echo json_encode($resp);
    }

    /*     * *****LOGOUT FUNCTION ****** */

    function logout() {
        $this->session->sess_destroy();
        $this->session->set_flashdata('logout_notification', 'logged_out');
        redirect(base_url(), 'refresh');
    }

}
