<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Admin extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->database();
         $this->load->model('Barcode_model');
         $this->load->model(array('Ajaxdataload_model' => 'ajaxload'));
        $this->load->library('session');
        
       /*cache control*/
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }
    
    /***default functin, redirects to login page if no admin logged in yet***/
    public function index()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($this->session->userdata('admin_login') == 1)
            redirect(base_url() . 'index.php?admin/dashboard', 'refresh');
    }
 //krish
    public function birthday_wishes(){
        $birthday = $this->db->get_where('settings' , array(
            'type' => 'birthday'
            ))->row()->description;
        if($birthday == 'Yes'){
            $y= date("Y"); // Year value
            $this->db->where('status',1);
            $birth_students = $this->db->get('student')->result_array();
            if(count($birth_students)>0){
                foreach($birth_students as $student){
                    if(isset($student['birthday'])){
                        $mem_bod_explode=explode("/",$student['birthday']);
                        $m_bday = mktime(0,0,0,$mem_bod_explode[1],$mem_bod_explode[0],$y);
                        if(date('d-m-Y') == date('d-m-Y',$m_bday)){
                            $message = 'Hi '.$student['name'].', Happy birthday to you. May this special day brings you all the happiness and success you deserve in life. Have a great day!';
                            if($student['phone'] !=''){ //student phone
                                $this->sms_model->send_sms($message,$student['phone']);
                            }
                            else{ //Parent phone
                                $this->db->where('parent_id',$student['parent_id']);
                                $phone = $this->db->get('parent')->row()->phone;
                                if($phone !=''){
                                    $this->sms_model->send_sms($message,$phone);
                                }
                            }
                        }
                    }
                }
            }
        }
    } 
    
   public function update_student_details() 
    {
        if($this->input->post('type') =='roll'){
            $data['roll']      = $this->input->post('roll');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('enroll', $data);
        }
        else if($this->input->post('type') =='name'){
            $data['name']      = $this->input->post('name');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('student', $data);
        }
        else if($this->input->post('type') =='address'){
            $data['address']      = $this->input->post('address');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('student', $data);
        }
      else if($this->input->post('type') =='phone'){
            $data['phone']      = $this->input->post('phone');
           
            $this->db->where('student_id', $this->input->post('id'));
            $this->db->update('student', $data);
        }
        
    }
    function check_amount($param1='',$param2=''){
        $this->db->where(['income_category_id'=> $param1,'invoice_id'=>$param2]);
        $amount = $this->db->get('invoice_student_master')->row()->due;
        echo $amount;
    }
    function get_teachers(){
        $this->db->select('teacher.teacher_id,teacher.name');
        $this->db->join('teacher', 'teacher.teacher_id = subject.teacher_id');
        $teachers = $this->db->get_where('subject',['subject_id'=>$this->input->post('subject_id'),'class_id'=>$this->input->post('class_id')]);
        echo (json_encode($teachers->result()));
    }
    public function homework_detail($param1='',$param2=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if($param1 =='do_update'){
            $this->db->where('homework_upload_id', $param2);
            $homework = $this->db->get('homework_mark')->row();
            $homework_upload = $this->db->get_where('homework_upload' , array('homework_upload_id' => $param2) )->row();
            $hwork = $this->db->get_where('homework' , array('homework_id' => $homework_upload->homework_id) )->row();
            
            $data['user_id'] = $this->session->userdata('admin_id');
            $data['user_type'] = 'admin';
            $data['mark'] = $this->input->post('mark');
            $data['homework_upload_id'] = $param2;
            $data['timestamp'] = strtotime("now");
            
            if(isset($homework)){
                $this->db->update('homework_mark', $data);
            }
            else{
                $this->db->insert('homework_mark', $data);
            }
            $this->session->set_flashdata('flash_message' , get_phrase('mark_updated'));
            redirect(base_url() . 'index.php?admin/homework_detail/'.$hwork->homework_id, 'refresh');
            
        }
        $running_year= $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description; 
        $page_data['homework']  = $this->db->get_where('homework' , array('homework.homework_id' => $param1))->row();
        $page_data['attachments']  = $this->db->get_where('homework_attachment' , array('homework_id' => $param1))->result_array();
        
        $this->db->select('student_id');
        $this->db->group_by('student_id');
        $students  = $this->db->get_where('homework_upload' , array('homework_id' => $param1))->result_array();
        $students = array_column($students, 'student_id');
        $result = array();
        
        if(count($students)>0){
            $this->db->order_by('student_id');
            $this->db->where_in('student_id',$students);
            $result = $this->db->get('student')->result();
        }
        $page_data['student_lists']  = array();
        if(isset($result) && count($result)>0){
            foreach($result as $key=>$row){
                $page_data['student_lists'][$key]['student_id'] = $row->student_id;
                $page_data['student_lists'][$key]['name'] = $row->name;
                $page_data['student_lists'][$key]['roll'] = $this->db->get_where('enroll' , array('student_id' => $row->student_id,'year'=>$running_year))->row()->roll;
                $data = $this->db->get_where('homework_upload' , array('homework_id' => $param1,'student_id'=>$row->student_id))->row();
                
                $page_data['student_lists'][$key]['homework_upload_id'] = $data->homework_upload_id;
                $page_data['student_lists'][$key]['description'] = $data->description;
                $page_data['student_lists'][$key]['date'] = date('d M Y H:i A',$data->timestamp);
                $page_data['student_lists'][$key]['file'] = $this->db->get_where('homework_upload_file' , array('homework_upload_id' => $data->homework_upload_id))->result_array();
            }
        }
        $page_data['page_name']  = 'homework_detail';
        $page_data['page_title'] = get_phrase('homework');
        $this->load->view('backend/index', $page_data);
    }
    public function delete_homework_attachments(){
        $this->db->where('homework_attachment_id', $this->input->post('id'));
        $data= $this->db->delete('homework_attachment');
        echo (json_encode($data));
    }
    public function homework($param1='',$param2=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
            
        if($param1=='create'){
            $data['title']  =  $this->input->post('title');
            $data['description'] =  $this->input->post('description');
            $data['class_id']  =  $this->input->post('class');
            $data['section_id'] = $this->input->post('section_id');
            $data['subject_id'] = $this->input->post('subject_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['chapter_id'] = $this->input->post('chapter_id');
            $data['start_date'] = date('Y-m-d',strtotime($this->input->post('start_date')));
            $data['end_date'] = date('Y-m-d',strtotime($this->input->post('end_date')));
            $data['total_mark'] = $this->input->post('total_mark');
            $data['user_type'] = $this->session->userdata('login_type');
            $data['user_id'] = $this->session->userdata('login_user_id');
            $data['year'] = $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
            $data['timestamp'] = strtotime("now");
            $this->db->insert('homework', $data);
            $homework_id = $this->db->insert_id();
            
            //uploading file using codeigniter upload library
            $files = $_FILES['file_name'];
            $this->load->library('upload');
            if (!is_dir('uploads/homework/')) {
                 mkdir('uploads/homework/', 0777, TRUE);
            }
            $config['upload_path']   =  'uploads/homework/';
            $config['allowed_types'] =  '*';
            foreach($files['name'] as $key=>$file){
                $_FILES['file_name']['name']     = $files['name'][$key];
                $_FILES['file_name']['type']     = $files['type'][$key];
                $_FILES['file_name']['tmp_name'] = $files['tmp_name'][$key];
                $_FILES['file_name']['size']     = $files['size'][$key];
                $this->upload->initialize($config);
                $this->upload->do_upload('file_name');
                $data1['homework_id'] = $homework_id;
                $data1['name'] = $file;
                $data1['file'] = 'uploads/homework/'.$_FILES['file_name']['name'];
                $this->db->insert('homework_attachment', $data1);
            }
            
            $this->session->set_flashdata('flash_message' , get_phrase('homework_added_successfully'));
            redirect(base_url() . 'index.php?admin/homework', 'refresh');

        }
        elseif($param1 =='filter' && $this->input->post('class') !=0){
            if($this->input->post('class') !=0){
                    $data['class_id']=$this->input->post('class');
                if($this->input->post('section_id') !=0)
                    $data['section_id']=$this->input->post('section_id');
                if($this->input->post('subject_id') !=0 && $this->input->post('subject_id') !='')
                    $data['subject_id']=$this->input->post('subject_id');
                if($this->input->post('chapter_id') !=0 && $this->input->post('chapter_id') !='')
                    $data['chapter_id']=$this->input->post('chapter_id');
                $this->db->where($data);
                $this->db->order_by('homework_id','desc');
                $page_data['homeworks'] = $this->db->get_where('homework')->result_array(); 
            $page_data['class_id'] = $this->input->post('class');
            $page_data['section_id'] = $this->input->post('section_id');
            $page_data['sections'] = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
            if($this->input->post('subject_id') !='' && $this->input->post('subject_id') !=0)
                $page_data['subject_id'] = $this->input->post('subject_id');
            $page_data['subjects'] = $this->db->get_where('subject',['class_id'=>$this->input->post('class')])->result_array();
        
            if($this->input->post('chapter_id') !='' && $this->input->post('chapter_id') !=0)
                $page_data['chapter_id'] = $this->input->post('chapter_id');
            $page_data['chapters'] = $this->db->get_where('chapter',$data)->result_array();
                
            }
        }
        elseif($param1 =='delete'){
            $this->db->where('homework_id', $param2);
            $this->db->delete('homework');
            $this->session->set_flashdata('flash_message' , get_phrase('homework_deleted'));
            redirect(base_url() . 'index.php?admin/homework', 'refresh');
        }
        elseif($param1 =='do_update'){
            $this->db->where('homework_id', $param2);
            $homework = $this->db->get('homework')->row();
            if(isset($homework)){
                $data = array();
                $data['title']  =  $this->input->post('title');
                $data['description'] =  $this->input->post('description');
                $data['class_id']  =  $this->input->post('class');
                $data['section_id'] = $this->input->post('section');
                $data['subject_id'] = $this->input->post('subject_id');
                $data['chapter_id'] = $this->input->post('chapter_id');
                $data['start_date'] = $this->input->post('start_date');
                $data['end_date'] = $this->input->post('end_date');
                $data['total_mark'] = $this->input->post('total_mark');
                $data['user_type'] = $this->session->userdata('login_type');
                $data['user_id'] = $this->session->userdata('login_user_id');
                $this->db->where('homework_id', $param2);
                $this->db->update('homework', $data);
                //uploading file using codeigniter upload library
                $files = $_FILES['file_name'];
                $this->load->library('upload');
                if (!is_dir('uploads/homework/')) {
                     mkdir('uploads/homework/', 0777, TRUE);
                }
                $config['upload_path']   =  'uploads/homework/';
                $config['allowed_types'] =  '*';
                foreach($files['name'] as $key=>$file){
                    if($files['name'][$key] !=''){
                        $_FILES['file_name']['name']     = $files['name'][$key];
                        $_FILES['file_name']['type']     = $files['type'][$key];
                        $_FILES['file_name']['tmp_name'] = $files['tmp_name'][$key];
                        $_FILES['file_name']['size']     = $files['size'][$key];
                        $this->upload->initialize($config);
                        $this->upload->do_upload('file_name');
                        $data1['homework_id'] = $param2;
                        $data1['name'] = $file;
                        $data1['file'] = 'uploads/homework/'.$_FILES['file_name']['name'];
                        $this->db->insert('homework_attachment', $data1);
                    }
                }
            }
            $this->session->set_flashdata('flash_message' , get_phrase('Updated successfully'));
            redirect(base_url() . 'index.php?admin/homework' , 'refresh'); 
            
        }
        else{
            $this->db->order_by('homework_id','desc');
            $page_data['homeworks'] = $this->db->get_where('homework')->result_array(); 
        }
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description; 
        $page_data['page_name']  = 'homework';
        $page_data['page_title'] = get_phrase('homework');
        $this->load->view('backend/index', $page_data);
    }
    public function chapters($param1='',$param2=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']       = $this->input->post('name');
            $data['class_id']   = $this->input->post('class');
            $data['section_id'] = $this->input->post('section_id');
            $data['subject_id'] = $this->input->post('subject');
            $data['timestamp']  = strtotime(date('d-m-Y H:i:s'));
            $data['year']       = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            if($this->input->post('section_id') !=0){
                $this->db->insert('chapter', $data);
            }
            else{
                $sections = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
                if(isset($sections)){
                    foreach($sections as $row){
                        $data['section_id'] = $row['section_id'];
                        $this->db->insert('chapter', $data);
                    }
                }
            }
            
            
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/chapters', 'refresh');
        }
        else if ($param1 == 'do_update') {
            $data['name']       = $this->input->post('name');
            $data['class_id']   = $this->input->post('class');
            $data['subject_id'] = $this->input->post('subject');
            $data['section_id'] = $this->input->post('section_id');
            
            $this->db->where('chapter_id', $param2);
            $this->db->update('chapter', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/chapers', 'refresh');
        }
        else if ($param1 == 'delete') {
            $this->db->where('chapter_id', $param2);
            $this->db->delete('chapter');
            
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/chapters', 'refresh');
        }
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $this->db->order_by('chapter_id','desc');
        $page_data['chapter']  = $this->db->get_where('chapter',['year'=>$running_year])->result_array();
        $page_data['page_name']  = 'chapters';
        $page_data['page_title'] = get_phrase('chapters');
        $this->load->view('backend/index', $page_data);
    }
    
    //student-user agents 
    public function student_user_agents($param1='', $param2=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'delete') {
            $this->db->where('user_agent_id', $param2);
            $this->db->delete('user_agents');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/student_user_agents/', 'refresh');
        }
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $page_data['agents']  = $this->db->get_where('user_agents',['year'=>$running_year])->result_array();
        $page_data['page_name']  = 'student_user_agent';
        $page_data['page_title'] = get_phrase('student_user_agents');
        $this->load->view('backend/index', $page_data);
    }

    //class schedule
    public function class_schedule($param1='', $param2='', $param3=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['class_id'] = $this->input->post('class');
            $data['section_id'] = $this->input->post('section');
            $data['title'] = $this->input->post('title');
            $data['notice'] = $this->input->post('notice');
            $data['date'] =  date("Y-m-d");
            $data['timestamp'] = strtotime($this->input->post('timestamp'));
            $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('class_schedule', $data);
            //Log
            $datas['user_id']       =   $this->session->userdata('login_user_id');
            $datas['name']       =   $this->session->userdata('name');
            $datas['device']       =   'web';
            $datas['description']    =   'Class-'.$this->input->post('class').' Section-'.$this->input->post('section').' New Notice with Title '.$this->input->post('notice_title').' has been added.';
            $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
            $datas['status']    =   0;
            $datas['date'] =  date("Y-m-d");
            $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/class_schedule', 'refresh');
        }
        else if ($param1 == 'do_update') {
            $data['class_id'] = $this->input->post('class');
            $data['section_id'] = $this->input->post('section_id');
            $data['title']     = $this->input->post('title');
            $data['notice']           = $this->input->post('notice');
            $data['timestamp'] = strtotime($this->input->post('timestamp'));
            $this->db->where('class_schedule_id', $param2);
            $this->db->update('class_schedule', $data);
            //Log
             $datas['user_id']       =   $this->session->userdata('login_user_id');
             $datas['name']       =   $this->session->userdata('name');
             $datas['device']       =   'web';
             $datas['description']    =   'Class-'.$this->input->post('class').' Section-'.$this->input->post('section_id').'notice with title '.$this->input->post('title').' has been updated.';
             $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
             $datas['status']    =   0;
             $datas['date'] =  date("Y-m-d");
             $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
             $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/class_schedule/', 'refresh');
        }
        else if ($param1 == 'delete') {
            $notice = $this->db->get_where('class_schedule' , array('class_schedule_id' => $param2 ))->row()->title;
            $this->db->where('class_schedule_id', $param2);
            $this->db->delete('class_schedule');
            //Log
            $datas['user_id']       =   $this->session->userdata('login_user_id');
            $datas['name']       =   $this->session->userdata('name');
            $datas['device']       =   'web';
            $datas['description']    =   'Notice with title '.$notice.'  deleted.';
            $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
            $datas['status']    =   0;
            $datas['date'] =  date("Y-m-d",$timestamp);
            $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/class_schedule/', 'refresh');
        }

        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

        $this->db->select('class_schedule_id,title,notice,date,timestamp,class.name as class_name,section.name as section_name');
        $this->db->join('section', 'class_schedule.section_id=section.section_id');
        $this->db->join('class', 'class_schedule.class_id=class.class_id');
        $this->db->from('class_schedule');
        if ($this->input->post('list')) 
            $this->db->where(['class_schedule.class_id'=>$this->input->post('class'),'class_schedule.section_id'=>$this->input->post('section_id')]);
        else
            $this->db->where('date BETWEEN CURDATE() - INTERVAL 30 DAY AND CURDATE()');
        $this->db->where('year',$running_year);
        $this->db->order_by("class_schedule_id","desc");
        $query = $this->db->get();
        $page_data['schedule']  = $query->result_array();
        $page_data['page_name']  = 'class_schedule';
        $page_data['page_title'] = get_phrase('class_schedule');
        $this->load->view('backend/index', $page_data);
    }
    
    
    //google calender starts here
    public function callback($code='',$scope=''){
        
    }
    
    //google calender ends here
    
    //razorpay starts here
    function online_payments(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        $this->db->select('razor_payment_id,student.name as student,class.name as class,email,phone,online_payments.timestamp,amount');
        $this->db->where('enroll.year' , $running_year);
        $this->db->join('enroll', 'enroll.student_id=online_payments.online_student_id'); 
        $this->db->join('class', 'enroll.class_id=class.class_id');
        $this->db->join('student', 'online_payments.online_student_id = student.student_id');
        $this->db->order_by('online_payments.online_payment_id', 'desc');
        $page_data['payments'] = $this->db->get('online_payments')->result_array();
       
        $page_data['page_name']  = 'online_payments';
        $page_data['page_title'] = get_phrase('online_payments');
        $this->load->view('backend/index', $page_data);
    }
    //razorpay ends here
    
    //zoom starts here
    function create_meeting() {
        
        //$path_to_file = FCPATH.'/uploads/video/file_example_MP4_480_1_5MG6.mp4';
        /*require 'vendor/autoload.php';
        //use Aws\S3\S3Client;
        
        $client = new Aws\S3\S3Client([
                'version' => 'latest',
                'region'  => 'sgp1',
                'endpoint' => 'https://video-resources.sgp1.digitaloceanspaces.com',
                'credentials' => [
                        'key'    => 'VJWNTVZ4IYMWY72ASFJD',
                        'secret' => 'zFLjiAvI26GeRXi0JkBSmU30UxTwAo79pSrfvZKzu/0',
                    ],
        ]);
        

        $spaces = $client->listBuckets();
        print_r($spaces);
foreach ($spaces['Buckets'] as $space){
    echo $space['Name']."\n";
}
exit;*/
    
        //require_once 'vendor/space.php';
        //$space = new SpacesConnect(key, secret, space_name, region);
        

        //$data = $space->UploadFile($path_to_file, "public");
       /* $files = $space->ListObjects();
        print_r($spaces);
        exit;*/
        
        //$download_file = "test.docx";
//$save_as = "folder/downloaded-test.docx";
    //$data = $space->DownloadFile($download_file, $save_as);
        //$data = $space->UploadFile($path_to_file, "public");
        
        //print_r($data);
        //exit;
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if($this->input->post('title') !=''){
            $accessToken = $this->db->get_where('zoom_token' , array(
                'zoom_token_id' =>1
            ))->row()->access_token;
            try{
                
                require_once 'vendor/autoload.php';
                $client = new GuzzleHttp\Client(['base_uri' => 'https://api.zoom.us']);
                
                $date = date('yy-m-d',strtotime($this->input->post('date'))).'T'.$this->input->post('time').':00';
                $duration = $this->input->post('minutes')+($this->input->post('hours')*60);
                if($duration == 0)
                    $duration=5;
                $random = rand(100000, 999999);
                $desc='';
                if($this->input->post('description') !='')
                    $desc = $this->input->post('description');
                $response = $client->request('POST', '/v2/users/me/meetings', [
                    "headers" => [
                        "Authorization" => "bearer ".$accessToken
                    ],
                    'json' => [
                        "topic" => $this->input->post('title'),
                        "type" => 2,
                        "start_time" => $date,
                        "duration" => $duration, // mins
                        "password" => $random,
                        "agenda" => $desc
                    ],
                ]);
                $token = json_decode($response->getBody()->getContents(), true);
                
                if(isset($token)){
                    $data =array();
                    $data['class_id'] = $this->input->post('class');
                    $data['section_id'] = $this->input->post('section_id');
                    $data['subject_id'] = $this->input->post('subject');
                    $data['title'] = $this->input->post('title');
                    $data['description'] = $this->input->post('description');
                    $data['date'] = $this->input->post('date');
                    $data['time'] = $this->input->post('time');
                    $data['hour'] = $this->input->post('hours');
                    $data['minute'] = $this->input->post('minutes');
                    $data['zoom_meeting_id'] = $token['id'];
                    $data['start_url'] = $token['start_url'];
                    $data['join_url'] = $token['join_url'];
                    $data['host_id'] = $token['host_id'];
                    $data['uuid'] = $token['uuid'];
                    $data['timestamp'] = strtotime(date('d-m-Y H:i:s'));
                    $data['password'] = $random;
                    $data['duration'] = $duration;
                    $data['status'] = 1;
                    if($this->input->post('section_id') !=0){
                        $this->db->insert('meeting', $data);
                    }
                    else{
                        $sections = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
                        if(isset($sections)){
                            foreach($sections as $row){
                                $data['section_id'] = $row['section_id'];
                                $this->db->insert('meeting', $data);
                            }
                        }
                    }
                    
                    //invite students
                    if($this->input->post('section_id') !=0){
                        $students = $this->db->get_where('enroll' , array(
                            'class_id' => $this->input->post('class') ,'section_id' => $this->input->post('section_id'), 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
                        ))->result_array();
                    }
                    else{
                        $students = $this->db->get_where('enroll' , array(
                            'class_id' => $this->input->post('class'), 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
                        ))->result_array();
                    }
                    $logo = base_url() .'uploads/logo.png';
                    $join_url = $token['join_url'];
                    $message = 'Edumia is inviting you to an online class. Topic: '.$this->input->post('title').', Time: '.date('d M Y H:i a',strtotime($this->input->post('date') .' '.$this->input->post('time'))).'. To join class class click the link: '.$token['join_url'].'. Meeting ID: '.$token['id'].' Password: '.$random;
                    foreach ($students as $stud) {
                        $stud_details = $this->crud_model->get_student_info($stud['student_id']);   
                        $name = $stud_details[0]['name'];
                        $email_message = '<html><style>.body,.content-cell,.header{color:#D0D0D0  !important;background-color:#1C3F55;filter:progid:DXImageTransform.Microsoft.gradient(GradientType=1,startColorstr=#1C3F55, endColorstr=#3ca7bb);background-image:-moz-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-webkit-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-o-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-ms-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-webkit-gradient(linear, right bottom, left top, color-stop(21%,#1C3F55), color-stop(33%,#3ca7bb),color-stop(59%,#3A456F),color-stop(77%,#2B5770));-webkit-background-size: cover !important;-moz-background-size: cover !important;-o-background-size: cover !important;background-size: cover !important; background-size: 100% 100% !important;background-repeat: repeat center center fixed!important;background-position: 0 0;font-family: Roboto !important;background-repeat: no-repeat;background-attachment: fixed;}</style><body><center><div style="margin:0;padding-top:0;padding-bottom:0;padding-right:0;padding-left:0;min-width:100%;background-color:#e1e1e1;color:#212121"><center  style="width:100%;table-layout:fixed"><div  style="max-width:600px"><table style="border-spacing:0;font-family:sans-serif;color:#333333;margin:0 auto;width:100%;max-width:540px;background-color:#e1e1e1" align="center"><tbody><tr><td style="padding-top:0;padding-bottom:0;padding-right:0;padding-left:0"><table style="border-spacing:0;font-family:sans-serif;color:#333333" width="100%"><tbody><tr><td style="background-color:#e1e1e1;text-align:center;padding-top:30px;padding-bottom:30px;padding-right:0;padding-left:0"></td></tr><tr><td style="padding-top:0;padding-bottom:0;padding-right:0;padding-left:0;background-color:#ffffff"><table style="border-spacing:0;font-family:sans-serif;color:#333333" width="100%"><tbody><tr><td style="padding-top:0;padding-bottom:0;padding-right:0;padding-left:0;text-align:center;background: #3ca7bb;color:#fff"><div><br><center><img alt="School Logo" src="'.$logo.'"  alt="Logo" title="Logo" style="display:block" width="80" height="80" /><h3 style="margin:0px!important;">'.$this->db->get_where("settings" , array("type" => "system_name"))->row()->description.'</h2></center><div class="clearfix"></div><br></div></td></tr></tbody></table> <p style="margin-top:30px;font-family:Arial,Helvetica,sans-serif;font-size:15px;line-height:24px;color:#363636;margin-bottom:20px;margin-right:40px;margin-left:40px">Hey '.$name.', </p><p style="font-family:Arial,Helvetica,sans-serif;font-size:15px;line-height:24px;color:#363636;margin-top:5px;margin-bottom:20px;margin-right:40px;margin-left:40px">Edumia is inviting you to an online class. <br>Topic : '.$this->input->post("title").'<br>Time : '.date("d M Y H:i a",strtotime($this->input->post("date") .' '.$this->input->post("time"))).'<br>To join <a href="'.$join_url.'">Click Here</a> <br>Meeting ID : '.$token["id"].'<br> Password : '.$random.'</p>   </td></tr></tbody></table><table style="border-spacing:0;font-family:sans-serif;color:#333333" width="100%"><tbody><tr><td style="padding-top:20px;padding-bottom:0;padding-right:20px;padding-left:20px;text-align:center"> <p style="font-family:Verdana,Tahoma,sans-serif;font-size:11px;line-height:18px;color:#939393;margin-top:5px;margin-bottom:20px;margin-right:40px;margin-left:40px"></p><p style="font-family:Verdana,Tahoma,sans-serif;font-size:11px;line-height:18px;color:#939393;margin-top:5px;margin-bottom:20px;margin-right:40px;margin-left:40px">This is an automated e-mail send from Edumia Team. <br>Please don`t reply to this e-mail.</p></td></tr></tbody></table></td></tr></tbody></table></div></center></body></html>';
                        if($this->input->post('msg_type') ==1){
                            if($stud_details[0]['phone'] !=''){
                                $results = $this->sms_model->send_sms( $message , $stud_details[0]['phone']); 
                            }
                            else{
                                if($stud_details[0]['email'] !='')
                                    $this->email_model->do_email($email_message , 'Edumia - Online Class' , $stud_details[0]['email']);
                            }   
                        }
                        else{
                            if($stud_details[0]['email'] !=''){
                                $this->email_model->do_email($email_message , 'Edumia - Online Class' , $stud_details[0]['email']);
                            }
                            else{
                                if($stud_details[0]['phone'] !='')
                                   $results = $this->sms_model->send_sms( $message , $stud_details[0]['phone']); 
                            }
                        }
                    }
                    $this->db->join('teacher','teacher.teacher_id=class.teacher_id');
                    $teacher = $this->db->get_where('class',['class_id'=>$this->input->post('class')])->row();
                    if(isset($teacher)){
                        $logo = base_url() .'uploads/logo.png';
                        $start_url = $token['start_url'];
                        $message = '<html><style>.body,.content-cell,.header{color:#D0D0D0  !important;background-color:#1C3F55;filter:progid:DXImageTransform.Microsoft.gradient(GradientType=1,startColorstr=#1C3F55, endColorstr=#3ca7bb);background-image:-moz-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-webkit-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-o-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-ms-linear-gradient(right bottom, #1C3F55 21%, #3ca7bb 33%,#3A456F 59%,#2B5770 77%);background-image:-webkit-gradient(linear, right bottom, left top, color-stop(21%,#1C3F55), color-stop(33%,#3ca7bb),color-stop(59%,#3A456F),color-stop(77%,#2B5770));-webkit-background-size: cover !important;-moz-background-size: cover !important;-o-background-size: cover !important;background-size: cover !important; background-size: 100% 100% !important;background-repeat: repeat center center fixed!important;background-position: 0 0;font-family: Roboto !important;background-repeat: no-repeat;background-attachment: fixed;}</style><body><center><div style="margin:0;padding-top:0;padding-bottom:0;padding-right:0;padding-left:0;min-width:100%;background-color:#e1e1e1;color:#212121"><center  style="width:100%;table-layout:fixed"><div  style="max-width:600px"><table style="border-spacing:0;font-family:sans-serif;color:#333333;margin:0 auto;width:100%;max-width:540px;background-color:#e1e1e1" align="center"><tbody><tr><td style="padding-top:0;padding-bottom:0;padding-right:0;padding-left:0"><table style="border-spacing:0;font-family:sans-serif;color:#333333" width="100%"><tbody><tr><td style="background-color:#e1e1e1;text-align:center;padding-top:30px;padding-bottom:30px;padding-right:0;padding-left:0"></td></tr><tr><td style="padding-top:0;padding-bottom:0;padding-right:0;padding-left:0;background-color:#ffffff"><table style="border-spacing:0;font-family:sans-serif;color:#333333" width="100%"><tbody><tr><td style="padding-top:0;padding-bottom:0;padding-right:0;padding-left:0;text-align:center;background: #3ca7bb;color:#fff"><div><br><center><img alt="School Logo" src="'.$logo.'"  alt="Logo" title="Logo" style="display:block" width="80" height="80" /><h3 style="margin:0px!important;">'.$this->db->get_where("settings" , array("type" => "system_name"))->row()->description.'</h2></center><div class="clearfix"></div><br></div></td></tr></tbody></table> <p style="margin-top:30px;font-family:Arial,Helvetica,sans-serif;font-size:15px;line-height:24px;color:#363636;margin-bottom:20px;margin-right:40px;margin-left:40px">Hey '.$teacher->name.', </p><p style="font-family:Arial,Helvetica,sans-serif;font-size:15px;line-height:24px;color:#363636;margin-top:5px;margin-bottom:20px;margin-right:40px;margin-left:40px">Edumia is inviting you to an online class. <br>Topic : '.$this->input->post("title").'<br>Time : '.date("d M Y H:i a",strtotime($this->input->post("date") .' '.$this->input->post("time"))).'<br>To start <a href="'.$start_url.'">Click Here</a> <br>Meeting ID : '.$token["id"].'<br> Password : '.$random.'</p>   </td></tr></tbody></table><table style="border-spacing:0;font-family:sans-serif;color:#333333" width="100%"><tbody><tr><td style="padding-top:20px;padding-bottom:0;padding-right:20px;padding-left:20px;text-align:center"> <p style="font-family:Verdana,Tahoma,sans-serif;font-size:11px;line-height:18px;color:#939393;margin-top:5px;margin-bottom:20px;margin-right:40px;margin-left:40px"></p><p style="font-family:Verdana,Tahoma,sans-serif;font-size:11px;line-height:18px;color:#939393;margin-top:5px;margin-bottom:20px;margin-right:40px;margin-left:40px">This is an automated e-mail send from Edumia Team. <br>Please don`t reply to this e-mail.</p></td></tr></tbody></table></td></tr></tbody></table></div></center></body></html>';
                        $reciever_phone = $teacher->phone;
                        
                        $results = $this->sms_model->send_sms($message , $reciever_phone);
                        $this->email_model->do_email($message , 'Edumia - Online Class' ,$teacher->email);
                    }
                    
                }
                $this->session->set_flashdata('flash_message' , get_phrase('New meeting added successfully'));
            }
            catch(Exception $e) {
                $this->session->set_flashdata('flash_message' , get_phrase('something_went_wrong'));
                redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            }
        }
        redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
    }
    
    public function get_zoom_user(){
        $accessToken = $this->db->get_where('zoom_token' , array(
            'zoom_token_id' =>1
        ))->row()->access_token;
        
        require_once 'vendor/autoload.php';
        $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);
        $response = $client->request('GET', '/v2/users/me', [
            "headers" => [
                "Authorization" => "Bearer ".$accessToken
            ],
        ]);
        json_decode($response->getBody()->getContents(), true);
    }
    
    public function zoom_meeting_delete($param=''){
        if($param !=''){
            try {
                $this->db->where('zoom_meeting_id',$param);
                $this->db->update('meeting' , array('status' =>0)); //delete from table 
                
                $this->session->set_flashdata('flash_message' , get_phrase('Meeting deleted successfully'));
                redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            }
            catch(Exception $e) {
                $this->session->set_flashdata('flash_message' , get_phrase('something_went_wrong'));
                redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            }
        }
        else
            redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
    }
    
    public function zoom_meeting_details($param=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if($param !=''){
            $accessToken = $this->db->get_where('zoom_token' , array(
                'zoom_token_id' =>1
            ))->row()->access_token; 
            try {
                require_once 'vendor/autoload.php';
                $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);
                $response = $client->request('GET', '/v2/meetings/'.$param, [
                    "headers" => [
                        "Authorization" => "Bearer ".$accessToken
                    ],
                ]);
                $page_data['meetings'] = json_decode($response->getBody()->getContents());
                
                $page_data['page_name']  = 'zoom_meeting_details';
                $page_data['page_title'] = get_phrase('zoom_meeting_details');
                $this->load->view('backend/index', $page_data);
            }
            catch(Exception $e) {
                redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            }  
        }
    }
    
    public function zoom_meeting_invite_students($param=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if($param !=''){
            $accessToken = $this->db->get_where('zoom_token' , array(
                'zoom_token_id' =>1
            ))->row()->access_token; 
            try {
                require_once 'vendor/autoload.php';
                $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);
                $response = $client->request('GET', '/v2/meetings/'.$param, [
                    "headers" => [
                        "Authorization" => "Bearer ".$accessToken
                    ],
                ]);
                $page_data['meetings'] = json_decode($response->getBody()->getContents());
                
                $page_data['page_name']  = 'zoom_meeting_invite_students';
                $page_data['page_title'] = get_phrase('zoom_meeting_invite_students');
                $this->load->view('backend/index', $page_data);
            }
            catch(Exception $e) {
                redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            }  
        }
        else if($this->input->post('meeting_id')){
            try {
                $accessToken = $this->db->get_where('zoom_token' , array(
                'zoom_token_id' =>1
                ))->row()->access_token; 
                
                require_once 'vendor/autoload.php';
                $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);
                $response = $client->request('GET', '/v2/meetings/'.$this->input->post('meeting_id'), [
                    "headers" => [
                        "Authorization" => "Bearer ".$accessToken
                    ],
                ]);
                $message = 'Edumia is inviting you to a scheduled Zoom meeting. Topic: '.$meeting->topic.' Time: '.date('H:i a',strtotime($meeting->start_time)).' Join Zoom Meeting: '.$meeting->join_url.' Meeting ID: '.$meeting->id.' Password: '.$meeting->password;
                foreach ($this->input->post('student_id') as $id) {
                    $stud_details = $this->crud_model->get_student_info($id);   
                    if($this->input->post('msg_type') ==1){
                        if($stud_details[0]['phone'] !=''){
                            $results = $this->sms_model->send_sms( $message , $stud_details[0]['phone']); 
                        }
                        else{
                            if($stud_details[0]['email'] !='')
                                $this->email_model->do_email($message , 'Edumia - Zoom meeting' , $stud_details[0]['email']);
                        }   
                    }
                    else{
                        if($stud_details[0]['email'] !=''){
                            $this->email_model->do_email($message , 'Edumia - Zoom meeting' , $stud_details[0]['email']);
                        }
                        else{
                            if($stud_details[0]['phone'] !='')
                                $results = $this->sms_model->send_sms( $message , $stud_details[0]['phone']); 
                        }
                    }
                     
                }
                
                $this->session->set_flashdata('flash_message' , get_phrase('Invitations_sent_successfully'));
                redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            }
            catch(Exception $e) {
               $this->session->set_flashdata('flash_message' , get_phrase('something_went_wrong'));
               redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
            } 
        }
        else {
            redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
        }
    }
    
    public function zoom_meeting(){
        
        if($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $this->zoom_refresh();
            $accessToken = $this->db->get_where('zoom_token' , array(
                'zoom_token_id' =>1
            ))->row()->access_token; 
             
        
        $this->db->order_by('meeting_id','desc');
        $page_data['meetings'] = $this->db->get_where('meeting' , array(
            'status' => 1
        ))->result_array();
        $page_data['page_name']  = 'zoom_meeting';
        $page_data['page_title'] = get_phrase('zoom_meeting');
        $this->load->view('backend/index', $page_data);
    }
      
    public function zoom_refresh(){
         $accessToken = $this->db->get_where('zoom_token' , array(
            'zoom_token_id' =>1
        ))->row()->refresh_token;
        try { 
            require_once 'vendor/zoom.php';
            $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);
    
            $response = $client->request('POST', '/oauth/token', [
                "headers" => [
                    "Authorization" => "Basic ". base64_encode(CLIENT_ID.':'.CLIENT_SECRET)
                ],
                'form_params' => [
                    "grant_type" => "refresh_token",
                    "refresh_token" => $accessToken
                ],
            ]);
            
            $token = json_decode($response->getBody()->getContents(), true);
            
            $data =array();
            $data['access_token'] = $token['access_token'];
            $data['token_type'] = $token['token_type'];
            $data['refresh_token'] = $token['refresh_token'];
            $data['expires_in'] = $token['expires_in'];
            $data['scope'] = $token['scope'];
            $data['date'] = date('d-m-Y H:i:s');
            $entry = $this->db->get_where('zoom_token' , array(
            'zoom_token_id' =>1
            ))->row();
            if(isset($entry)){
                $this->db->where('zoom_token_id', 1);
                $this->db->update('zoom_token', $data);
            }
            else{
                $this->db->insert('zoom_token', $data);
            }
            
        }
        catch(Exception $e) {
            //
        } 
    }
    
    public function zoom_users(){
        
    }
    public function zoom_refresh_token() {
        $accessToken = $this->db->get_where('zoom_token' , array(
            'zoom_token_id' =>1
        ))->row()->refresh_token;
        try { 
            require_once 'vendor/zoom.php';
            $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);
    
            $response = $client->request('POST', '/oauth/token', [
                "headers" => [
                    "Authorization" => "Basic ". base64_encode(CLIENT_ID.':'.CLIENT_SECRET)
                ],
                'form_params' => [
                    "grant_type" => "refresh_token",
                    "refresh_token" => $accessToken
                ],
            ]);
            
            $token = json_decode($response->getBody()->getContents(), true);
            
            $data =array();
            $data['access_token'] = $token['access_token'];
            $data['token_type'] = $token['token_type'];
            $data['refresh_token'] = $token['refresh_token'];
            $data['expires_in'] = $token['expires_in'];
            $data['scope'] = $token['scope'];
            $data['date'] = date('d-m-Y H:i:s');
            $entry = $this->db->get_where('zoom_token' , array(
            'zoom_token_id' =>1
            ))->row();
            if(isset($entry)){
                $this->db->where('zoom_token_id', 1);
                $this->db->update('zoom_token', $data);
            }
            else{
                $this->db->insert('zoom_token', $data);
            }
            $this->session->set_flashdata('flash_message' , get_phrase('Token Updated'));
            redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
        }
        catch(Exception $e) {
            $this->session->set_flashdata('flash_message' , get_phrase('Something wrong happend'));
            redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
        }    
        
    }
    
    public function zoom_token_creation(){
        $code = $this->db->get_where('settings' , array(
            'type' => 'zoom_code'
            ))->row()->description;
            
        require_once 'vendor/zoom.php';
        $client = new GuzzleHttp\Client(['base_uri' => 'https://zoom.us']);

        $response = $client->request('POST', '/oauth/token', [
            "headers" => [
                "Authorization" => "Basic ". base64_encode(CLIENT_ID.':'.CLIENT_SECRET)
            ],
            'form_params' => [
                "grant_type" => "authorization_code",
                "code" => $code,
                "redirect_uri" => REDIRECT_URI
            ],
        ]);
        
        $token = json_decode($response->getBody()->getContents(), true);
        $details = $token;
        if(isset($token)){
            $data['access_token'] = $details['access_token'];
            $data['token_type'] = $details['token_type'];
            $data['refresh_token'] = $details['refresh_token'];
            $data['expires_in'] = $details['expires_in'];
            $data['scope'] = $details['scope'];
            $data['date'] = date('d-m-Y H:i:s');
            $entry = $this->db->get_where('zoom_token' , array(
            'zoom_token_id' =>1
            ))->row();
            if(isset($entry)){
                $this->db->where('zoom_token_id', 1);
                $this->db->update('zoom_token', $data);
            }
            else{
            $this->db->insert('zoom_token', $data);
            }
            
        }
        redirect(base_url() . 'index.php?admin/zoom_meeting' , 'refresh');
    }
    //zoom ends here
    
    //vimeo starts here
    function get_video_thumbnail(){
        require_once 'vendor/vimeo/vimeo-api/autoload.php';
                $vimeo = new Vimeo\Vimeo("ab673e8849477a7b6eb7738fbc1323d6e6347763", "O3Drrh8eMSVuTcnEMDez/bt8r5bCJwjXTDbJyyG9fAbQplKxPtC3cCy/pBJe9L92IlCwmGzLIwx5v/fM0lssjecmc4TkNqEguSDlWZcwLw6jsysgAv3yEy0Rut5HE3tW", "989886212c1c79f248ee6f602ea6c13b");
                   
                $uri = $vimeo->request(
                    '/me/videos',
                    [
                        'upload' => [
                            'approach' => 'pull',
                            'link' => 'https://edmspace.sgp1.digitaloceanspaces.com/Steps/learning-at-home-DARASUN.mov'
                        ],
                        'privacy' => [
                            'download' => "false"
                        ],
                    ],
                    'POST'
                );
        $vimeo->request($uri['body']['uri'], array(
            'name' => 'link test',
            'description' => 'link test',
        ), 'PATCH');

        require_once 'vendor/vimeo/vimeo-api/autoload.php';
        $vimeo = new Vimeo\Vimeo("ab673e8849477a7b6eb7738fbc1323d6e6347763", "O3Drrh8eMSVuTcnEMDez/bt8r5bCJwjXTDbJyyG9fAbQplKxPtC3cCy/pBJe9L92IlCwmGzLIwx5v/fM0lssjecmc4TkNqEguSDlWZcwLw6jsysgAv3yEy0Rut5HE3tW", "989886212c1c79f248ee6f602ea6c13b");
        
        $data = $this->db->get_where('video',['image' =>NULL])->result_array();
        if(isset($data)){
            try{
                foreach($data as $row){
                    $uri = $row['uri'];
                    $response = $vimeo->request($uri.'/pictures', array(), 'GET');
                    if(isset($response)){
                        if(isset($response['body']['data'][0]['sizes'][2]['link'])){
                            $this->db->where('video_id',$row['video_id']);
                            $this->db->update('video',['image' => $response['body']['data'][0]['sizes'][2]['link']]);
                        }
                    }
                }
            }
            catch(Exception $e){
                
            }
        }
    }
    function video_upload($param='', $param1='', $param2='', $param3=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if( $param=='list'){
            $page_data['videos'] = $this->db->get_where('uploaded_videos',['class_id'=>$this->input->post('class'),'section_id'=>$this->input->post('sectionid'),'subject_id'=>$this->input->post('subject'),'year'=>$this->db->get_where('settings',array('type'=>'running_year'))->row()->description])->result_array();
        }
        else if( $param=='create'){
            $data['title']  =  $this->input->post('title');
            $data['description'] =  $this->input->post('description');
            $data['class_id']  =  $this->input->post('class');
            $data['section_id'] = $this->input->post('section_id');
            $data['subject_id'] = $this->input->post('subject');
            $data['year'] = $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
            $data['timestamp'] = strtotime("now");
            //uploading file using codeigniter upload library
            $files = $_FILES['file_name'];
            $this->load->library('upload');
            $config['upload_path']   =  'uploads/video/';
            if (!is_dir('uploads/video')) {
                 mkdir('uploads/video', 0777, TRUE);
            }
            $config['allowed_types'] =  '*';
            $_FILES['file_name']['name']     = $files['name'];
            $_FILES['file_name']['type']     = $files['type'];
            $_FILES['file_name']['tmp_name'] = $files['tmp_name'];
            $_FILES['file_name']['size']     = $files['size'];
            $this->upload->initialize($config);
            $this->upload->do_upload('file_name');
            try{
                require_once 'vendor/vimeo/vimeo-api/autoload.php';
                $vimeo = new Vimeo\Vimeo("ab673e8849477a7b6eb7738fbc1323d6e6347763", "O3Drrh8eMSVuTcnEMDez/bt8r5bCJwjXTDbJyyG9fAbQplKxPtC3cCy/pBJe9L92IlCwmGzLIwx5v/fM0lssjecmc4TkNqEguSDlWZcwLw6jsysgAv3yEy0Rut5HE3tW", "989886212c1c79f248ee6f602ea6c13b");
                   
                $uri = $vimeo->request(
                    '/me/videos',
                    [
                        'upload' => [
                            'approach' => 'pull',
                            'link' => base_url().'uploads/video/'.$_FILES['file_name']['name']
                        ],
                    ],
                    'POST'
                );
                $vimeo->request($uri['body']['uri'], array(
                    'name' => $this->input->post('title'),
                    'description' => $this->input->post('description'),
                ), 'PATCH');
                
                if($uri['body']['upload']['status'] =='in_progress' || $uri['body']['upload']['status'] =='success'){
                    $data['uri'] = $uri['body']['uri'];
                    $data['vimeo_url'] = $uri['body']['link'];
                    $this->db->insert('uploaded_videos', $data);
                    $this->session->set_flashdata('flash_message' , get_phrase('video_added_successfully'));
                    redirect(base_url() . 'index.php?admin/video_upload/' , 'refresh');
                }
                else{
                    $this->session->set_flashdata('flash_message' , get_phrase('Something wrong happend'));
                }
            }
            catch(Exception $e){
                $this->session->set_flashdata('flash_message' , get_phrase('Something wrong happend'));
                redirect(base_url() . 'index.php?admin/video_upload/' , 'refresh'); 
            }
            
        }
        $page_data['page_name']  = 'video_upload';
        $page_data['page_title'] = get_phrase('videos');
        $this->load->view('backend/index', $page_data);
    }
    
    //vimeo ends here
    function get_subject($class_id='') {
          $page_data['class_id'] = $class_id; 
          $this->load->view('backend/admin/manage_subject_holder' , $page_data);
    }
    /***ADMIN DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'dashboard';
        $page_data['page_title'] = get_phrase('admin_dashboard');
        $this->load->view('backend/index', $page_data);
    }
    
    //Krish-Leave requests
    function leave_requests(){
     
        $page_data['page_name']  = 'leave_requests';
        $page_data['page_title'] = get_phrase('leave_requests');
        $this->load->view('backend/index', $page_data);
    }
    function fines($param1 = '',$param2 = ''){
        
        if($this->input->post('fine') !=''){
            $data['fine'] = $this->input->post('amount');
            $data['type'] = $this->input->post('fine');
            $data['timestamp'] = strtotime(date('d-m-Y'));
            $this->db->insert('fine', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('fine_added_successfully'));
            redirect(base_url() . 'index.php?admin/fines/' , 'refresh');
        }
        if($param1 == 'delete'){
            $this->db->where('fine_id', $param2);
            $this->db->delete('fine');
            $this->session->set_flashdata('flash_message' , get_phrase('fine_deleted_successfully'));
            redirect(base_url() . 'index.php?admin/fines/' , 'refresh');
        }
        $this->db->order_by('fine_id','DESC');
        $page_data['fines'] = $this->db->get('fine')->result_array();
        $page_data['page_name']  = 'fines';
        $page_data['page_title'] = get_phrase('fines');
        $this->load->view('backend/index', $page_data);
    }
    function transaction_report(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
            ))->row()->description;
            $newdata =  array();
        if($this->input->post('method')){
            $date  = $this->input->post('start_timestamp');
            $end_date  = $this->input->post('end_timestamp');
            $i=0;
            while (strtotime($date) <= strtotime($end_date)) {
                $date = date ("d-m-Y", strtotime($date));
                
                $amount = 0;
                $this->db->select_sum('amount');
                $this->db->where('year' , $running_year);
                $this->db->where(['method' => $this->input->post('method'),'payment_type' => 'income']);
                $this->db->where('timestamp =',strtotime($date) );
                $amount = $this->db->get('payment')->row()->amount;
                $this->db->select_sum('amount');
                $this->db->where('year' , $running_year);
                $this->db->where(['method' => $this->input->post('method'),'payment_type' => 'expense']);
                $this->db->where('timestamp =',strtotime($date) );
                $expense = $this->db->get('payment')->row()->amount;
                if(isset($amount) || isset($expense)){
                    $newdata[$i]['income'] = $amount;
                    $newdata[$i]['expense'] = $expense;
                    $newdata[$i]['profit'] = $amount - $expense;
                    $newdata[$i]['date'] = $date;
                    $i=$i+1;
                }
                $date = date ("d-m-Y", strtotime("+1 day", strtotime($date)));
	        }
	        $page_data['expense_details']  = $newdata;
	       $page_data['method']  = $this->input->post('method');
        }
        if($this->input->post('start_timestamp') !=''){
          $page_data['start_date']  = $this->input->post('start_timestamp');
          $page_data['end_date']  = $this->input->post('end_timestamp');
          $income_category = $this->db->get('income_category')->result_array();
          $income= array();
          $grandTotal = 0;
        
          foreach($income_category as $key=>$category){ 
              $amount =0;$income[$key]['total']=0;
            $income[$key]['name'] =  $category['name'];  
            $this->db->select('invoice_student_master.invoice_id,invoice_student_master.amount,invoice_student_master.due');
            
            $this->db->join('invoice', 'invoice.invoice_id = invoice_student_master.invoice_id');
            $this->db->join('payment', 'payment.invoice_id = invoice.invoice_id');
            $this->db->where('invoice_student_master.income_category_id', $category['income_category_id']);
            $this->db->where('payment.timestamp <=',strtotime($this->input->post('end_timestamp')) );
           $this->db->where('payment.timestamp >=', strtotime($this->input->post('start_timestamp')));
           $this->db->group_by('invoice_student_master.invoice_master_id');
            $amounts = $this->db->get('invoice_student_master')->result_array();
            foreach($amounts as $amount){
                $income[$key]['total'] +=  $amount['amount'] - $amount['due'];
            }
            
            //$income[$key]['total'] =  $amount->amount_paid; 

            $grandTotal += $income[$key]['total'];
            
           }
           $page_data['income'] = $income;
           $page_data['grandTotal']  = $grandTotal;
           $expense_category = $this->db->get('expense_category')->result_array();
          $expense= array();
          $expenseTotal = 0;
          foreach($expense_category as $key=>$expen){ 
            $expense[$key]['name'] =  $expen['name'];  
            
            $this->db->select_sum('amount');
            $this->db->where('year' , $running_year);
            $this->db->where('expense_category_id', $expen['expense_category_id']);
            $this->db->where('timestamp <=',strtotime($this->input->post('end_timestamp')) );
            $this->db->where('timestamp >=', strtotime($this->input->post('start_timestamp')));
            $amount = $this->db->get('payment')->row();
            $expense[$key]['total'] =  $amount->amount;   
            $expenseTotal += $expense[$key]['total'];
           }
           $page_data['expense']  = $expense;
           $page_data['expenseTotal']  = $expenseTotal;
        }
        $page_data['page_name']  = 'transactional_report';
        $page_data['page_title'] = get_phrase('transactional_report');
        $this->load->view('backend/index', $page_data);
    }
    function categorized_report(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
       if($this->input->post('income_category_id') !=''){
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        $this->db->where('invoice.year' , $running_year);
        $this->db->join('enroll', 'invoice.student_id = enroll.student_id'); 
        $this->db->join('student', 'invoice.student_id = student.student_id'); 
        $this->db->join('invoice_student_master', 'invoice.invoice_id = invoice_student_master.invoice_id');
        $this->db->where('income_category_id' , $this->input->post('income_category_id'));
    $this->db->order_by('invoice.creation_timestamp', 'desc');
    $this->db->group_by('invoice.invoice_id');
        $page_data['invoices'] = $this->db->get('invoice')->result_array();

        $this->db->join('enroll', 'payment.student_id = enroll.student_id'); 
        $this->db->join('student', 'payment.student_id = student.student_id'); 
    $this->db->where('payment_type' , 'income');
    $this->db->order_by('timestamp' , 'desc');
        $this->db->where('income_category_id' , $this->input->post('income_category_id'));
        $this->db->join('invoice_student_master', 'payment.invoice_id = invoice_student_master.invoice_id');
    $page_data['payments'] = $this->db->get('payment')->result_array();
        $page_data['income_id'] = $this->input->post('income_category_id');
        }
        $page_data['page_name']  = 'categorized_report';
        $page_data['page_title'] = get_phrase('category_based_report');
        $this->load->view('backend/index', $page_data);
    }
    function expense_report(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
       if($this->input->post('expense_category_id') !=''){
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        
        $this->db->where('year' , $running_year);
    $this->db->order_by('timestamp' , 'desc');
        $this->db->where('expense_category_id' , $this->input->post('expense_category_id'));
    $page_data['invoices'] = $this->db->get('payment')->result_array();
        $page_data['expense_id'] = $this->input->post('expense_category_id');
        }
        $page_data['page_name']  = 'expense_report';
        $page_data['page_title'] = get_phrase('expense_report');
        $this->load->view('backend/index', $page_data);
    }
    function other_income_category_report(){
       if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

       if($this->input->post('other_income_category_id') !=''){
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        
        $this->db->where('year' , $running_year);
    $this->db->order_by('timestamp' , 'desc');
        $this->db->where('other_income_category_id' , $this->input->post('other_income_category_id'));
    $page_data['invoices'] = $this->db->get('other_income')->result_array();
        $page_data['income_id'] = $this->input->post('other_income_category_id');
        }
        $page_data['page_name']  = 'other_income_category_report';
        $page_data['page_title'] = get_phrase('other_income_category_report');
        $this->load->view('backend/index', $page_data);
    }
    public function due_list(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
            ))->row()->description;
        if($this->input->post('section_id')!='' && $this->input->post('class_id')){
            $this->db->where(['enroll.section_id' => $this->input->post('section_id'),'enroll.class_id' =>$this->input->post('class_id'),'enroll.year' => $running_year]);
            $this->db->where('invoice.due >',0);
            $this->db->join('enroll', 'invoice.student_id = enroll.student_id'); 
            $this->db->join('student', 'invoice.student_id = student.student_id');
            $this->db->order_by('invoice.creation_timestamp', 'desc');
            $this->db->group_by('invoice.invoice_id');
            $page_data['data'] = $this->db->get('invoice')->result_array();
            $page_data['class_id'] = $this->input->post('class_id');
            $page_data['section_id'] = $this->input->post('section_id');
        }
        $page_data['page_name']  = 'due_list';
        $page_data['page_title'] = get_phrase('fee_due_list');
        $this->load->view('backend/index', $page_data);
    }
//krish
       function log(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

            $page_data['page_name']  = 'log';
            $page_data['page_title'] = get_phrase('log');
            $this->load->view('backend/index', $page_data);
       }
        function login_details(){
            if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

            $page_data['page_name']  = 'login_details';
            $page_data['page_title'] = get_phrase('login_details');
            $this->load->view('backend/index', $page_data);
       }
    function student_filter()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $blood_group = $this->input->post('blood_group');
        $father_name = $this->input->post('father_name');
        $phone_number = $this->input->post('phone_number');
        $student_name = $this->input->post('student_name');
        $admission_number = $this->input->post('admission_number');
        if(isset($blood_group) || isset($father_name) || isset($phone_number))
        {
            if(!empty($blood_group))
            {
                $type='blood';
                $check=array('blood_group'=>$blood_group);
            }
            else if(!empty($father_name))
            {
                $type='father';
                $check=array('father_name'=>$father_name);
            }
            else if(!empty($student_name))
            {
                $type='father';
                $check=array('name'=>$student_name);
            }
            else if(!empty($admission_number))
            {
                $type='father';
                $check=array('admission_no'=>$admission_number);
            }
            else
            {
                $type='phone';
               $check=array('phone'=>$phone_number); 
            }
           
           $students   =$this->db->get_where('student',$check)->result_array();
           $page_data['students'] =$students;
           $page_data['type']=$check;
                            
        }
        $page_data['page_name'] = 'student_filter';
        $page_data['page_title'] = get_phrase('student_filter');
        $this->load->view('backend/index', $page_data);
    }
    function student_filter_print()
    {
        $type=$this->input->post('type');
        $name=$this->input->post('name');
        $check=array($type=>$name);
        
        $students   =$this->db->get_where('student',$check)->result_array();
        $page_data['students'] =$students;
        $this->load->view('backend/admin/student_fiter_print', $page_data);
    }
//krish
    function question_papers($param1 = '',$param2='')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if($this->input->post('title') !=''){
            $data['title']= $this->input->post('title');
            $data['subject_id'] =   $this->input->post('subject_id');
            $data['class_id'] =   $this->input->post('class');
            $data['section_id']= $this->input->post('section_id');
            $data['chapter_id']= $this->input->post('chapter_id');
            //uploading file using codeigniter upload library
            $files = $_FILES['file_name'];
            $this->load->library('upload');
            $config['upload_path']   =  'uploads/question_papers/';
            $config['allowed_types'] =  '*';
            $_FILES['file_name']['name']     = $files['name'];
            $_FILES['file_name']['type']     = $files['type'];
            $_FILES['file_name']['tmp_name'] = $files['tmp_name'];
            $_FILES['file_name']['size']     = $files['size'];
            $this->upload->initialize($config);
            $this->upload->do_upload('file_name');
    
            $data['file'] = $_FILES['file_name']['name'];
            $data['year']=   $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
            $data['timestamp']=   strtotime(date("Y-m-d H:i:s"));
            if($this->input->post('section_id') !=0){
                $this->db->insert('question_paper' , $data);
            }
            else{
                $sections = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
                if(isset($sections)){
                    foreach($sections as $row){
                        $data['section_id'] = $row['section_id'];
                        $this->db->insert('question_paper' , $data);
                    }
                }
            }
            
            $this->session->set_flashdata('flash_message' , get_phrase('question_paper_uploaded'));
            redirect(base_url() . 'index.php?admin/question_papers/' , 'refresh');
        }
        else if($param1 == 'delete'){
            $this->db->where('question_paper_id', $param2);
            $this->db->delete('question_paper');
            $this->session->set_flashdata('flash_message' , get_phrase('question_paper_deleted'));
            redirect(base_url() . 'index.php?admin/question_papers', 'refresh');
        }
        elseif($param1 =='filter' && $this->input->post('class') !=0){
            if($this->input->post('class') !=0){
                    $data['class_id']=$this->input->post('class');
                if($this->input->post('section_id') !=0)
                    $data['section_id']=$this->input->post('section_id');
                if($this->input->post('subject_id') !=0 && $this->input->post('subject_id') !='')
                    $data['subject_id']=$this->input->post('subject_id');
                if($this->input->post('chapter_id') !=0 && $this->input->post('chapter_id') !='')
                    $data['chapter_id']=$this->input->post('chapter_id');
                $this->db->where($data);
                $this->db->order_by('question_paper_id','desc');
                $page_data['papers'] = $this->db->get_where('question_paper')->result_array(); 
            $page_data['class_id'] = $this->input->post('class');
            $page_data['section_id'] = $this->input->post('section_id');
            $page_data['sections'] = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
            if($this->input->post('subject_id') !='' && $this->input->post('subject_id') !=0)
                $page_data['subject_id'] = $this->input->post('subject_id');
            $page_data['subjects'] = $this->db->get_where('subject',['class_id'=>$this->input->post('class')])->result_array();
        
            if($this->input->post('chapter_id') !='' && $this->input->post('chapter_id') !=0)
                $page_data['chapter_id'] = $this->input->post('chapter_id');
            $page_data['chapters'] = $this->db->get_where('chapter',$data)->result_array();
                
            }
        }
        else{
            $this->db->order_by('question_paper_id','desc');
            $page_data['papers'] = $this->db->get('question_paper')->result_array();
        }
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;    
        $page_data['page_name']  = 'question_papers';
        $page_data['page_title'] = get_phrase('question_papers');
        $this->load->view('backend/index', $page_data);
    }
    function lecture_notes($param1 = '',$param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if($this->input->post('title') !=''){
            $data['title']= $this->input->post('title');
            $data['description'] = $this->input->post('description');
            $data['subject_id'] =   $this->input->post('subject_id');
            $data['class_id'] =   $this->input->post('class');
            $data['section_id']= $this->input->post('section_id');
            $data['chapter_id']= $this->input->post('chapter_id');
            //uploading file using codeigniter upload library
            $files = $_FILES['file_name'];
            $this->load->library('upload');
            $config['upload_path']   =  'uploads/lecture_notes/';
            $config['allowed_types'] =  '*';
            $_FILES['file_name']['name']     = $files['name'];
            $_FILES['file_name']['type']     = $files['type'];
            $_FILES['file_name']['tmp_name'] = $files['tmp_name'];
            $_FILES['file_name']['size']     = $files['size'];
            $this->upload->initialize($config);
            $this->upload->do_upload('file_name');
    
            $data['file'] = $_FILES['file_name']['name'];
            $data['year']=   $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
            $data['timestamp']=   strtotime(date("Y-m-d H:i:s"));
            if($this->input->post('section_id') !=0){
                $this->db->insert('notes' , $data);
            }
            else{
                $sections = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
                if(isset($sections)){
                    foreach($sections as $row){
                        $data['section_id'] = $row['section_id'];
                        $this->db->insert('notes' , $data);
                    }
                }
            }
            
            $this->session->set_flashdata('flash_message' , get_phrase('lecture_note_uploaded'));
            redirect(base_url() . 'index.php?admin/lecture_notes/' , 'refresh');
        }
        elseif($param1 == 'delete'){
            $this->db->where('notes_id', $param2);
            $this->db->delete('notes');
            $this->session->set_flashdata('flash_message' , get_phrase('lecture_note_deleted'));
            redirect(base_url() . 'index.php?admin/lecture_notes', 'refresh');
        }
        elseif($param1 =='filter' && $this->input->post('class') !=0){
            if($this->input->post('class') !=0){
                    $data['class_id']=$this->input->post('class');
                if($this->input->post('section_id') !=0)
                    $data['section_id']=$this->input->post('section_id');
                if($this->input->post('subject_id') !=0 && $this->input->post('subject_id') !='')
                    $data['subject_id']=$this->input->post('subject_id');
                if($this->input->post('chapter_id') !=0 && $this->input->post('chapter_id') !='')
                    $data['chapter_id']=$this->input->post('chapter_id');
                $this->db->where($data);
                $this->db->order_by('notes_id','desc');
                $page_data['notes'] = $this->db->get_where('notes')->result_array(); 
            $page_data['class_id'] = $this->input->post('class');
            $page_data['section_id'] = $this->input->post('section_id');
            $page_data['sections'] = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
            if($this->input->post('subject_id') !='' && $this->input->post('subject_id') !=0)
                $page_data['subject_id'] = $this->input->post('subject_id');
            $page_data['subjects'] = $this->db->get_where('subject',['class_id'=>$this->input->post('class')])->result_array();
        
            if($this->input->post('chapter_id') !='' && $this->input->post('chapter_id') !=0)
                $page_data['chapter_id'] = $this->input->post('chapter_id');
            $page_data['chapters'] = $this->db->get_where('chapter',$data)->result_array();
                
            }
        }
        else{
            $this->db->order_by('notes_id','desc');
            $page_data['notes'] = $this->db->get('notes')->result_array();
        }
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;       
        $page_data['page_name']  = 'lecture_notes';
        $page_data['page_title'] = get_phrase('lecture_notes');
        $this->load->view('backend/index', $page_data);
    }
    function delete_lecture_videos(){ // from folder
        date_default_timezone_set('Asia/Kolkata');
        $last_min = strtotime(date('Y-m-d H:i:s'));
        $files = array_diff(scandir(FCPATH .'uploads/video/'), array('.', '..'));

        foreach ($files as $file) {
            if (file_exists('uploads/video/'.$file)) {
                $filetime = strtotime(date ("Y-m-d H:i:s", filemtime('uploads/video/'.$file)));
                $difference = $last_min - $filetime;
                if($difference/60 >30)
                    unlink('uploads/video/'.$file); 
            }
        }
    }
    
    function videos($param1='',$param2=''){

        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
            
        $this->db->where('schedule_status',1); 
        $video1 = $this->db->get('video')->result_array();
        if(isset($video1) && count($video1)>0){
            $current_date = date('Y-m-d H:i');
            foreach($video1 as $row){
                $date = date('Y-m-d H:i',strtotime($row['scheduled_time']));
                if($date <= $current_date){
                    $data1['schedule_status'] = 0;
                    $this->db->where('video_id', $row['video_id']);
                    $this->db->update('video', $data1);
                }
            }
        }
            
        if($param1=='create'){
           
            $data['title']  =  $this->input->post('title');
            $data['description'] =  $this->input->post('description');
            $data['class_id']  =  $this->input->post('class');
            $data['section_id'] = $this->input->post('section_id');
            $data['subject_id'] = $this->input->post('subject_id');
            $data['chapter_id'] = $this->input->post('chapter_id');
            $data['year'] = $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
            $data['timestamp'] = strtotime("now");
            $data['schedule_status'] = $this->input->post('schedule');
            if($this->input->post('schedule') ==1)
                $data['scheduled_time'] = $this->input->post('schedule_date');
            
        //digitalocean upload
        //$files = file_get_contents($_FILES['file_name']['tmp_name']);
        $file = $_FILES["file_name"]['tmp_name'];
        
        $system_name = $this->db->get_where('settings' , array('type'=>'system_name'))->row()->description;
        require_once 'vendor/space.php';

        $client = new Aws\S3\S3Client([
                'version' => 'latest',
                'region'  => region,
                'endpoint' => endpoint,
                'credentials' => [
                        'key'    => key,
                        'secret' => secret,
                    ],
        ]);
        
        $data1= $client->putObject([
             'Bucket' => $system_name,
             'Key'    => $_FILES["file_name"]["name"],
             'SourceFile' => $file,
             'ContentType'=>'video/mp4',
             'ACL'    => 'public-read',
        ]);
            if(isset($data1) && $data1['@metadata']['statusCode'] ==200){
                try{
                    require_once 'vendor/vimeo/vimeo-api/autoload.php';
                    $vimeo = new Vimeo\Vimeo("ab673e8849477a7b6eb7738fbc1323d6e6347763", "O3Drrh8eMSVuTcnEMDez/bt8r5bCJwjXTDbJyyG9fAbQplKxPtC3cCy/pBJe9L92IlCwmGzLIwx5v/fM0lssjecmc4TkNqEguSDlWZcwLw6jsysgAv3yEy0Rut5HE3tW", "989886212c1c79f248ee6f602ea6c13b");
                    $folder_name = $this->db->get_where('settings' , array('type'=>'v_folder'))->row()->description;
                    if($folder_name==''){
                        $folder_uri = $vimeo->request(
                            '/me/projects',
                            [
                                
                                'name' => $system_name,
                            ],
                            'POST'
                        ); 
                        $response['description'] = $folder_uri['body']['uri'];
                        $this->db->where('type' , 'v_folder');
                        $this->db->update('settings' , $response);
                        $folder_name = $folder_uri['body']['uri'];
                    }
                    $uri = $vimeo->request(
                        '/me/videos',
                        [
                            'upload' => [
                                'approach' => 'pull',
                                'link' => $data1['@metadata']['effectiveUri']
                            ],
                            'privacy' => [
                                'view' => 'disable',
                                'download' => 'false',
                                'comments'=>'nobody',
                                'add'=>'0',
                            ],
                        ],
                        'POST'
                    );
                    $vimeo->request($uri['body']['uri'], array(
                        'name' => $this->input->post('title'),
                        'description' => $this->input->post('description'),
                    ), 'PATCH');
                    $vimeo->request($folder_name.''.$uri['body']['uri'], array(
                        'name' => $this->input->post('title'),
                        'description' => $this->input->post('description'),
                    ), 'PUT');
                    if($uri['body']['upload']['status'] =='in_progress' || $uri['body']['upload']['status'] =='success'){
                        $data['uri'] = $uri['body']['uri'];
                        $data['url'] = $uri['body']['link'];
                        if($this->input->post('section_id') !=0){
                            $this->db->insert('video', $data);
                        }
                        else{
                            $sections = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
                            if(isset($sections)){
                                foreach($sections as $row){
                                    $data['section_id'] = $row['section_id'];
                                    $this->db->insert('video', $data);
                                }
                            }
                        }
                        $this->session->set_flashdata('flash_message' , get_phrase('video_added_successfully'));
                        redirect(base_url() . 'index.php?admin/videos/' , 'refresh');
                    }
                    else{
                        $this->session->set_flashdata('flash_message' , get_phrase('Something wrong happend'));
                    }
                }
                catch(Exception $e){
                    $this->session->set_flashdata('flash_message' , get_phrase('Something wrong happend'));
                    redirect(base_url() . 'index.php?admin/videos/' , 'refresh'); 
                }
                
            }
        }
        elseif($param1 =='delete'){
            $this->db->where('video_id', $param2);
            $this->db->delete('video');
            $this->session->set_flashdata('flash_message' , get_phrase('video_deleted'));
            redirect(base_url() . 'index.php?admin/videos', 'refresh');
        }
        elseif($param1 =='do_share'){
            if($this->input->post('sections')){
                $this->db->where('video_id', $param2);
                $video = $this->db->get('video')->row();
                if(isset($video)){
                    $data = array();
                    $data['title']  =  $video->title;
                    $data['description'] =  $video->description;
                    $data['class_id']  =  $this->input->post('class');
                    $data['subject_id'] = $this->input->post('subject_id');
                    $data['chapter_id'] = $this->input->post('chapter_id');
                    $data['year'] = $video->year;
                    $data['timestamp'] = strtotime("now");
                    $data['uri'] = $video->uri;
                    $data['url'] = $video->url;
                    $data['image'] = $video->image;
                    $data['schedule_status'] = $video->schedule_status;
                    $data['scheduled_time'] = $video->scheduled_time;
                    foreach($this->input->post('sections') as $sec){
                        $data['section_id'] = $sec;
                        $this->db->insert('video', $data);
                    }
                }
                $this->session->set_flashdata('flash_message' , get_phrase('Shared successfully'));
                redirect(base_url() . 'index.php?admin/videos' , 'refresh'); 
            }
            else{
                $this->session->set_flashdata('flash_message' , get_phrase('Something wrong happend'));
                redirect(base_url() . 'index.php?admin/videos' , 'refresh'); 
            }
        }
        elseif($param1 =='do_update'){
            $this->db->where('video_id', $param2);
            $video = $this->db->get('video')->row();
            if(isset($video)){
                $data = array();
                $data1['title']  =  $this->input->post('title');
                $data1['description'] =  $this->input->post('description');
                $data1['chapter_id'] = $this->input->post('chapter_id');
                $data1['schedule_status'] = $this->input->post('scheduled');
                if($this->input->post('scheduled') ==1)
                    $data1['scheduled_time'] = $this->input->post('schedule_date');
                else
                    $data1['scheduled_time'] = '';
                $this->db->where('video_id', $param2);
                $this->db->update('video', $data1);
            }
            $this->session->set_flashdata('flash_message' , get_phrase('Updated successfully'));
            redirect(base_url() . 'index.php?admin/videos' , 'refresh'); 
            
        }
        elseif($param1 =='filter' && $this->input->post('class') !=0){
            if($this->input->post('class') !=0){
                        $data['class_id']=$this->input->post('class');
                    if($this->input->post('section_id') !=0)
                        $data['section_id']=$this->input->post('section_id');
                    if($this->input->post('subject_id') !=0 && $this->input->post('subject_id') !='')
                        $data['subject_id']=$this->input->post('subject_id');
                    if($this->input->post('chapter_id') !=0 && $this->input->post('chapter_id') !='')
                        $data['chapter_id']=$this->input->post('chapter_id');
                    $this->db->where($data);
                    $this->db->order_by('video_id','desc');
                    $page_data['videos'] = $this->db->get_where('video')->result_array(); 
                $page_data['class_id'] = $this->input->post('class');
                $page_data['section_id'] = $this->input->post('section_id');
                $page_data['sections'] = $this->db->get_where('section',['class_id'=>$this->input->post('class')])->result_array();
                if($this->input->post('subject_id') !='' && $this->input->post('subject_id') !=0)
                    $page_data['subject_id'] = $this->input->post('subject_id');
                $page_data['subjects'] = $this->db->get_where('subject',['class_id'=>$this->input->post('class')])->result_array();
            
                if($this->input->post('chapter_id') !='' && $this->input->post('chapter_id') !=0)
                    $page_data['chapter_id'] = $this->input->post('chapter_id');
                $page_data['chapters'] = $this->db->get_where('chapter',$data)->result_array();
                
            }
        }
        else{
            $this->db->order_by('video_id','desc');
            $page_data['videos'] = $this->db->get_where('video')->result_array(); 
        }
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description; 
        $page_data['page_name']  = 'videos';
        $page_data['page_title'] = get_phrase('videos');
        $this->load->view('backend/index', $page_data);
    }
    function get_subjects(){
        $data['class_id']=$this->input->post('class_id');
        echo (json_encode($this->db->get_where('subject', $data)->result()));
    }
    function get_chapters(){
        if(!is_array($this->input->post('section_id')))
            $this->db->where('section_id',$this->input->post('section_id'));
        else
            $this->db->where_in('section_id',$this->input->post('section_id'));
        $this->db->where('class_id',$this->input->post('class_id'));
        $this->db->where('subject_id',$this->input->post('subject_id'));
        echo (json_encode($this->db->get('chapter')->result()));
    }
    /****MANAGE STUDENTS CLASSWISE*****/
    function student_add()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
            
        $page_data['page_name']  = 'student_add';
        $page_data['page_title'] = get_phrase('add_student');
        $this->load->view('backend/index', $page_data);
    }
    
    function student_bulk_add($param1 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if($param1 == 'add_bulk_student') {

            $names     = $this->input->post('name');
            $rolls     = $this->input->post('roll');
            $emails    = $this->input->post('email');
            $passwords = $this->input->post('password');
            $phones    = $this->input->post('phone');
            $addresses = $this->input->post('address');
            $genders   = $this->input->post('sex');

            $student_entries = sizeof($names);
            for($i = 0; $i < $student_entries; $i++) {
                $data['name']     =   $names[$i];
                $data['email']    =   $emails[$i];
                $data['password'] =   sha1($passwords[$i]);
                $data['phone']    =   $phones[$i];
                $data['address']  =   $addresses[$i];
                $data['sex']      =   $genders[$i];

                //validate here, if the row(name, email, password) is empty or not 
                if($data['name'] == '' || $data['email'] == '' || $data['password'] == '')
                    continue;

                $this->db->insert('student' , $data);
                $student_id = $this->db->insert_id();

                $data2['enroll_code']   =   substr(md5(rand(0, 1000000)), 0, 7);
                $data2['student_id']    =   $student_id;
                $data2['class_id']      =   $this->input->post('class_id');
                if($this->input->post('section_id') != '') {
                    $data2['section_id']    =   $this->input->post('section_id');
                }
                $data2['roll']          =   $rolls[$i];
                $data2['date_added']    =   strtotime(date("Y-m-d H:i:s"));
                $data2['year']          =   $this->db->get_where('settings' , array(
                                                'type' => 'running_year'
                                            ))->row()->description;

                $this->db->insert('enroll' , $data2);

            }
            $this->session->set_flashdata('flash_message' , get_phrase('students_added'));
            redirect(base_url() . 'index.php?admin/student_information/' . $this->input->post('class_id') , 'refresh');
        }           

        $page_data['page_name']  = 'student_bulk_add';
        $page_data['page_title'] = get_phrase('add_bulk_student');
        $this->load->view('backend/index', $page_data);
    }

    function get_sections($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/admin/student_bulk_add_sections' , $page_data);
    }
    function get_promotion_sections($class_id,$student_id)
    {
        $page_data['class_id'] = $class_id;
        $page_data['student_id'] = $student_id;
        $this->load->view('backend/admin/student_bulk_add_promotion_sections' , $page_data);
    }
    
    public function student_phone_numbers(){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
            ))->row()->description;
        if($this->input->post('section_id')!=''){
            $this->db->select('student.name as name,student.phone as phone,student.student_id,student.parent_id,student.admission_no,student.mother_phone');
            $this->db->group_by('student.student_id');
            $this->db->where(['enroll.section_id' => $this->input->post('section_id'),'enroll.class_id' =>$this->input->post('class_id'),'enroll.year' => $running_year]);
            $this->db->join('enroll', 'enroll.student_id = student.student_id');
            $page_data['section_id']  = $this->input->post('section_id');
            $page_data['class_id']  = $this->input->post('class_id');
            $page_data['data']  = $this->db->get('student')->result_array();
        }
        $page_data['page_name']  = 'student_phone_numbers';
        $page_data['page_title'] = get_phrase('phone_numbers');
        $this->load->view('backend/index', $page_data);
    }
   //Krish
    function help_page($param1 = '',$param2 = ''){
    if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
    if ($param1 == 'create') {
        $data['name']   = $this->input->post('name');
            $data['designation']   = $this->input->post('designation');
            $data['mob_number']     = $this->input->post('number');
            $data['type']     = 2;
            $this->db->insert('help_table', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added successfully'));
            redirect(base_url() . 'index.php?admin/help_page', 'refresh');
   }
   if ($param1 == 'delete') {
            $this->db->where('id', $param2);
            $this->db->delete('help_table');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/help_page', 'refresh');
   }
    $page_data['dNumbers']      = $this->db->get_where('help_table',['type' => 2])->result_array();
    $page_data['admin_numbers']      = $this->db->get_where('help_table',['type' =>1])->result_array();
    $page_data['page_name']  = 'help_page';
    $this->load->view('backend/index', $page_data);
    }
    function pending_student($class_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
            
        $page_data['page_name']     = 'pending_student';
        $page_data['page_title']    = get_phrase('pending_student'). " - ".get_phrase('class')." : ".
                                            $this->crud_model->get_class_name($class_id);
        $page_data['class_id']  = $class_id;
        $this->load->view('backend/index', $page_data);
    }
     /***Krish***/
    
    function student_information($class_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
            
        $page_data['page_name']     = 'student_information';
        $page_data['page_title']    = get_phrase('student_information'). " - ".get_phrase('class')." : ".
                                            $this->crud_model->get_class_name($class_id);
        $page_data['class_id']  = $class_id;
        $this->load->view('backend/index', $page_data);
    }
    function student_export($class_id)
    {
        $section_id = $this->input->post('section_id');
        if(isset($section_id))
        {
            $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
            ))->row()->description;
            if($section_id != 'all')
            {
                // $students   = $this->db->join('student','student.student_id = enroll.student_id');
                // $this->db->get_where('enroll' , array(
                // 'class_id'=>$class_id , 'section_id' => $section_id , 'year' => $running_year,'status'=>1
                // ))->result_array();
                $students   =$this->db->select()->from('enroll')->join('student','student.student_id = enroll.student_id')->where('class_id',$class_id)->where('year',$running_year)->where('enroll.status',1)->where('section_id',$section_id)->order_by('roll')->group_by('enroll.student_id')->get()->result_array();
            }
            else
            {
                $students   =$this->db->select()->from('enroll')->join('student','student.student_id = enroll.student_id')->where('class_id',$class_id)->where('year',$running_year)->where('enroll.status',1)->order_by('roll')->group_by('enroll.student_id')->get()->result_array();
            }
            // output headers so that the file is downloaded rather than displayed
            header('Content-Type: text/csv; charset=utf-8');
            header('Content-Disposition: attachment; filename=data.csv');
            
            // create a file pointer connected to the output stream
            $output = fopen('php://output', 'w');
            
            // output the column headings
            fputcsv($output, array('admission_no', 'roll', 'photo', 'name', 'address', 'phone', 'date of birth', 'gender','religion','caste', 'religion category', 'blood group', 'father name', 'mother name', 'mother phone','aadhar','email'));
            
            foreach($students as $row)
            {
               $img=$this->crud_model->get_image_url('student',$row['student_id']); 
              fputcsv($output, array($row['admission_no'], $row['roll'], $img, $row['name'], $row['address'], $row['phone'], $row['birthday'], $row['sex'],$row['religion'], $row['caste'], $row['religion_category'], $row['blood_group'], $row['father_name'], $row['mother_name'], $row['mother_phone'],$row['aadhar'],$row['email']));  
            }
             redirect(base_url() . 'index.php?admin/student_export/'.$class_id, 'refresh');
        }
        $page_data['page_name']     = 'student_export';
        $page_data['page_title']    = get_phrase('student_export'). " - ".get_phrase('class')." : ".
                                            $this->crud_model->get_class_name($class_id);
        $page_data['class_id']  = $class_id;
        $this->load->view('backend/index', $page_data);
    
    }
    function student_marksheet($student_id = '') {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $class_id     = $this->db->get_where('enroll' , array(
            'student_id' => $student_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->row()->class_id;
        $student_name = $this->db->get_where('student' , array('student_id' => $student_id))->row()->name;
        $class_name   = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
        $page_data['page_name']  =   'student_marksheet';
        $page_data['page_title'] =   get_phrase('marksheet_for') . ' ' . $student_name . ' (' . get_phrase('class') . ' ' . $class_name . ')';
        $page_data['student_id'] =   $student_id;
        $page_data['class_id']   =   $class_id;
        $this->load->view('backend/index', $page_data);
    }
function attendance_report_separate_print_view($class_id ='' , $section_id = '' , $month = '') {
         if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['class_id'] = $class_id;
        $page_data['section_id']  = $section_id;
        $page_data['sessionId'] = $this->input->post('sessId');
        $page_data['month'] = $month;
        $this->load->view('backend/admin/attendance_report_separate_print_view' , $page_data);
    }
function  attendance_settings(){
$page_data['page_name']  =   'attendance_settings';
$this->load->view('backend/index', $page_data);
    }
    function student_marksheet_print_view($student_id , $exam_id) {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $class_id     = $this->db->get_where('enroll' , array(
            'student_id' => $student_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->row()->class_id;
        $class_name   = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;

        $page_data['student_id'] =   $student_id;
        $page_data['class_id']   =   $class_id;
        $page_data['exam_id']    =   $exam_id;
        $this->load->view('backend/admin/student_marksheet_print_view', $page_data);
    }
    //Krish
    //*new function
    function get_parent_details(){
        $data = $this->db->get_where('parent' , array('parent_id' => $this->input->post('pid')))->result_array();
        echo (json_encode($data));
    }
    function student($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        if ($param1 == 'create') {
            $data['name']           = $this->input->post('name');
            $data['birthday']       = $this->input->post('birthday');
            $data['sex']            = $this->input->post('sex');
            //*new change
            $data['address']        = $this->input->post('address');
            
            //end change
            $data['father_name']          = $this->input->post('father_name');
            $data['father_id']          = $this->input->post('father_id');
            $data['phone']          = $this->input->post('phone');
            $data['mother_name']          = $this->input->post('mother_name');
            $data['mother_id']          = $this->input->post('mother_id');
            $data['mother_phone']          = $this->input->post('mother_phone');
            $data['national_id']          = $this->input->post('national_id');
            
            $data['nationality']          = $this->input->post('nation');
            $data['email']          = $this->input->post('email');
            if($this->input->post('username') == 1)
             $data['user_name']          = $this->input->post('admission'); 
            else
              $data['user_name']          = $this->input->post('phone');      
            $data['admission_no']          = $this->input->post('admission');
            $data['password']       = sha1($this->input->post('password'));
            $data['parent_id']      = $this->input->post('parent_id');
            $data['dormitory_id']  = $this->input->post('dormitory_id');
            $this->db->insert('student', $data);
            $student_id = $this->db->insert_id();
            foreach($this->input->post('transport_id') as $value){
               $data1['student_id'] = $student_id;
               $data1['transport_id'] = $value;
               $this->db->insert('transport_student', $data1);
            }
            
            $data2['student_id']     = $student_id;
            $data2['enroll_code']    = substr(md5(rand(0, 1000000)), 0, 7);
            $data2['class_id']       = $this->input->post('class_id');
            if ($this->input->post('section_id') != '') {
                $data2['section_id'] = $this->input->post('section_id');
            }
           
            $data2['roll']           = $this->input->post('roll');;
            $data2['date_added']     = strtotime(date("Y-m-d H:i:s"));
            $data2['year']           = $running_year;
            $this->db->insert('enroll', $data2);
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/student_image/' . $student_id . '.jpg');
            //sms
            $school=$this->db->get_where('settings',['settings_id',1])->result();
            $message = 'Welcome to '.$this->db->get_where('settings' , array('type'=>'system_name'))->row()->description.'. The admission for '.$data['name'].' has been initaited. For future reference, use Admission No : '.$data['admission_no'];
            if($this->input->post('phone') !=''){
                $this->sms_model->send_sms($message , $this->input->post('phone'));
            }
//Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'New student profile of '.$this->input->post('name').' has been added.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_&_SMS_sent_successfully'));


            $this->email_model->account_opening_email('student', $data['email']); //SEND EMAIL ACCOUNT OPENING EMAIL
            redirect(base_url() . 'index.php?admin/student_add/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']           = $this->input->post('name');
            $data['birthday']       = $this->input->post('birthday');
            $data['sex']            = $this->input->post('sex');
            //*new change
            $data['address']        = $this->input->post('address');
          
            $data['father_name']          = $this->input->post('father');
            $data['mother_name']          = $this->input->post('mother');
            $data['mother_phone']          = $this->input->post('mother_phone');
            //end change
            $data['phone']          = $this->input->post('phone');
            $data['admission_no']        = $this->input->post('admission_no');
            $data['email']          = $this->input->post('email');
            $data['user_name']          = $this->input->post('user_name'); 
            $data['password']       = sha1($this->input->post('password'));
            $data['parent_id']      = $this->input->post('parent_id');
            $data['dormitory_id']   = $this->input->post('dormitory_id');

            if(count($this->db->get_where('transport_student',['student_id' =>$param2])->result())>0){
               $this->db->where('student_id', $param2);
               $this->db->delete('transport_student');
            }
            foreach($this->input->post('transport_id') as $value){
               $details=$this->db->get_where('transport_student',['student_id' =>$param2,'transport_id' =>$value])->result();
               if(count($details) == 0){
               $data1['student_id'] = $param2;
               $data1['transport_id'] = $value;
               $this->db->insert('transport_student', $data1);
              }
            }
            
           
            $this->db->where('student_id', $param2);
            $this->db->update('student', $data);

            $data2['section_id']    =   $this->input->post('section_id');
            $data2['roll']          =   $this->input->post('roll');
            $running_year = $this->db->get_where('settings' , array('type'=>'running_year'))->row()->description;
            $this->db->where('student_id' , $param2);
            $this->db->where('year' , $running_year);
            $this->db->update('enroll' , array(
                'section_id' => $data2['section_id'] , 'roll' => $data2['roll']
            ));

            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/student_image/' . $param2 . '.jpg');
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                  $datas['description']    =   'Profile of '.$this->input->post('name').' has been updated.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->crud_model->clear_cache();
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/student_information/' . $param3, 'refresh');
        }
        if ($param2 == 'delete') {
            $this->db->where('student_id', $param3);
            $this->db->delete('student');
             
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/student_information/' . $param1, 'refresh');
        }
    } 
    //krish
      function delete_student($student_id = '', $class_id = '') {
     $student = $this->db->get_where('student' , array('student_id' => $student_id))->row()->name;
      $this->crud_model->delete_student($student_id);
      
      //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   '<font color="red">Profile of <b>'.$student.' </b>has been deleted.</font>';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
      $this->session->set_flashdata('flash_message' , get_phrase('student_deleted'));
      redirect(base_url() . 'index.php?admin/student_information/' . $class_id, 'refresh');
    }
    /*krish----*/
    //Consolidated Attendence Register
    function consolidated_attendance_register($class_id = '',$section_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['page_name']  = 'consolidated_attendance_register';
        $page_data['page_title'] = get_phrase('consolidated_attendance_register');
        $this->load->view('backend/index', $page_data);
    }
    /*krish----*/
    function consolidated_attendance()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $data['class_id']   = $this->input->post('class_id');
        $data['section_id'] = $this->input->post('section_id');
        redirect(base_url() . 'index.php?admin/consolidated_attendance_register/'. $data['class_id'] . '/' . $data['section_id']  , 'refresh');
    }
    //STUDENT DIARY
    function student_diary($class_id = '' ,$section_id = '') {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');      
        /*if ($this->input->post('operation') == 'selection') {
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?admin/tabulation_sheet/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?admin/tabulation_sheet/', 'refresh');
            }
        }*/
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'Student Diary';
        
        $page_data['page_name']  = 'student_diary';
        $page_data['page_title'] = get_phrase('Student_Diary');
        $this->load->view('backend/index', $page_data);
    
    }
    function modal_student_diary($page_name = '' , $param2 = '' , $param3 = '')
	{
		$page_data['student_id'] = $this->input->post('student_id');
        $page_data['page_info'] = 'Student Diary';
        
        $page_data['page_name']  = 'modal_student_diary';
        $page_data['page_title'] = get_phrase('Student_Diary');
		$this->load->view('backend/index', $page_data);
		
	}
    //krish
    function get_student_diary_ajax(){
        $this->db->select('student.name,student.student_id');
        $this->db->join('student','enroll.student_id = student.student_id');
        $this->db->order_by('enroll.roll');
        $data=$this->db->get_where('enroll',['enroll.class_id' =>$this->input->post('class_id'),'enroll.section_id' =>$this->input->post('section_id')])->result();
        echo (json_encode($data));
    }
    //krish -issue tc
    function issue_tc($class_id = '' , $section_id = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($this->input->post('operation') == 'selection') {
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            if ($page_data['class_id'] > 0 && $page_data['section_id'] > 0) {
                redirect(base_url() . 'index.php?admin/issue_tc/' . $page_data['class_id'] . '/' .$page_data['section_id'], 'refresh');
            } else {
                redirect(base_url() . 'index.php?admin/issue_tc', 'refresh');
            }
        }
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;  
        $page_data['page_name']  = 'issue_tc';
        $page_data['page_title'] = 'ISSUE TC';
        $this->load->view('backend/index', $page_data);     
    }
    //krish 
    function student_profile_print($student_id = '' ) {
      $student_info =   $this->db->get_where('enroll' , array(
    'student_id' => $student_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
    ))->result();
       $system_name        =   $this->db->get_where('settings' , array('type'=>'system_name'))->row()->description;
            $code = $this->db->get_where('settings' , array('type'=>'system_code'))->row()->description;
            $affiliation = $this->db->get_where('settings' , array('type'=>'affiliation'))->row()->description;
            $line1        = $this->db->get_where('settings' , array('type'=>'address'))->row()->description;
            $line2        = $this->db->get_where('settings' , array('type'=>'phone'))->row()->description;
            $line3        = $this->db->get_where('settings' , array('type'=>'system_email'))->row()->description;
            $title='<center><h3 style="font-weight: 100;margin-left:300px">'.$system_name.'</h3></center>';
            $image = $student_id.'.jpg';
            $this->load->helper('pdf_helper');
            $html ='<html><body style="border:1px solid #000;"><div style="width:100%;padding:10px"><div style="width:100%; margin:0px auto;">
            <div style="float:left;width:150px"><br>
                    <img src="uploads/logo.png" style="width:60px;height:60px;padding-left:40px"><br>
                    <div style="margin-top:20px;margin-bottom:10px;">School Code : '.$code.'<br><br></div>
            </div>
            <div style="float:left;width:500px;height:auto"><center><h3>'.$system_name.'</h3>';
            if($affiliation !='')
              $html .=$affiliation.'.<br>';

             $html .=$line1.', Ph.'.$line2.'<br> '.$line3.'<br><br></center></div>
            </div><div style="width:100px">';
           if($affiliation !='')
            $html .='<br>';
           $html .='<br><br></div><br><br><br><div style="border-bottom:1px solid black;height:20px;margin-top:20px"></div>
            <div style="padding:20px"><center><h3><u>Student Information</u></h3></center><br>
          <div  style="width:10%;float:right;" >';
          $image= $this->db->get_where('student' , array(
                                        'student_id' => $student_id
                                    ))->row()->image;
            if($image !=''){
   $html .="<img src='data:image/jpeg;base64,".$image."' class='img-circle' /></td>";
     } 
            $html .='</div>
         <div  style="width:80%"><table width="100%"><tr><td width="40%"><b>Admission No.</b></td><td width="10%">:</td><td 
 width="40%">'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->admission_no.'</td></tr>
          <tr><td><b>Name</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->name.'</td></tr>
          <tr><td><b>Class</b></td><td>:</td><td>'.$this->crud_model->get_class_name($student_info[0]->class_id).'</td></tr>
          <tr><td><b>Section</b></td><td>:</td><td>'.$this->db->get_where('section' , array('section_id' => $student_info[0]->section_id))->row()->name.'</td></tr>
          
 <tr><td><b>Date of Birth</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->birthday.'</td></tr>
         <tr><td><b>Gender</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->sex.'</td></tr>
         <tr><td><b>Phone</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->phone.'</td></tr> 
        <tr><td><b>Email</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->email.'</td></tr>  
        <tr><td><b>Father</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->father_name.'</td></tr>  
        <tr><td><b>Mother</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->mother_name.'</td></tr>  
       <tr><td><b>Address</b></td><td>:</td><td>'.$this->db->get_where('student' , array('student_id' => $student_id))->row()->address.'</td></tr>';
$issuetc = $this->db->get_where('student' , array('student_id' => $student_id))->row()->issue_tc;
if($issuetc == 1)
$html .='
 <tr><td><b>TC issued on</b></td><td>:</td><td>'.$this->db->get_where('tc_details' , array('student_id' => $student_id))->row()->issue_date.'</td></tr>';
$html .='</table></div></div></body></html>';

           include(APPPATH."libraries/dompdf/autoload.inc.php");
            $dompdf = new Dompdf\Dompdf(); 
            $dompdf->loadHtml($html);// (Optional) Setup the paper size and orientation
            $dompdf->setPaper('A4', 'portrait');// Render the HTML as PDF
            $dompdf->render();// Get the generated PDF file contents
            $pdf = $dompdf->output();// Output the generated PDF to Browser
            $dompdf->stream();
    }
    function issue_tc_form_print($student_id = '' ) {
       $tcstudent = $this->db->get_where('tc_details' ,['student_id' => $student_id])->result();
       $page_data['student_id']   = $student_id;
       $page_data['tcstudent']   = $tcstudent;
       $page_data['page_name']  = 'issue_tc_form';
       $page_data['page_title'] = 'TC Form';
       $this->load->view('backend/index', $page_data);
    }
    function issue_tc_form($student_id = '' ) {
        if ($this->input->post('operation') == 'selection') {
            $data  = array();
            $system_name        =   $this->db->get_where('settings' , array('type'=>'system_name'))->row()->description;
           $this->db->where('student_id' , $this->input->post('student_id'));
            $this->db->update('student' , ['issue_tc' => 1]);
            $details = $this->db->get_where('student',['student_id' => $this->input->post('student_id')])->result();
            $parent = $this->db->get_where('parent' , array('parent_id'=>$details[0]->parent_id))->row()->name;
            $running_year = $this->db->get_where('settings' , array(
                'type' => 'running_year'
             ))->row()->description;
            $this->db->order_by('enroll_id','DESC');
            $class = $this->db->get_where('enroll',['student_id' => $this->input->post('student_id'),'enroll.status' =>1,'year' =>$running_year])->result(); 
            $class = $this->db->get_where('class',['class_id' =>$class[0]->class_id])->row()->name;
                       
            $check   =   array(  'status' => '1' , 'student_id' => $this->input->post('student_id'));
            $query = $this->db->get_where('attendance' , $check);
            $present_today      =   $query->num_rows();

            $check5   =   array(  'status' => '2' , 'student_id' => $this->input->post('student_id'));
            $query5 = $this->db->get_where('attendance' , $check5);
            $absent_today      =   $query5->num_rows();
            $absent_dates     =   $query5->result_array();
            if(($present_today +  $absent_today) ==0){
                $total_percent = 0;
            }
            else{
                $total_percent =  ($present_today / ($present_today +  $absent_today ) * 100);
            }
            $total = $present_today.'/'.$absent_today.' ( '.round($total_percent,2).'% )';
            $subject = $this->db->get_where('subject',['class_id' => $class[0]->class_id])->result();
            $subjs='';
            foreach($subject as $subj){
                $subjs.=$subj->name.', ';
            }
            $tcstudent = $this->db->get_where('tc_details' ,['student_id' => $this->input->post('student_id')])->result();
            $running_year       =   $this->db->get_where('settings' , array('type'=>'running_year'))->row()->description;
            $data['student_id'] = $this->input->post('student_id');
            $data['book_no'] = $this->input->post('file_no');
            $data['tc_no'] = $this->input->post('tc_no');
            $data['guardian'] = $this->input->post('guardian');
            $data['caste'] = $this->input->post('caste');
            $data['dob'] = $this->input->post('dob');
            $data['admission_date'] = $this->input->post('admin_date');
            $data['birth_place'] = $this->input->post('birth_place');
            $data['class_last_study'] = $class;
            $data['school_board'] = $this->input->post('last_exam');
            $data['fee_concession'] = $this->input->post('fees_concession');
            $data['failed'] = $this->input->post('failed_class');
            $data['subjects'] = $subjs;
            $data['promotion'] = $this->input->post('qualified');
            $data['fee_date'] = date('Y-m-d',strtotime($this->input->post('paid_fees')));
            $data['no_working'] = $total;
            $data['others'] = $this->input->post('group');
            $data['games'] = $this->input->post('curricular');
            $data['conduct'] = $this->input->post('conduct');
            $data['application_date'] = date('Y-m-d',strtotime($this->input->post('application_date')));
            $data['leaving_date'] = date('Y-m-d',strtotime($this->input->post('leaving_date')));
            $data['issue_date'] = date('Y-m-d',strtotime($this->input->post('issue_date')));
            $data['leaving_reason'] = $this->input->post('reason');
            $data['to_school'] = $this->input->post('new_schl');
            $data['remarks'] = $this->input->post('remarks');
            $data['timestamp'] = strtotime(date('d-m-Y'));
            $data['year'] = $running_year;
            if(count($tcstudent)==0){
                $this->db->insert('tc_details', $data);
            }
            else
            {
                $this->db->where('student_id', $this->input->post('student_id'));
                $this->db->update('tc_details', $data);
            }

            $system_name        =   $this->db->get_where('settings' , array('type'=>'system_name'))->row()->description;
            $code = $this->db->get_where('settings' , array('type'=>'system_code'))->row()->description;
            $affiliation = $this->db->get_where('settings' , array('type'=>'affiliation'))->row()->description;
            $line1        = $this->db->get_where('settings' , array('type'=>'address'))->row()->description;
            $line2        = $this->db->get_where('settings' , array('type'=>'phone'))->row()->description;
            $line3        = $this->db->get_where('settings' , array('type'=>'system_email'))->row()->description;
            $title='<center><h3 style="font-weight: 100;margin-left:300px">'.$system_name.'</h3></center>';
            $this->load->helper('pdf_helper');
            $page_data['data']='<div style="width:100%;border:1px solid #000;padding:10px"><div style="width:100%; margin:0px auto;">
            <div style="float:left;width:150px"><br>
                    <img src="uploads/logo.png" style="width:60px;height:60px;padding-left:40px;padding-top:20px"><br>
                    <div style="margin-top:20px;margin-bottom:10px;">School Code : '.$code.'<br><br></div>
            </div>
            <div style="float:left;width:500px;height:auto"><center><h3>'.$system_name.'</h3>';
            if($affiliation !='')
              $page_data['data'] .=$affiliation.'.<br>';

             $page_data['data'] .=$line1.', Ph.'.$line2.'<br> '.$line3.'<h4><u>TRANSFER CERTIFICATE</u></h4></center></div><br><br>
            <div style="width:100px"></div><br>';
           if($affiliation !='')
            $page_data['data'] .='<br>';
           $page_data['data'] .='<br><br><br><br><br><br>
            <div style="padding:0px 40px 10px 40px;border-bottom:1px solid black"><table><tr><td width="80">Book/File No : </td><td width="60">'.$this->input->post('file_no').'</td><td width="60">TC No : </td><td width="80">'.$this->input->post('tc_no').'</td><td width="80">Admission No : </td><td width="60">'.$details[0]->admission_no.'</td></tr></table></div>
            <table><tbody>
            <tr><td width="300">1. Name of Pupil</td><td width="10">:</td><td>'.$details[0]->name.'</td></tr>
            <tr><td width="300">2. Name of the Guardian</td><td width="10">:</td><td>'.$this->input->post('guardian').'</td></tr>
            <tr><td width="300">3. Nationality</td><td width="10">:</td><td>'.$this->input->post('nationality').'</td></tr>
            <tr><td width="300">4. Religion/Community</td><td width="10">:</td><td>'.$details[0]->religion.'</td></tr>
            <tr><td width="300">5. Caste</td><td width="50">:</td><td>'.$this->input->post('caste').'</td></tr>
            <tr><td width="300">6. Date of Admission in the School with class</td><td width="50">:</td><td>'.$this->input->post('admin_date').'</td></tr>
            <tr><td width="240">7. Date Of Birth(in Christian era) according to Admission Register(in Figures & Words)</td><td width="50">:</td><td>'.$this->input->post('dob').'</td></tr>
            <tr><td width="260">8. Place Of Birth</td><td width="50">:</td><td>'.$this->input->post('birth_place').'</td></tr>
            <tr><td width="260">9. Class in which pupil last studied</td><td width="50">:</td><td>'.$class.'</td></tr>
            <tr><td width="260">10. School/Board Annual examination last taken with Result</td><td width="50">:</td><td>'.$this->input->post('last_exam').'</td></tr>
            <tr><td width="260">11. Any fees concession availed. If so, name of such concession</td><td width="50">:</td><td>'.$this->input->post('fees_concession').'</td></tr>
            <tr><td width="260">12. Whether failed, if so once/twice in the same class</td><td width="50">:</td><td>'.$this->input->post('failed_class').'</td></tr>
            <tr><td width="260">13. Subjects Studied</td><td width="50">:</td><td>'.$subjs.'</td></tr>
            <tr><td width="260">14. Whether qualified for promotion & to which class</td><td width="50">:</td><td>'.$this->input->post('qualified').'</td></tr>
            <tr><td width="260">15. Month upto which the pupil has paid school fees</td><td width="50">:</td><td>'.$this->input->post('paid_fees').'</td></tr>
            <tr><td width="260">16. Total No. of Present days / working days</td><td width="50">:</td><td>'.$total.'</td></tr>
            
            <tr><td width="260">17. Whether NCC cadet/Boy Scout/Girl Guide/Others(Details may be given)</td><td width="50">:</td><td>'.$this->input->post('group').'</td></tr>
            <tr><td width="260">18. Games played/Extra Curricular Activities the pupil took part (mention achievement level)</td><td width="50">:</td><td>'.$this->input->post('curricular').'</td></tr>
            <tr><td width="260">19. General Conduct</td><td width="50">:</td><td>'.$this->input->post('conduct').'</td></tr>
            <tr><td width="260">20. Date of application for certificate</td><td width="50">:</td><td>'.$this->input->post('application_date').'</td></tr>
            <tr><td width="260">21. Date of leaving the school & Date of issuing the certificate</td><td width="50">:</td><td>'.$this->input->post('leaving_date').','.$this->input->post('issue_date').'</td></tr>
            <tr><td width="260">22. Reason for leaving the school</td><td width="50">:</td><td>'.$this->input->post('reason').'</td></tr>
            <tr><td width="260">23. Details of the school to which student indented to proceed</td><td width="50">:</td><td>'.$this->input->post('new_schl').'</td></tr>
            <tr><td width="260">24. Any other remarks</td><td width="50">:</td><td>'.$this->input->post('remarks').'</td></tr>
            </tbody></table><br><br><table><tr><td width="180">Class Teacher</td><td width="130">Checked By</td><td width="220">Principal</td></tr><tr><td width="130">Signature</td><td width="180">Name & Designation</td><td width="160">Seal</td></tr></table><br></div>';
            
            $page_data['page_name']  = 'pdfreport';
            $page_data['page_title'] = 'TC Form';
            include(APPPATH."libraries/dompdf/autoload.inc.php");
            $dompdf = new Dompdf\Dompdf();   
            $html = $page_data['data'];
            $dompdf->loadHtml($html);// (Optional) Setup the paper size and orientation
            $dompdf->setPaper('A4', 'portrait');// Render the HTML as PDF
            $dompdf->render();// Get the generated PDF file contents
            $pdf = $dompdf->output();// Output the generated PDF to Browser
            $dompdf->stream();
            }
        $page_data['student_id']   = $student_id;
        $page_data['page_name']  = 'issue_tc_form';
        $page_data['page_title'] = 'TC Form';
        $this->load->view('backend/index', $page_data); 
    }
    //krish -issued tc
    function issued_tc($class_id = '' , $section_id = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($this->input->post('operation') == 'selection') {
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            if ($page_data['class_id'] > 0 && $page_data['section_id'] > 0) {
                redirect(base_url() . 'index.php?admin/issued_tc/' . $page_data['class_id'] . '/' .$page_data['section_id'], 'refresh');
            } else {
                redirect(base_url() . 'index.php?admin/issued_tc', 'refresh');
            }
        }
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id; 
        $page_data['page_name']  = 'issued_tc';
        $page_data['page_title'] = 'ISSUED TC';
        $this->load->view('backend/index', $page_data); 
    }
    //Krish
    function changeStudentStatus($param='',$param1='',$param2=''){
      if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

       $this->db->where('student_id', $param);
       $this->db->update('student', ['alumni'=>1]);
       $this->issued_tc($param1,$param2);
    }
     //krish
    function save_student_diary(){
            $data['date']           = $this->input->post('date');
            $data['student_id']     = $this->input->post('student_id');
            $data['category_id  ']  = $this->input->post('category');
            $data['details']        = $this->input->post('description');
            if($this->input->post('teacher') != -1){
                $data['added_by']       = $this->input->post('teacher');
                $this->db->select('teacher.name');
                $Added = $this->db->get_where('teacher',['teacher_id' => $this->input->post('teacher')])->result();
                $data['added_type']       = 'teacher';
            }
            else{
                $data['added_by']       = $this->session->userdata('admin_id');
                $this->db->select('admin.name');
                $Added = $this->db->get_where('admin',['admin_id' => $this->session->userdata('admin_id')])->result();
                $data['added_type']       = 'admin';
            }
            if($this->session->userdata('admin_login')){
                $data['user_type']       = 'admin';
                $data['user_id']       = $this->session->userdata('admin_id');
            }
            else{
                 $data['user_type']       = 'teacher';
                 $data['user_id']       = $this->session->userdata('teacher_id');
            }
            $data['user_id']       = 'admin';
            $data['sms_option']        = $this->input->post('sms_to_parent');
            $data['status']        = 1;
            $this->db->insert('student_diary', $data);
            if($this->input->post('sms_to_parent') == 'Yes'){
                $this->db->select('category');
                $category = $this->db->get_where('category',['id' => $this->input->post('category')])->result();
                $this->db->select('parent.phone');
                $this->db->join('parent','parent.parent_id = student.parent_id');
                $data=$this->db->get_where('student',['student_id' => $this->input->post('student_id') ])->result();
                $message = $this->input->post('date');
                $message.= "\n By ".$Added[0]->name;
                $message.= "\n ".$category[0]->category;
                $message.= "\n ".$this->input->post('description');
                $reciever_phone = $data[0]->phone;
                $this->sms_model->send_sms($message , $reciever_phone);
                $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
            }
            redirect(base_url() . 'index.php?admin/student_diary/', 'refresh');
    }
    /*//krish*/
    function category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if($param1 == 'delete') {
            $this->db->where('id' , $param2);
            $this->db->delete('category');
            $this->session->set_flashdata('flash_message' , get_phrase('category_deleted'));
            redirect(base_url() . 'index.php?admin/student_diary/', 'refresh');
        }
        if($param1 == 'update') {
            $data['category']                   = $this->input->post('category');
            $this->db->where('id' , $this->input->post('category_id'));
            $this->db->update('category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('category_updated'));
            redirect(base_url() . 'index.php?admin/student_diary/', 'refresh');
        }
        if ($param1 == 'add') {
           $data['category']                   = $this->input->post('category');
            $this->db->insert('category', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('category_added_successfully'));
            redirect(base_url() . 'index.php?admin/student_diary/', 'refresh');
        }
    }
    /*//krish*/

    // STUDENT PROMOTION
    function student_promotion($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');

        if($param1 == 'promote') {
            $running_year  =   $this->input->post('running_year');  
            $from_class_id =   $this->input->post('promotion_from_class_id'); 
            $students_of_promotion_class =   $this->db->get_where('enroll' , array(
                'class_id' => $from_class_id , 'year' => $running_year
            ))->result_array();
            foreach($students_of_promotion_class as $row) {
                if($this->input->post('promotion_status_'.$row['student_id'])!=''){
                $enroll_data['enroll_code']     =   substr(md5(rand(0, 1000000)), 0, 7);
                $enroll_data['student_id']      =   $row['student_id'];
                $enroll_data['class_id']        =   $this->input->post('promotion_status_'.$row['student_id']);
                $enroll_data['section_id']      =   $this->input->post('promotion_section_'.$row['student_id']);
                $enroll_data['year']            =   $this->input->post('promotion_year');
                $enroll_data['date_added']      =   strtotime(date("Y-m-d H:i:s"));
                $enroll_data['status']      =   1;
                $this->db->insert('enroll' , $enroll_data);
                }
            } 
            $this->session->set_flashdata('flash_message' , get_phrase('new_enrollment_successfull'));
            redirect(base_url() . 'index.php?admin/student_promotion' , 'refresh');
        }

        $page_data['page_title']    = get_phrase('student_promotion');
        $page_data['page_name']  = 'student_promotion';
        $this->load->view('backend/index', $page_data);
    }

    function get_students_to_promote($class_id_from , $class_id_to , $running_year , $promotion_year,$section)
    {
        $page_data['class_id_from']     =   $class_id_from;
        $page_data['class_id_to']       =   $class_id_to;
        /*$page_data['sections']          =   $this->db->get_where('section' , array(
            'class_id' => $class_id_to
        ))->result_array();*/
        $page_data['section']          =   $section;
        $page_data['running_year']      =   $running_year;
        $page_data['promotion_year']    =   $promotion_year;
        $this->load->view('backend/admin/student_promotion_selector' , $page_data);
    }


     /****MANAGE PARENTS CLASSWISE*****/
    function parent($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']                   = $this->input->post('name');
            $data['mother_name']            = $this->input->post('mother_name');
            $data['email']                  = $this->input->post('email');
            $data['user_name']       = $this->input->post('user_name');
            $data['password']               = sha1($this->input->post('password'));
            $data['phone']                  = $this->input->post('phone');
            $data['mother_phone']           = $this->input->post('mother_contact');
            $data['address_line_1']                = $this->input->post('address_line_1');
            $data['address_line_2']                = $this->input->post('address_line_2');
            $data['profession']             = $this->input->post('profession');
            $data['mother_occupation']             = $this->input->post('mother_occupation');
            $this->db->insert('parent', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            $this->email_model->account_opening_email('parent', $data['email']); //SEND EMAIL ACCOUNT OPENING EMAIL
            redirect(base_url() . 'index.php?admin/parent/', 'refresh');
        }
        if ($param1 == 'edit') {
            $data['name']                   = $this->input->post('name');
            $data['email']                  = $this->input->post('email');
            $data['phone']                  = $this->input->post('phone');
            $data['mother_name']            = $this->input->post('mother_name');
            $data['mother_phone']           = $this->input->post('mother_contact');
            $data['address_line_1']         = $this->input->post('address_line_1');
            $data['address_line_2']         = $this->input->post('address_line_2');
            $data['user_name']       = $this->input->post('user_name');
            $data['password']    = sha1($this->input->post('password'));
            $data['mother_occupation']      = $this->input->post('mother_occupation');
            $data['profession']             = $this->input->post('profession');
            $this->db->where('parent_id' , $param2);
            $this->db->update('parent' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/parent/', 'refresh');
        }
        if ($param1 == 'delete') {
            $this->db->where('parent_id' , $param2);
            $this->db->delete('parent');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/parent/', 'refresh');
        }
        $page_data['page_title']    = get_phrase('all_parents');
        $page_data['page_name']  = 'parent';
        $this->load->view('backend/index', $page_data);
    }
    
    
/****MANAGE TEACHERS*****/
    function teacher($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']        = $this->input->post('name');
            $data['birthday']    = $this->input->post('birthday');
            $data['sex']         = $this->input->post('sex');
            $data['address']     = $this->input->post('address');
            $data['phone']       = $this->input->post('phone');
              $data['user_name']       = $this->input->post('user_name');
            $data['email']       = $this->input->post('email');
            $data['password']    = sha1($this->input->post('password'));
            $this->db->insert('teacher', $data);
            $teacher_id = $this->db->insert_id();
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/teacher_image/' . $teacher_id . '.jpg');
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            $this->email_model->account_opening_email('teacher', $data['email']); //SEND EMAIL ACCOUNT OPENING EMAIL
            redirect(base_url() . 'index.php?admin/teacher/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']        = $this->input->post('name');
            $data['birthday']    = $this->input->post('birthday');
            $data['sex']         = $this->input->post('sex');
            $data['address']     = $this->input->post('address');
            $data['phone']       = $this->input->post('phone');
            $data['user_name']       = $this->input->post('user_name');
            $data['password']    = sha1($this->input->post('password'));
            $data['email']       = $this->input->post('email');
            
            $this->db->where('teacher_id', $param2);
            $this->db->update('teacher', $data);
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/teacher_image/' . $param2 . '.jpg');
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/teacher/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_teacher_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('teacher', array(
                'teacher_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('teacher_id', $param2);
            $this->db->delete('teacher');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/teacher/', 'refresh');
        }
        $page_data['teachers']   = $this->db->get('teacher')->result_array();
        $page_data['page_name']  = 'teacher';
        $page_data['page_title'] = get_phrase('manage_teacher');
        $this->load->view('backend/index', $page_data);
    }
    
    
    /****MANAGE SUBJECTS*****/
    function subject($param1 = '', $param2 = '' , $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']       = $this->input->post('name');
            $data['class_id']   = $this->input->post('class_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['year']       = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('subject', $data);
            
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $class = $this->db->get_where('class' , array('class_id' => $data['class_id']))->row()->name;
                 $datas['device']       =   'web';
                 $datas['description']    =   'New Subject <b>'.$this->input->post('name').' </b>for class: '.$class.' has been added.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/subject/'.$data['class_id'], 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']       = $this->input->post('name');
            $data['class_id']   = $this->input->post('class_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['year']       = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            
            $this->db->where('subject_id', $param2);
            $this->db->update('subject', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/subject/'.$data['class_id'], 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('subject', array(
                'subject_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
             $subject = $this->db->get_where('subject' , array('subject_id' => $param2))->row()->name;
             $classid = $this->db->get_where('subject' , array('subject_id' => $param2))->row()->class_id;
            $class = $this->db->get_where('class' , array('class_id' => $classid))->row()->name;
            $this->db->where('subject_id', $param2);
            $this->db->delete('subject');
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   '<font color="red">Subject <b>'.$subject.' </b>for class: '.$class.' has been deleted.</font>';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/subject/'.$param3, 'refresh');
        }
        $page_data['class_id']   = $param1;
        $page_data['subjects']   = $this->db->get_where('subject' , array('class_id' => $param1))->result_array();
        $page_data['page_name']  = 'subject';
        $page_data['page_title'] = get_phrase('manage_subject');
        $this->load->view('backend/index', $page_data);
    }
    /****MANAGE CLASSES*****/
    function classes($param1 = '', $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']         = $this->input->post('name');
            $data['name_numeric'] = $this->input->post('name_numeric');
            $data['teacher_id']   = $this->input->post('teacher_id');
            $this->db->insert('class', $data);
            $class_id = $this->db->insert_id();
            $class = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
            //create a section by default
            $data2['class_id']  =   $class_id;
            $data2['name']      =   'A';
            $this->db->insert('section' , $data2);
            
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'New '.$class.' has been created.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);

            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/classes/', 'refresh');
        }
        if ($param1 == 'fee') {
            $data['fee_amount']   = $this->input->post('amount');
            
            $this->db->where('class_id', $this->input->post('class_id'));
            $this->db->update('class', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/classes/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']         = $this->input->post('name');
            $data['name_numeric'] = $this->input->post('name_numeric');
            $data['teacher_id']   = $this->input->post('teacher_id');
            $data['fee_amount']   = $this->input->post('fee_amount');
            $this->db->where('class_id', $param2);
            $this->db->update('class', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/classes/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('class', array(
                'class_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
          
            $class = $this->db->get_where('class' , array('class_id' => $param2 ))->row()->name;
            $this->db->where('class_id', $param2);
             $this->db->delete('class');
             
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
    $datas['ip']       =   $_SERVER['REMOTE_ADDR'];
                 $datas['description']    =   '<font color="red">Class - '.$class.' has been deleted.</font>';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/classes/', 'refresh');
        }
        $page_data['classes']    = $this->db->get('class')->result_array();
        $page_data['page_name']  = 'class';
        $page_data['page_title'] = get_phrase('manage_class');
        $this->load->view('backend/index', $page_data);
    }

    // ACADEMIC SYLLABUS
    function academic_syllabus($class_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        // detect the first class
        if ($class_id == '')
            $class_id           =   $this->db->get('class')->first_row()->class_id;

        $page_data['page_name']  = 'academic_syllabus';
        $page_data['page_title'] = get_phrase('academic_syllabus');
        $page_data['class_id']   = $class_id;
        $this->load->view('backend/index', $page_data);
    }

    function upload_academic_syllabus()
    {
        $data['academic_syllabus_code'] =   substr(md5(rand(0, 1000000)), 0, 7);
        $data['title']                  =   $this->input->post('title');
        $data['description']            =   $this->input->post('description');
        $data['class_id']               =   $this->input->post('class_id');
        $data['uploader_type']          =   $this->session->userdata('login_type');
        $data['uploader_id']            =   $this->session->userdata('login_user_id');
        $data['year']                   =   $this->db->get_where('settings',array('type'=>'running_year'))->row()->description;
        $data['timestamp']              =   strtotime(date("Y-m-d H:i:s"));
        //uploading file using codeigniter upload library
        $files = $_FILES['file_name'];
        $this->load->library('upload');
        $config['upload_path']   =  'uploads/syllabus/';
        $config['allowed_types'] =  '*';
        $_FILES['file_name']['name']     = $files['name'];
        $_FILES['file_name']['type']     = $files['type'];
        $_FILES['file_name']['tmp_name'] = $files['tmp_name'];
        $_FILES['file_name']['size']     = $files['size'];
        $this->upload->initialize($config);
        $this->upload->do_upload('file_name');

        $data['file_name'] = $_FILES['file_name']['name'];

        $this->db->insert('academic_syllabus', $data);
        $this->session->set_flashdata('flash_message' , get_phrase('syllabus_uploaded'));
        redirect(base_url() . 'index.php?admin/academic_syllabus/' . $data['class_id'] , 'refresh');

    }

    function download_academic_syllabus($academic_syllabus_code)
    {
        $file_name = $this->db->get_where('academic_syllabus', array(
            'academic_syllabus_code' => $academic_syllabus_code
        ))->row()->file_name;
        $this->load->helper('download');
        $data = file_get_contents("uploads/syllabus/" . $file_name);
        $name = $file_name;

        force_download($name, $data);
    }

    /****MANAGE SECTIONS*****/
    function section($class_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        // detect the first class
        if ($class_id == '')
            $class_id           =   $this->db->get('class')->first_row()->class_id;

        $page_data['page_name']  = 'section';
        $page_data['page_title'] = get_phrase('manage_sections');
        $page_data['class_id']   = $class_id;
        $this->load->view('backend/index', $page_data);    
    }

    function sections($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']       =   $this->input->post('name');
            $data['nick_name']  =   $this->input->post('nick_name');
            $data['class_id']   =   $this->input->post('class_id');
            $data['teacher_id'] =   $this->input->post('teacher_id');
             
             
             $class = $this->db->get_where('class' , array('class_id' => $data['class_id'] ))->row()->name;
            $this->db->insert('section' , $data);
            //log
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $data['description']    =   'New Section '.$this->input->post('name').' for'.$class.' has been added.';
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $data['status']       =  0; 
                 $this->db->insert('log' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/section/' . $data['class_id'] , 'refresh');
        }

        if ($param1 == 'edit') {
            $data['name']       =   $this->input->post('name');
            $data['nick_name']  =   $this->input->post('nick_name');
            $data['class_id']   =   $this->input->post('class_id');
            $data['teacher_id'] =   $this->input->post('teacher_id');
            $this->db->where('section_id' , $param2);
            $this->db->update('section' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/section/' . $data['class_id'] , 'refresh');
        }

        if ($param1 == 'delete') {
            $section = $this->db->get_where('section' , array('section_id' => $param2 ))->row()->name;
           $classid = $this->db->get_where('section' , array('section_id' => $param2 ))->row()->class_id;
             $class = $this->db->get_where('class' , array('class_id' => $classid ))->row()->name;
            $this->db->where('section_id' , $param2);
            $this->db->delete('section');
            
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
    
                 $datas['description']    =   '<font color="red"> Section- '.$section.' of '.$class.' has been deleted.</font>';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/section' , 'refresh');
        }
    }

    function get_class_section($class_id)
    {
        $sections = $this->db->get_where('section' , array(
            'class_id' => $class_id
        ))->result_array();
        foreach ($sections as $row) {
            echo '<option value="' . $row['section_id'] . '">' . $row['name'] . '</option>';
        }
    }
    
    
    
    function get_class_subject($class_id)
    {
        $subjects = $this->db->get_where('subject' , array(
            'class_id' => $class_id
        ))->result_array();
        foreach ($subjects as $row) {
            echo '<option value="' . $row['subject_id'] . '">' . $row['name'] . '</option>';
        }
    }

    function get_class_students($class_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        foreach ($students as $row) {
           $this->db->where(['student_id' =>$row['student_id'],'alumni' =>0]);
            $checkStudent = $this->db->get('student')->result_array();
            if(count($checkStudent)>0){
            $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<option value="' . $row['student_id'] . '">' . $name . '</option>';
        } }
    }

    function get_class_students_mass($class_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id , 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        echo '<div class="form-group">
                <label class="col-sm-3 control-label">' . get_phrase('students') . '</label>
                <div class="col-sm-9">';
        foreach ($students as $row) {
          $this->db->where(['student_id' =>$row['student_id'],'alumni' =>0]);
           $checkStudent = $this->db->get('student')->result_array();
            if(count($checkStudent)>0){
             $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<div class="checkbox">
                    <label><input type="checkbox" class="checks" name="student_id[]" value="' . $row['student_id'] . '">' . $name .'</label>
                </div>';
        } }
        echo '<br><button type="button" class="btn btn-default" onClick="select()">'.get_phrase('select_all').'</button>';
        echo '<button style="margin-left: 5px;" type="button" class="btn btn-default" onClick="unselect()"> '.get_phrase('select_none').' </button>';
        echo '</div></div>';
    }



    /****MANAGE EXAMS**** Krish-updated*/
    function exam($param1 = '', $param2 = '' , $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']    = $this->input->post('name');
            $data['date']    = $this->input->post('date');
            $data['total_mark']    = $this->input->post('total_mark');
            $data['comment'] = $this->input->post('comment');
            $data['year']    = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            if($this->input->post('class_id') =='-1')
            {
                $classes = $this->db->get('class')->result();
                foreach ($classes as $key => $value) {
                    $data['class_id'] = $value->class_id;
                    $this->db->insert('exam', $data);
                }
            }
            else{

            $data['class_id'] = $this->input->post('class_id');
            $this->db->insert('exam', $data);
           }
            //log
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
                 $section = $this->db->get_where('section' , array('section_id' => $section_id))->row()->name;
                 $data['description']    =   'New Exam '.$this->input->post('name').' has been added.';
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $data['status']       =  1; 
                 $this->db->insert('log' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/exam/', 'refresh');
        }
        if ($param1 == 'edit' && $param2 == 'do_update') {
            $data['name']    = $this->input->post('name');
            $data['date']    = $this->input->post('date');
            $data['total_mark']    = $this->input->post('total_mark');
            $data['comment'] = $this->input->post('comment');
            $data['year']    = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            
            $this->db->where('exam_id', $param3);
            $this->db->update('exam', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/exam/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('exam', array(
                'exam_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
          
            $exam = $this->db->get_where('exam' , array('exam_id' => $param2 ))->row()->name;
            $this->db->where('exam_id', $param2);
            $this->db->delete('exam');
            //log
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $data['description']    =   '<font color="red">Exam '.$exam.' details deleted.</font>';
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $data['status']       =  1; 
                 $this->db->insert('log' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/exam/', 'refresh');
        }
        $page_data['exams']      = $this->db->get('exam')->result_array();
        $page_data['page_name']  = 'exam';
        $page_data['page_title'] = get_phrase('manage_exam');
        $this->load->view('backend/index', $page_data);
    }
   /*** Default Numbers -Krish ***/
   function default_numbers($param1 = '',$param2 = ''){
     if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

    if ($param1 == 'create') {
        $data['name']   = $this->input->post('name');
            $data['designation']   = $this->input->post('designation');
            $data['number']     = $this->input->post('number');
            $this->db->insert('default_sms', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added successfully'));
            redirect(base_url() . 'index.php?admin/default_numbers', 'refresh');
    }
    if ($param1 == 'delete') {
            $this->db->where('id', $param2);
            $this->db->delete('default_sms');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/default_numbers', 'refresh');
    }
    $page_data['dNumbers']      = $this->db->get('default_sms')->result_array();
    $page_data['page_name']  = 'default_numbers';
        $page_data['page_title'] = get_phrase('default_numbers');
        $this->load->view('backend/index', $page_data);
   }
  /****** SEND EXAM MARKS VIA SMS ********/
    function exam_marks_sms($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'send_sms') {

            $exam_id    =   $this->input->post('exam_id');
            $section_id = $this->input->post('section_id');
            $class_id   =   $this->input->post('class_id');
            $receiver   =   $this->input->post('receiver');
            if ($exam_id != '' && $class_id != '' && $receiver != '' && $section_id !='') {
            // get all the students of the selected class
            $students = $this->db->get_where('enroll' , array(
                'class_id' => $class_id,
                'section_id' => $section_id,
                    'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
            ))->result_array();
            // get the marks of the student for selected exam
            foreach ($students as $row) {
                if ($receiver == 'student')
                    $receiver_phone = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->phone;
                if ($receiver == 'parent') {
                    $parent_id =  $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->parent_id;
                    if($parent_id != '' || $parent_id != null) {
                        $receiver_phone = $this->db->get_where('parent' , array('parent_id' => $row['parent_id']))->row()->phone;
                        if($receiver_phone == null){
                          $this->session->set_flashdata('error_message' , get_phrase('parent_phone_number_is_not_found'));
                        }
                    }
                }
                $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                $this->db->where('exam_id' , $exam_id);
                $this->db->where('student_id' , $row['student_id']);
                $this->db->where('year', $running_year);
                $marks = $this->db->get('mark')->result_array();
                $student_name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
                $exam_name       = $this->db->get_where('exam' , array('exam_id' => $this->input->post('exam_id')))->row()->name;
                $message='';
                $message .="".$student_name." \n"; 
                $message .="Exam:".$exam_name." \n"; 
                foreach ($marks as $row2) {
                     
                    $subject       = $this->db->get_where('subject' , array('subject_id' => $row2['subject_id']))->row()->name;
                    $mark_obtained = $row2['mark_obtained'];
                    
                    $message      .= $subject . ' : ' . $mark_obtained ." \n";
                }
                // send sms
              $this->sms_model->send_sms( $message , $receiver_phone );
            }
            
       
            $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
          }
          else{
            $this->session->set_flashdata('error_message' , get_phrase('select_all_the_fields'));
          }
           //log
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
                 $section = $this->db->get_where('section' , array('section_id' => $section_id))->row()->name;
                 $exam = $this->db->get_where('exam',['exam_id' =>$exam_id])->row()->name;
                 $subject = $this->db->get_where('subject',['subject_id' =>$subject_id])->row()->name;
                 $data['description']    =   'Exam marks sent successfully <br> Class: '.$class.'   section: '.$section.'   Exam : '.$exam.'';
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $data['status']       =  5; 
                 $this->db->insert('log' , $data);
            redirect(base_url() . 'index.php?admin/exam_marks_sms' , 'refresh');
        }

        $page_data['page_name']  = 'exam_marks_sms';
        $page_data['page_title'] = get_phrase('send_marks_by_sms');
        $this->load->view('backend/index', $page_data);
    }

    /****MANAGE EXAM MARKS*****/
    function marks2($exam_id = '', $class_id = '', $subject_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['subject_id'] = $this->input->post('subject_id');
            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0 && $page_data['subject_id'] > 0) {
                redirect(base_url() . 'index.php?admin/marks2/' . $page_data['exam_id'] . '/' . $page_data['class_id'] . '/' . $page_data['subject_id'], 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose exam, class and subject');
                redirect(base_url() . 'index.php?admin/marks2/', 'refresh');
            }
        }
        if ($this->input->post('operation') == 'update') {
            $students = $this->db->get_where('enroll' , array('class_id' => $class_id , 'year' => $running_year))->result_array();
            foreach($students as $row) {
                $data['mark_obtained'] = $this->input->post('mark_obtained_' . $row['student_id']);
                $data['comment']       = $this->input->post('comment_' . $row['student_id']);
                
                $this->db->where('mark_id', $this->input->post('mark_id_' . $row['student_id']));
                $this->db->update('mark', array('mark_obtained' => $data['mark_obtained'] , 'comment' => $data['comment']));
            }
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/marks2/' . $this->input->post('exam_id') . '/' . $this->input->post('class_id') . '/' . $this->input->post('subject_id'), 'refresh');
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['subject_id'] = $subject_id;
        
        $page_data['page_info'] = 'Exam marks';
        
        $page_data['page_name']  = 'marks2';
        $page_data['page_title'] = get_phrase('manage_exam_marks');
        $this->load->view('backend/index', $page_data);
    }

    function marks_manage()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['page_name']  =   'marks_manage';
        $page_data['page_title'] = get_phrase('manage_exam_marks');
        $this->load->view('backend/index', $page_data);
    }

    function marks_manage_view($exam_id = '' , $class_id = '' , $section_id = '' , $subject_id = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['exam_id']    =   $exam_id;
        $page_data['class_id']   =   $class_id;
        $page_data['subject_id'] =   $subject_id;
        $page_data['section_id'] =   $section_id;
        $page_data['page_name']  =   'marks_manage_view';
        $page_data['page_title'] = get_phrase('manage_exam_marks');
        $this->load->view('backend/index', $page_data);
    }

    function marks_selector()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $data['exam_id']    = $this->input->post('exam_id');
        $data['class_id']   = $this->input->post('class_id');
        $data['section_id'] = $this->input->post('section_id');
        $data['subject_id'] = $this->input->post('subject_id');
        $data['year']       = $this->db->get_where('settings' , array('type'=>'running_year'))->row()->description;
        $query = $this->db->get_where('mark' , array(
                    'exam_id' => $data['exam_id'],
                        'class_id' => $data['class_id'],
                            'section_id' => $data['section_id'],
                                'subject_id' => $data['subject_id'],
                                    'year' => $data['year']
                ));
        if($query->num_rows() < 1) {
            $students = $this->db->get_where('enroll' , array(
                'class_id' => $data['class_id'] , 'section_id' => $data['section_id'] , 'year' => $data['year']
            ))->result_array();
            foreach($students as $row) {
                $data['student_id'] = $row['student_id'];
                $this->db->insert('mark' , $data);
            }
        }
        redirect(base_url() . 'index.php?admin/marks_manage_view/' . $data['exam_id'] . '/' . $data['class_id'] . '/' . $data['section_id'] . '/' . $data['subject_id'] , 'refresh');
        
    }
//Krish
    function marks_update($exam_id = '' , $class_id = '' , $section_id = '' , $subject_id = '')
    {
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $marks_of_students = $this->db->get_where('mark' , array(
            'exam_id' => $exam_id,
                'class_id' => $class_id,
                    'section_id' => $section_id,
                        'year' => $running_year,
                            'subject_id' => $subject_id
        ))->result_array();
        if($this->input->post('total_mark')!='')
             $total  = $this->input->post('total_mark');
        else
             $total = $this->db->get_where('exam',['exam_id' =>$exam_id])->row()->total_mark;
        foreach($marks_of_students as $row) {
            $obtained_marks = $this->input->post('marks_obtained_'.$row['mark_id']);
            $comment = $this->input->post('comment_'.$row['mark_id']);
            $percentage = ($obtained_marks/$total)*100;
            $this->db->where('mark_id' , $row['mark_id']);
            $this->db->update('mark' , array('mark_obtained' => $obtained_marks ,'mark_total'=>$total,'percentage' => $percentage , 'comment' => $comment));
        }
          //log
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
                 $section = $this->db->get_where('section' , array('section_id' => $section_id))->row()->name;
                 $exam = $this->db->get_where('exam',['exam_id' =>$exam_id])->row()->name;
                 $subject = $this->db->get_where('subject',['subject_id' =>$subject_id])->row()->name;
                 $data['description']    =   'Mark of '.$class.' '.$section.' added<br>Exam : '.$exam.'<br>Subject : '.$subject;
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $data['status']       =  1; 
                 $this->db->insert('log' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('marks_updated'));
        redirect(base_url().'index.php?admin/marks_manage_view/'.$exam_id.'/'.$class_id.'/'.$section_id.'/'.$subject_id , 'refresh');
    }

    function marks_get_subject($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/admin/marks_get_subject' , $page_data);
    }

    // TABULATION SHEET
    function tabulation_sheet($class_id = '' ,$section_id = '', $exam_id = '') {
         if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?admin/tabulation_sheet/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?admin/tabulation_sheet/', 'refresh');
            }
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'Exam marks';
        
        $page_data['page_name']  = 'tabulation_sheet';
        $page_data['page_title'] = get_phrase('exam_report');
        $this->load->view('backend/index', $page_data);
    
    }

    function tabulation_sheet_print_view($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['exam_id']  = $exam_id;
        $this->load->view('backend/admin/tabulation_sheet_print_view' , $page_data);
    }
    function examwise_rank_sheet_print_view($class_id = '' ,$section_id = '', $exam_id = '') {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['exam_id']  = $exam_id;
        $this->load->view('backend/admin/examwise_rank_sheet_print_view' , $page_data);
    }

    function subject_report($class_id = '' ,$section_id = '', $exam_id = '') {
        
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?admin/subject_report/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?admin/subject_report/', 'refresh');
            }
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'subject_report';
        
        $page_data['page_name']  = 'subject_report';
        $page_data['page_title'] = get_phrase('subject_report');
        $this->load->view('backend/index', $page_data);    
    }

    function get_subject_details(){
        $this->db->select('student.name as name,student.student_id,subject.name as sname,mark_obtained,exam.name as exname,exam.exam_id,roll,exam.total_mark as exam_total');
        $this->db->join('student','student.student_id = mark.student_id');
        $this->db->join('subject','subject.subject_id = mark.subject_id');
        $this->db->join('exam','exam.exam_id = mark.exam_id');
        $this->db->join('enroll','enroll.student_id = student.student_id');
        $this->db->order_by('roll');
        $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $this->input->post('subject_id'),'mark.class_id' => $this->input->post('class_id'),'mark.section_id' => $this->input->post('section_id')])->result();
        foreach($data as $key =>$val){
            $arr['exam'][$val->exam_id]=$val->exname;
            $arr['student'][$val->roll]['name']=$val->name;
            $arr['mark'][$val->roll][$val->exam_id]=$val->mark_obtained;
            $arr['roll'][$val->roll]=$val->roll;
            $percentage = ($val->mark_obtained/$val->exam_total)*100;
            $grade = $this->crud_model->get_grade($percentage);
            $arr['grade'][$val->roll][$val->exam_id]=$grade['name'];
        }
        //usort($arr['student'], 'sort_by_order');
        echo (json_encode($arr));
        //json_encode($this->db->get_where('section', $data));
    }

    function subject_report_print_view($class_id = '', $section_id = '', $subject_id = ''){
        if($class_id!='' && $section_id !='' && $subject_id !=''){
            $this->db->select('student.name as name,student.student_id,subject.name as sname,mark_obtained,exam.name as exname,exam.exam_id,roll,exam.total_mark as exam_total');
            $this->db->join('student','student.student_id = mark.student_id');
            $this->db->join('subject','subject.subject_id = mark.subject_id');
            $this->db->join('exam','exam.exam_id = mark.exam_id');
            $this->db->join('enroll','enroll.student_id = student.student_id');
            $this->db->order_by('roll');
            $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $subject_id,'mark.class_id' => $class_id,'mark.section_id' => $section_id])->result();
            $page_data['subject_id']    = $subject_id;
            $page_data['class_id']   = $class_id;
            $page_data['section_id'] = $section_id;
            foreach($data as $key =>$val){
                $page_data['exam'][$val->exam_id]=$val->exname;
                $page_data['student'][$val->roll]['name']=$val->name;
                $page_data['mark'][$val->roll][$val->exam_id]=$val->mark_obtained;
                $page_data['roll'][$val->roll]=$val->roll;
                $percentage = ($val->mark_obtained/$val->exam_total)*100;
                $grade = $this->crud_model->get_grade($percentage);
                $page_data['grade'][$val->roll][$val->exam_id]=$grade['name'];
            }
            $this->load->view('backend/admin/subject_report_print_view' , $page_data);
        }
    }

    function exam_wise_ranking($class_id = '' ,$section_id = '', $exam_id = '') {
        
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($this->input->post('operation') == 'selection') {
            $page_data['exam_id']    = $this->input->post('exam_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            
            if ($page_data['exam_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?admin/exam_wise_ranking/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['exam_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?admin/exam_wise_ranking/', 'refresh');
            }
        }
        $page_data['exam_id']    = $exam_id;
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        
        $page_data['page_info'] = 'Exam Wise Ranking';
        
        $page_data['page_name']  = 'exam_wise_ranking';
        $page_data['page_title'] = get_phrase('exam_wise_ranking');
        $this->load->view('backend/index', $page_data);
    
    }

    function subject_ranking($class_id = '' ,$section_id = '', $subject_id = '') {
        
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($this->input->post('operation') == 'selection') {
            $page_data['subject_id']    = $this->input->post('subject_id');
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            
            if ($page_data['subject_id'] > 0 && $page_data['class_id'] > 0 && $page_data['section_id'] > 0) {
                redirect(base_url() . 'index.php?admin/subject_ranking/' . $page_data['class_id'] . '/' .$page_data['section_id'] . '/' . $page_data['subject_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('mark_message', 'Choose class and exam');
                redirect(base_url() . 'index.php?admin/subject_ranking/', 'refresh');
            }
        }
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['subject_id'] = $subject_id;
        
        $page_data['page_info'] = 'Subject Ranking';
        
        $page_data['page_name']  = 'subject_ranking';
        $page_data['page_title'] = get_phrase('subject_ranking');
        if($class_id!='' && $section_id !='' && $subject_id !=''){
            $this->db->select('student.name as name,student.student_id,subject.name as sname,mark_obtained,exam.name as exname,exam.exam_id,roll');
            $this->db->join('student','student.student_id = mark.student_id');
            $this->db->join('subject','subject.subject_id = mark.subject_id');
            $this->db->join('exam','exam.exam_id = mark.exam_id');
            $this->db->join('enroll','enroll.student_id = student.student_id');
            $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $subject_id,'mark.class_id' => $class_id,'mark.section_id' => $section_id])->result();
            $page_data['subject_id']    = $subject_id;
            $page_data['class_id']   = $class_id;
            $page_data['section_id'] = $section_id;
            foreach($data as $key =>$val){
                $page_data['exam'][$val->exam_id]=$val->exname;
                $page_data['student'][$val->roll]['name']=$val->name;
                $page_data['mark'][$val->roll][$val->exam_id]=$val->mark_obtained;
                $page_data['roll'][$val->roll]=$val->roll;
            }
        }
        $this->load->view('backend/index', $page_data);
    
    }
    function subject_ranking_print_view($class_id = '' ,$section_id = '', $subject_id = '') {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['subject_id']  = $subject_id;
        $this->load->view('backend/admin/subject_ranking_print_view' , $page_data);

    }

    function get_sectiones(){
        $class_id =$this->input->post('class_id');
        if($class_id){
            $data['class_id']=$class_id;
            echo (json_encode($this->db->get_where('section', $data)->result()));
        }
        else{
            $data = array();
            if($class_id ==0){
                $classes = $this->db->get_where('class')->result_array();
                foreach ($classes as $key=>$row) {
                    $sections = $this->db->get_where('section' , array(
                        'class_id' => $row['class_id']
                    ))->result_array();
                    $data[$key]['class_id'] = $row['class_id'];
                    $data[$key]['class'] = $row['name'];
                     $data[$key]['section'] = array();
                    foreach ($sections as $key1=>$row1) {
                        $data[$key]['section'][$key1]['id'] = $row1['section_id'];
                        $data[$key]['section'][$key1]['name'] = $row1['name'];
                    }
                }
            }
            echo (json_encode($data));
        }
    }

    function get_subject_details_order(){
        $this->db->join('student','student.student_id = mark.student_id');
        $this->db->group_by('student.student_id');
        $this->db->order_by('mark_obtained','DESC');
        $data=$this->db->get_where('mark', [ 'mark.subject_id'=> $this->input->post('subject_id'),'mark.class_id' => $this->input->post('class_id'),'section_id' => $this->input->post('section_id')])->result();
        echo (json_encode($data));
        //json_encode($this->db->get_where('section', $data));
    }
    function get_exam_order(){
        $this->db->join('student','student.student_id = mark.student_id');
        $this->db->group_by('student.student_id');
        $vals=$this->db->get_where('mark', [ 'mark.exam_id'=> $this->input->post('exam_id'),'mark.class_id' => $this->input->post('class_id'),'section_id' => $this->input->post('section_id')])->result();
        foreach($vals as $key=>$val){
        $this->db->join('student','student.student_id = mark.student_id');   
        $data[$key]=$this->db->get_where('mark',['student_id'=>$val->id])->result;
      }
        echo (json_encode($data));
    }
    
    /****MANAGE GRADES*****/
    function grade($param1 = '', $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['name']        = $this->input->post('name');
            $data['grade_point'] = $this->input->post('grade_point');
            $data['mark_from']   = $this->input->post('mark_from');
            $data['mark_upto']   = $this->input->post('mark_upto');
            $data['comment']     = $this->input->post('comment');
            $this->db->insert('grade', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/grade/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']        = $this->input->post('name');
            $data['grade_point'] = $this->input->post('grade_point');
            $data['mark_from']   = $this->input->post('mark_from');
            $data['mark_upto']   = $this->input->post('mark_upto');
            $data['comment']     = $this->input->post('comment');
            
            $this->db->where('grade_id', $param2);
            $this->db->update('grade', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/grade/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('grade', array(
                'grade_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('grade_id', $param2);
            $this->db->delete('grade');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/grade/', 'refresh');
        }
        $page_data['grades']     = $this->db->get('grade')->result_array();
        $page_data['page_name']  = 'grade';
        $page_data['page_title'] = get_phrase('manage_grade');
        $this->load->view('backend/index', $page_data);
    }
    
    /**********MANAGING CLASS ROUTINE******************/
    function class_routine($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['class_id']       = $this->input->post('class_id');
            if($this->input->post('section_id') != '') {
                $data['section_id'] = $this->input->post('section_id');
            }
            $data['subject_id']     = $this->input->post('subject_id');
            $data['period_number']  = $this->input->post('period');
            $data['time_start']     = $this->input->post('time_start') + (12 * ($this->input->post('starting_ampm') - 1));
            $data['time_end']       = $this->input->post('time_end') + (12 * ($this->input->post('ending_ampm') - 1));
            $data['time_start_min'] = $this->input->post('time_start_min');
            $data['time_end_min']   = $this->input->post('time_end_min');
            $data['day']            = $this->input->post('day');
            $data['year']           = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('class_routine', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/class_routine_add/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['class_id']       = $this->input->post('class_id');
            if($this->input->post('section_id') != '') {
                $data['section_id'] = $this->input->post('section_id');
            }
            $data['period_number']  = $this->input->post('period');
            $data['subject_id']     = $this->input->post('subject_id');
            $data['time_start']     = $this->input->post('time_start') + (12 * ($this->input->post('starting_ampm') - 1));
            $data['time_end']       = $this->input->post('time_end') + (12 * ($this->input->post('ending_ampm') - 1));
            $data['time_start_min'] = $this->input->post('time_start_min');
            $data['time_end_min']   = $this->input->post('time_end_min');
            $data['day']            = $this->input->post('day');
            $data['year']           = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            
            $this->db->where('class_routine_id', $param2);
            $this->db->update('class_routine', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/class_routine_view/' . $data['class_id'], 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('class_routine', array(
                'class_routine_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $class_id = $this->db->get_where('class_routine' , array('class_routine_id' => $param2))->row()->class_id;
            $this->db->where('class_routine_id', $param2);
            $this->db->delete('class_routine');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/class_routine_view/' . $class_id, 'refresh');
        }
        
    }

    function class_routine_add()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['page_name']  = 'class_routine_add';
        $page_data['page_title'] = get_phrase('add_class_routine');
        $this->load->view('backend/index', $page_data);
    }

    function class_routine_view($class_id)
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['page_name']  = 'class_routine_view';
        $page_data['class_id']  =   $class_id;
        $page_data['page_title'] = get_phrase('class_routine');
        $this->load->view('backend/index', $page_data);
    }

    function class_routine_print_view($class_id , $section_id)
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['class_id']   =   $class_id;
        $page_data['section_id'] =   $section_id;
        $this->load->view('backend/admin/class_routine_print_view' , $page_data);
    }

    function get_class_section_subject($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/admin/class_routine_section_subject_selector' , $page_data);
    }

    function section_subject_edit($class_id , $class_routine_id)
    {
        $page_data['class_id']          =   $class_id;
        $page_data['class_routine_id']  =   $class_routine_id;
        $this->load->view('backend/admin/class_routine_section_subject_edit' , $page_data);
    }
    //staff attendance - kriss
    function staff_attendance(){
        $page_data['page_name']  =  'staff_attendance';
        $page_data['page_title'] =  get_phrase('staff_attendance');
        $this->load->view('backend/index', $page_data);
    }
    function staff_attendance_selector()
    {
        $data['year']       = $this->input->post('year');
        $data['timestamp']  = strtotime($this->input->post('timestamp'));

        $query = $this->db->get_where('teacher_attendance' ,array(
                    'year'=>$data['year'],
                        'timestamp'=>$data['timestamp']
        ));
        if($query->num_rows() < 1) {
            
            $staffs = $this->db->get('teacher')->result_array();
          
            foreach($staffs as $row) {
                $attn_data['teacher_id'] = $row['teacher_id'];
                $attn_data['year']       = $data['year'];
                $attn_data['timestamp']  = $data['timestamp'];
                $this->db->insert('teacher_attendance' , $attn_data);  
            }
            
        }
        redirect(base_url().'index.php?admin/manage_staff_attendance_view/'.$data['timestamp'],'refresh');
    }
    function manage_staff_attendance_view($timestamp = '')
    {
        if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');
        
        $page_data['timestamp'] = $timestamp;
        $page_data['page_name'] = 'manage_staff_attendance_view';
        
        $page_data['page_title'] = get_phrase('manage_staff_attendance');
        $this->load->view('backend/index', $page_data);
    }
    function staff_attendance_update($timestamp = ''){
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $active_sms_service = $this->db->get_where('settings' , array('type' => 'active_sms_service'))->row()->description;
        
        $attendance_of_staffs = $this->db->get_where('teacher_attendance' , array(
            'year'=>$running_year,'timestamp'=>$timestamp
        ))->result_array();
        foreach($attendance_of_staffs as $row) {
            $attendance_status = $this->input->post('status_'.$row['teacher_attendance_id']);
            $data['attendance'] = $attendance_status;
            $this->db->where('teacher_attendance_id' , $row['teacher_attendance_id']);
            $this->db->update('teacher_attendance' , $data);

           //sms
         if($row['attendance'] == 0){
           if ($active_sms_service != '' || $active_sms_service != 'disabled') {
             $teacher_name   = $this->db->get_where('teacher' , array('teacher_id' => $row['teacher_id']))->row()->name;
             $message ='You are absent on today ('. date("d/m/y",$timestamp).'). If not, Please contact the office.';
             $receiver_phone = $this->db->get_where('teacher' , array('teacher_id' => $row['teacher_id']))->row()->phone;
            // $this->sms_model->send_sms($message,$receiver_phone);
           }
         }
       }
        $data=array();
        $data['user_id']       =   $this->session->userdata('login_user_id');
        $data['name']       =   $this->session->userdata('name');
        $data['device']       =   'web';
        $data['description']    =   'Staff attendance';
        $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
        $data['status']    =   3;
        $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $this->db->insert('log' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('attendance_updated'));
        redirect(base_url().'index.php?admin/manage_staff_attendance_view/'.$timestamp, 'refresh');
    }
    function staff_attendance_report(){
         $page_data['month']        = date('m');
         $page_data['page_name']    = 'staff_attendance_report';
         $page_data['page_title']   = get_phrase('staff_attendance_report');
         $this->load->view('backend/index',$page_data);
    }
    function staff_attendance_report_selector(){
        $data['month']  = $this->input->post('month');
        redirect(base_url().'index.php?admin/staff_attendance_report_view/'.$data['month'],'refresh');
    }
    function staff_attendance_report_view($month=''){
       if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');
        
        $page_data['month']    = $month;
        $page_data['page_name'] = 'staff_attendance_report_view';
        $page_data['page_title'] = get_phrase('attendance_report');
        $this->load->view('backend/index', $page_data);
   }
   function staff_attendance_report_print_view($month=''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['month'] = $month;
        $this->load->view('backend/admin/staff_attendance_report_print_view' , $page_data);
   }
   function staff_attendance_period(){
       $page_data['page_name']    = 'staff_attendance_report_period';
       $page_data['page_title']   = get_phrase('attendance_report');
       $this->load->view('backend/index',$page_data);
   }
   function staff_attendance_report_period_selector()
    { 
        $data['year']       = $this->input->post('year');
        $data['startdate']  = $this->input->post('start_date');
        $data['enddate']  = $this->input->post('end_date');
        redirect(base_url().'index.php?admin/staff_attendance_report_period_view'.'/'.$data['startdate'].'/'.$data['enddate'],'refresh');
    }
    function staff_attendance_report_period_view($startdate= '' ,$enddate= '') {
         
        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $page_data['startdates'] = strtotime($startdate);
        $page_data['enddates'] = strtotime($enddate);
        $page_data['page_name'] = 'staff_attendance_report_period_view';
        
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $page_data['page_title'] = get_phrase('attendance_report');
        $this->load->view('backend/index', $page_data);
     }
     function staff_attendance_report_period_print_view($startdate = '', $enddate = '') {
         
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $this->load->view('backend/admin/staff_attendance_report_period_print_view' , $page_data);
    }
    function manage_attendance()
    {
        if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');
        
        $page_data['page_name']  =  'manage_attendance';
        $page_data['page_title'] =  get_phrase('manage_attendance_of_class');
        $this->load->view('backend/index', $page_data);
    }

    function manage_attendance_view($class_id = '' , $section_id = '' , $timestamp = '')
    {
        if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');
        $class_name = $this->db->get_where('class' , array(
            'class_id' => $class_id
        ))->row()->name;
        $page_data['class_id'] = $class_id;
        $page_data['timestamp'] = $timestamp;
        $page_data['page_name'] = 'manage_attendance_view';
        $section_name = $this->db->get_where('section' , array(
            'section_id' => $section_id
        ))->row()->name;
        $page_data['section_id'] = $section_id;
        $page_data['page_title'] = get_phrase('manage_attendance_of_class') . ' ' . $class_name . ' : ' . get_phrase('section') . ' ' . $section_name;
        $this->load->view('backend/index', $page_data);
    }
    function get_section($class_id) {
          $page_data['class_id'] = $class_id; 
          $this->load->view('backend/admin/manage_attendance_section_holder' , $page_data);
    }
    function approveStudent($studId = '',$classid = ''){
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $data=array('status'=>1);
        
        $this->db->where('student_id',$studId);
        $this->db->update('student',$data);

        $this->db->where('student_id',$studId);
        $this->db->update('enroll',$data);

       
        redirect(base_url().'index.php?admin/pending_student/'.$classid);

        

    }
    function attendance_selector()
    {
        $data['class_id']   = $this->input->post('class_id');
        $data['year']       = $this->input->post('year');
        $data['timestamp']  = strtotime($this->input->post('timestamp'));
        $data['section_id'] = $this->input->post('section_id');
        $query = $this->db->get_where('attendance' ,array(
            'class_id'=>$data['class_id'],
                'section_id'=>$data['section_id'],
                    'year'=>$data['year'],
                        'timestamp'=>$data['timestamp']
        ));
        if($query->num_rows() < 1) {
            $this->db->join('student','enroll.student_id = student.student_id');
            $this->db->where(['student.status'=>1,'student.alumni' =>0]);
            $students = $this->db->get_where('enroll' , array(
                'class_id' => $data['class_id'] , 'section_id' => $data['section_id'] , 'year' => $data['year']
            ))->result_array();
          
            foreach($students as $row) {
                $attn_data['class_id']   = $data['class_id'];
                $attn_data['year']       = $data['year'];
                $attn_data['timestamp']  = $data['timestamp'];
                $attn_data['section_id'] = $data['section_id'];
                $attn_data['student_id'] = $row['student_id'];
                $this->db->insert('attendance' , $attn_data);  
            }
            
        }
        redirect(base_url().'index.php?admin/manage_attendance_view/'.$data['class_id'].'/'.$data['section_id'].'/'.$data['timestamp'],'refresh');
    }
    function get_session_attendance(){
       $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
      $this->db->join('student','student.student_id = attendance.student_id');
      $this->db->join('enroll','enroll.student_id = attendance.student_id');
      $this->db->order_by('roll');
      $attendance_of_students = $this->db->get_where('attendance' , array(
            'attendance.class_id'=>$_POST['class_id'],'attendance.section_id'=>$_POST['section_id'],'attendance.year'=>$running_year,'timestamp'=>strtotime($_POST['timestamp'])
        ))->result_array();
 echo (json_encode($attendance_of_students));
    }
    function attendance_update($class_id = '' , $section_id = '' , $timestamp = '')
    {
        $session = $this->input->post('session');
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $active_sms_service = $this->db->get_where('settings' , array('type' => 'active_sms_service'))->row()->description;
        $this->db->join('student','attendance.student_id = student.student_id');
            $this->db->where('student.status',1);
      $attendance_of_students = $this->db->get_where('attendance' , array(
            'class_id'=>$class_id,'section_id'=>$section_id,'year'=>$running_year,'timestamp'=>$timestamp
        ))->result_array();


       $att_type= $this->db->get_where('settings' , array('type' => 'attendance'))->row()->description;
$message ='';
        foreach($attendance_of_students as $row) {
            $attendance_status = $this->input->post('status_'.$row['attendance_id']);

            if($att_type == 'Session'){
            $sessions = $this->db->get('sessions')->row();
           if(count($sessions)>0){
            $data['attendance_type']=1;
             if($this->input->post('session') == 1){
              if($attendance_status == 1)
               $data['session_one'] = 0.5;
              else
               $data['session_one'] = 0;

            }
           if($this->input->post('session') == 2){
              if($attendance_status == 1)
               $data['session_two'] = 0.5;
              else
              $data['session_two'] = 0;
            }
          }
         }
            $data['status'] = $attendance_status;
            $this->db->where('attendance_id' , $row['attendance_id']);
            $this->db->update('attendance' , $data);
            $attend = $this->db->get_where('attendance',array('attendance_id' => $row['attendance_id']))->row();
          if($att_type == 'Session'){
            if(count($attend)>0){
              $data1['general_attendance'] = $attend->session_one + $attend->session_two;
            }
            $this->db->where('attendance_id' , $row['attendance_id']);
            $this->db->update('attendance' , $data1);
         }else{
              if ($attendance_status == 2)
                  $data1['general_attendance'] = 0;
              else
                 $data1['general_attendance'] = 1;
              $data1['status'] = $this->input->post('status_'.$row['attendance_id']);
              $this->db->where('attendance_id' , $row['attendance_id']);
              $this->db->update('attendance' , $data1);    
         }
            if ($attendance_status == 2) {

                if ($active_sms_service != '' || $active_sms_service != 'disabled') {
                    $student_name   = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
                    $parent_id      = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->parent_id;
                    $receiver_phone = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->phone;
                    if($att_type == 'Session'){
                     $ses = $this->db->get_where('sessions',array('session_id' => $this->input->post('session')))->row()->name;
                     $message        = 'Your child' . ' ' . $student_name . ' is absent in '.$ses.' session on '. date("d/m/y",$timestamp).'. If not, Please contact the office.';
                    }
                    else{
                    $message        = 'Your child' . ' ' . $student_name . ' is absent today ('. date("d/m/y",$timestamp).'). If not, Please contact the office.';
                    }
                    $this->sms_model->send_sms($message,$receiver_phone);
                }
            }
        }

        $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $class_id))->row()->name;
                 $section = $this->db->get_where('section' , array('section_id' => $section_id))->row()->name;
                 $data['description']    =   'Attendance of '.$class.' '.$section.' added';
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['class_id'] = $class_id;
                 $data['section_id'] = $section_id;
                 $data['status'] = 4;
                 $data['date'] =  date("Y-m-d",$timestamp);
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('attendance_updated'));

       redirect(base_url().'index.php?admin/manage_attendance_view/'.$class_id.'/'.$section_id.'/'.$timestamp, 'refresh');
    }
    
    function monitor_attendance($date=''){
        if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $page_data['page_name']  =  'monitor_attendance';
        $page_data['page_title'] =  get_phrase('monitor_attendance');
        $page_data['classes'] =  array();
        $page_data['sections'] =  array();
        $page_data['dates'] =  array();
        $page_data['logs'] =  array();
        $this->db->where('class_id !=',0);
        $this->db->group_by('class_id');
        $classes = $this->db->get('class')->result_array();
        $page_data['seldate'] =  $this->input->post('date');
        if($this->input->post('date') ==''){
            $this->db->order_by('log_id','DESC');
            $this->db->group_by('date');
            $att_dates = $this->db->get_where('log' , ['year'=>$running_year,'status'=>4] )->result_array();
            foreach($att_dates as $att_date){
                foreach($classes as $class){
                    $this->db->group_by('section_id');
                    $sections = $this->db->get_where('section' , ['class_id' => $class['class_id']] )->result_array();
                    foreach($sections as $section){
                        $this->db->order_by('log_id','DESC');
                        $log  = $this->db->get_where('log' , ['year'=>$running_year,'status'=>4,'class_id' => $class['class_id'],'section_id'=>$section['section_id'],'date'=>$att_date['date']] )->row();
                        $data[$att_date['date']][$class['class_id']][$section['section_id']]['user'] = isset($log->name)?$log->name:'-';
                        $data[$att_date['date']][$class['class_id']][$section['section_id']]['class'] = $this->db->get_where('class' , ['class_id' => $class['class_id']] )->row()->name;
                        $data[$att_date['date']][$class['class_id']][$section['section_id']]['section'] = $this->db->get_where('section' , ['section_id' => $section['section_id']] )->row()->name;
                        $data[$att_date['date']][$class['class_id']][$section['section_id']]['created'] = isset($log->timestamp)?$log->timestamp:'-';
                    }
                }
            }
        }
        else{
            foreach($classes as $class){
                    $this->db->group_by('section_id');
                    $sections = $this->db->get_where('section' , ['class_id' => $class['class_id']] )->result_array();
                    foreach($sections as $section){
                        $this->db->order_by('log_id','DESC');
                        $log  = $this->db->get_where('log' , ['year'=>$running_year,'status'=>4,'class_id' => $class['class_id'],'section_id'=>$section['section_id'],'date' =>date('Y-m-d',strtotime($this->input->post('date')))] )->row();
                        $data[$this->input->post('date')][$class['class_id']][$section['section_id']]['user'] = isset($log->name)?$log->name:'-';
                        $data[$this->input->post('date')][$class['class_id']][$section['section_id']]['class'] = $this->db->get_where('class' , ['class_id' => $class['class_id']] )->row()->name;
                        $data[$this->input->post('date')][$class['class_id']][$section['section_id']]['section'] = $this->db->get_where('section' , ['section_id' => $section['section_id']] )->row()->name;
                        $data[$this->input->post('date')][$class['class_id']][$section['section_id']]['created'] = isset($log->timestamp)?$log->timestamp:'-';
                    }
                }
        }
        $page_data['classes'] =  $classes;
        $page_data['sections'] =  $sections;
        $page_data['dates'] =  $att_dates;
        $page_data['logs'] =  $data;
        $this->load->view('backend/index', $page_data);
    }
    /****** DAILY ATTENDANCE *****************/
    function manage_attendance2($date='',$month='',$year='',$class_id='' , $section_id = '' , $session = '')
    {
        if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');

        $active_sms_service = $this->db->get_where('settings' , array('type' => 'active_sms_service'))->row()->description;
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

        
        if($_POST)
        {
            // Loop all the students of $class_id
            $this->db->where('class_id' , $class_id);
            if($section_id != '') {
                $this->db->where('section_id' , $section_id);
            }
            //$session = base64_decode( urldecode( $session ) );
            $this->db->where('year' , $session);
            $students = $this->db->get('enroll')->result_array();
            foreach ($students as $row)
            {
                $attendance_status  =   $this->input->post('status_' . $row['student_id']);

                $this->db->where('student_id' , $row['student_id']);
                $this->db->where('date' , $date);
                $this->db->where('year' , $year);
                $this->db->where('class_id' , $row['class_id']);
                if($row['section_id'] != '' && $row['section_id'] != 0) {
                    $this->db->where('section_id' , $row['section_id']);
                }
                $this->db->where('session' , $session);

                $this->db->update('attendance' , array('status' => $attendance_status));

                if ($attendance_status == 2) {

                    if ($active_sms_service != '' || $active_sms_service != 'disabled') {
                        $student_name   = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
                        $parent_id      = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->parent_id;
                        $receiver_phone = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->phone;
                        $message        = 'Your child' . ' ' . $student_name . ' is absent today. If not, Please contact the office. ';
                        $this->sms_model->send_sms($message,$receiver_phone);
                    }
                }

            }

            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/manage_attendance/'.$date.'/'.$month.'/'.$year.'/'.$class_id.'/'.$section_id.'/'.$session , 'refresh');
        }
        $page_data['date']       =  $date;
        $page_data['month']      =  $month;
        $page_data['year']       =  $year;
        $page_data['class_id']   =  $class_id;
        $page_data['section_id'] =  $section_id;
        $page_data['session']    =  $session;
        
        $page_data['page_name']  =  'manage_attendance';
        $page_data['page_title'] =  get_phrase('manage_daily_attendance');
        $this->load->view('backend/index', $page_data);
    }
    function attendance_selector2()
    {
        //$session = $this->input->post('session');
        //$encoded_session = urlencode( base64_encode( $session ) );
        redirect(base_url() . 'index.php?admin/manage_attendance/'.$this->input->post('date').'/'.
                    $this->input->post('month').'/'.
                        $this->input->post('year').'/'.
                            $this->input->post('class_id').'/'.
                                $this->input->post('section_id').'/'.
                                    $this->input->post('session') , 'refresh');
    }
        ///////ATTENDANCE REPORT /////
     function attendance_report() {
         $page_data['month']        = date('m');
         $page_data['page_name']    = 'attendance_report';
         $page_data['page_title']   = get_phrase('attendance_report');
         $this->load->view('backend/index',$page_data);
     }
    //krish
     function attendance_report_period() {
         $page_data['page_name']    = 'attendance_report_period';
         $page_data['page_title']   = get_phrase('attendance_report');
         $this->load->view('backend/index',$page_data);
     }
    //krish
     function attendance_report_period_view($class_id = '' , $section_id = '', $startdate= '' ,$enddate= '') {
         if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');

        $class_name = $this->db->get_where('class' , array(
            'class_id' => $class_id
        ))->row()->name;
        $page_data['class_id'] = $class_id;
        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $page_data['startdates'] = strtotime($startdate);
        $page_data['enddates'] = strtotime($enddate);
        $page_data['page_name'] = 'attendance_report_period_view';
        $section_name = $this->db->get_where('section' , array(
            'section_id' => $section_id
        ))->row()->name;
        $page_data['section_id'] = $section_id;
        $page_data['running_year']               = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $page_data['page_title'] = get_phrase('attendance_report_of_class') . ' ' . $class_name . ' : ' . get_phrase('section') . ' ' . $section_name;
        $this->load->view('backend/index', $page_data);
     }
     //krish
     function attendance_report_period_selector()
    {
        $data['class_id']   = $this->input->post('class_id');
        $data['year']       = $this->input->post('year');
        $data['section_id'] = $this->input->post('section_id');
        $data['startdate']  = $this->input->post('start_date');
        $data['enddate']  = $this->input->post('end_date');
        redirect(base_url().'index.php?admin/attendance_report_period_view/'.$data['class_id'].'/'.$data['section_id'].'/'.$data['startdate'].'/'.$data['enddate'],'refresh');
    }
     function attendance_report_view($class_id = '' , $section_id = '', $month = '') {
         if($this->session->userdata('admin_login')!=1)
            redirect(base_url() , 'refresh');
        $class_name = $this->db->get_where('class' , array(
            'class_id' => $class_id
        ))->row()->name;
        $page_data['class_id'] = $class_id;
        $page_data['month']    = $month;
        $page_data['page_name'] = 'attendance_report_view';
        $section_name = $this->db->get_where('section' , array(
            'section_id' => $section_id
        ))->row()->name;
        $page_data['section_id'] = $section_id;
        $page_data['page_title'] = get_phrase('attendance_report_of_class') . ' ' . $class_name . ' : ' . get_phrase('section') . ' ' . $section_name;
        $this->load->view('backend/index', $page_data);
     }
     function attendance_report_print_view($class_id ='' , $section_id = '' , $month = '') {
          
        $page_data['class_id'] = $class_id;
        $page_data['section_id']  = $section_id;
        $page_data['month'] = $month;
        $this->load->view('backend/admin/attendance_report_print_view' , $page_data);
    }
    function attendance_report_period_print_view($class_id ='' , $section_id = '' , $startdate = '', $enddate = '') {
          
        $page_data['class_id'] = $class_id;
        $page_data['section_id']  = $section_id;
        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $this->load->view('backend/admin/attendance_report_period_print_view' , $page_data);
    }
   function attendance_percentage_report($class_id ='' , $section_id = '' , $startdate = '', $enddate = '') {
          
        $page_data['class_id'] = $class_id;
        $page_data['section_id']  = $section_id;
        $page_data['startdate'] = $startdate;
        $page_data['enddate'] = $enddate;
        $this->load->view('backend/admin/attendance_percentage_report' , $page_data);
    }
    function attendance_report_session_print_view($class_id ='' , $section_id = '' , $month = '') {
          
        $page_data['class_id'] = $class_id;
        $page_data['section_id']  = $section_id;
        $page_data['month'] = $month;
        $this->load->view('backend/admin/attendance_report_session_print_view' , $page_data);
    }
     
    function attendance_report_selector()
    {
        $data['class_id']   = $this->input->post('class_id');
        $data['year']       = $this->input->post('year');
        $data['month']  = $this->input->post('month');
        $data['section_id'] = $this->input->post('section_id');
        redirect(base_url().'index.php?admin/attendance_report_view/'.$data['class_id'].'/'.$data['section_id'].'/'.$data['month'],'refresh');
    }
    function student_payment_print($invoice_id,$class_id,$section_id){
        $page_data['running_year'] = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
        $this->db->where(['invoice_id'=> $invoice_id]);
        $invoicepayment = $this->db->get('invoice')->result_array();
        $page_data['invoice'] = $invoicepayment;
        $page_data['classid'] = $class_id;
        $page_data['sectionid'] = $section_id;
        $page_data['page_name']    = 'student_payment_print';
        $page_data['page_title']   = get_phrase('student_payment');
        $this->load->view('backend/index', $page_data);
    }
    /******MANAGE BILLING / INVOICES WITH STATUS*****/
    function invoice($param1 = '', $param2 = '', $param3 = '')
    {  
        
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['student_id']         = $this->input->post('student_id');
            $data['term_id']        =   $this->input->post('term');
            $data['invoice_no']        =   $this->input->post('invoice_no');
            $data['description']        = $this->input->post('description');
            $data['amount']             = $this->input->post('amount');
            $data['amount_paid']        = $this->input->post('amount_paid');
            $data['due']                = $data['amount'] - $data['amount_paid'];
            $data['status']             = $this->input->post('status');
            $data['creation_timestamp'] = strtotime($this->input->post('date'));
            $data['due_date'] = strtotime($this->input->post('due_date'));
            $data['fine_id'] = strtotime($this->input->post('fine_id'));
            $data['year']               = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

            $this->db->insert('invoice', $data);
            $invoice_id = $this->db->insert_id();
            //krish

            foreach($_POST['title'] as $item){ 
            $cat_id = $this->db->get_where('income_category',['name' => $item])->row()->income_category_id;
            $data1['invoice_id']        =   $invoice_id;
            $data1['income_category_id']  =  $cat_id;
            $item = preg_replace('/\s+/', '', $item);
            $data1['amount']            =  $this->input->post($item);
            $data1['due'] = $this->input->post($item) - $this->input->post('pay_'.$item);
            $this->db->insert('invoice_student_master' , $data1);
            }
            
            $data2['invoice_id']        =   $invoice_id;
            $data2['student_id']        =   $this->input->post('student_id');
            
            $data2['description']       =   $this->input->post('description');
            $data2['payment_type']      =  'income';
            $data2['method']            =   $this->input->post('method');
            $data2['bank']            =   $this->input->post('bank');
            $data2['payment_ref']       =   $this->input->post('payment_ref');
            $data2['payment_remarks']       =   $this->input->post('payment_remark');
            $data2['cheque_dd']       =   $this->input->post('cheque');
            $data2['payment_date']       =   $this->input->post('date_payment');
            $data2['amount']            =   $this->input->post('amount_paid');
            $data2['timestamp']         =   strtotime($this->input->post('date'));
            $data2['year']              =  $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

            $this->db->insert('payment' , $data2);
            $this->db->select('phone');
            //krish
            $data=$this->db->get_where('student',['student_id' =>$this->input->post('student_id')])->result();
            if(isset($data)){
                //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $this->input->post('class_id')))->row()->name;
                 $student = $this->db->get_where('student' , array('student_id' => $this->input->post('student_id')))->row()->name;
                 $datas['description']    =   'New invoice has been created for student '.$student.' ,class '.$class.'.';
                 $datas['status']    =   2;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
                //sms
                $message = 'Thank you for your Payment. Your Invoice has been created. Total Amount is '.$this->input->post('amount').'. Paid amount is '.$this->input->post('amount_paid').'. Date : '.date('d-m-Y');
                 
                $this->sms_model->send_sms($message , $data[0]->phone);
            }
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/student_payment_print/'.$invoice_id, 'refresh');
        }

        else if ($param1 == 'create_mass_invoice') {
            foreach ($this->input->post('student_id') as $id) {
                $this->db->order_by('invoice_id','DESC');
                $this->db->limit(1);
                $invoiceno = $this->db->get('invoice')->row()->invoice_no;
                if($invoiceno == 0 || $invoiceno == '')
                    $invoiceno =  1;
                else
                    $invoiceno +=1;
                $data['student_id']         = $id;
                $data['invoice_no']         = $invoiceno;
                $data['term_id']        =   $this->input->post('term');
                $data['description']        = $this->input->post('description');
                $data['amount']             = $this->input->post('amount');
                $data['amount_paid']        = $this->input->post('amount_paid');
                $data['due']                = $data['amount'] - $data['amount_paid'];
                $data['status']             = $this->input->post('status');
                $data['creation_timestamp'] = strtotime($this->input->post('date'));
                $data['fine_id'] = strtotime($this->input->post('fine_id'));
                $data['due_date'] = strtotime($this->input->post('due_date'));
                $data['year']               = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                
                $this->db->insert('invoice', $data);
                $invoice_id = $this->db->insert_id();
                foreach($_POST['titles'] as $item){ 
                    $cat_id = $this->db->get_where('income_category',['name' => $item])->row()->income_category_id;
                    $data1['invoice_id']        =   $invoice_id;
                    $data1['income_category_id']  =  $cat_id;
                    $item = preg_replace('/\s+/', '', $item);
                    $data1['amount']            =  $this->input->post($item);
                    $data1['due'] = $this->input->post($item) - $this->input->post('paid_'.$item);
                    $this->db->insert('invoice_student_master' , $data1);
                }
                $data2['invoice_id']        =   $invoice_id;
                $data2['student_id']        =   $id;
                $data2['description']       =   $this->input->post('description');
                $data2['payment_type']      =  'income';
                $data2['method']            =   $this->input->post('method');
                $data2['amount']            =   $this->input->post('amount_paid');
                $datas['status']    =   2;
                $data2['timestamp']         =   strtotime($this->input->post('date'));
                $data2['year']               =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;

                $this->db->insert('payment' , $data2);
            }
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $this->input->post('class_id')))->row()->name;
                
                 $datas['description']    =   'Mass invoice has been created for class '.$class.'<br>Student : '.$student;
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   2;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/student_payment', 'refresh');
        }

        else if ($param1 == 'do_update') {
            $data['student_id']         = $this->input->post('student_id');
            $data['title']              = $this->input->post('title');
            $data['description']        = $this->input->post('description');
            $data['amount']             = $this->input->post('amount');
            $data['status']             = $this->input->post('status');
            $data['creation_timestamp'] = strtotime($this->input->post('date'));
            
            $this->db->where('invoice_id', $param2);
            $this->db->update('invoice', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/invoice', 'refresh');
        } 
        else if ($param1 == 'take_payment') {
            $invo = $this->db->get_where('invoice',['invoice_id' =>$param2])->row()->due;
            if($invo >= $this->input->post('amount')){
            $data['invoice_id']   =   $this->input->post('invoice_id');
            $data['student_id']   =   $this->input->post('student_id');
            $data['title']        =   $this->input->post('title');
            $data['description']  =   $this->input->post('description');
            $data['payment_type'] =   'income';
            $data['method']       =   $this->input->post('method');
            $data['bank']            =   $this->input->post('bank');
            $data['payment_ref']       =   $this->input->post('payment_ref');
            $data['payment_remarks']       =   $this->input->post('payment_remark');
            $data['cheque_dd']       =   $this->input->post('cheque');
            $data['payment_date']       =   $this->input->post('date_payment');
            $data['amount']       =   $this->input->post('amount');
            
            $data['timestamp']    =   strtotime($this->input->post('timestamp'));
            $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->insert('payment' , $data);

            $status['status']   =   $this->input->post('status');
            $this->db->where('invoice_id' , $param2);
            $this->db->update('invoice' , array('status' => $status['status']));
            //krish
            $class_id = $this->db->get_where('enroll' , array('student_id' => $this->input->post('student_id'),'year'=>$data['year']))->row()->class_id;
            $section_id = $this->db->get_where('enroll' , array('student_id' => $this->input->post('student_id'),'year'=>$data['year']))->row()->section_id;
            
            foreach($_POST['category'] as $key => $val){
        $amount = $this->db->get_where('invoice_student_master',['income_category_id'=> $key,'invoice_id'=>$param2])->result_array();
                if($amount[0]['amount'] > $val){
                    $pending = $amount[0]['amount']-$val;
                    $due = $amount[0]['due'] - $pending;
                    $this->db->where(['income_category_id'=> $key,'invoice_id'=>$param2]);
                    $this->db->set('due', $due, FALSE);
                    $this->db->update('invoice_student_master');
                    $this->db->where('invoice_id' , $param2);
               
                $this->db->set('amount', 'amount - ' . $pending, FALSE);
                $this->db->set('due', 'due - ' . $pending, FALSE);
                $this->db->update('invoice');

                }
                else{
                    $pending = $val - $amount[0]['amount'];
                    $due = $amount[0]['due'] + $pending;
                    $this->db->where(['income_category_id'=> $key,'invoice_id'=>$param2]);
                    $this->db->set('due', $due, FALSE);
                    $this->db->update('invoice_student_master');
                    $this->db->where('invoice_id' , $param2);
                    $this->db->set('amount', 'amount + ' . $pending, FALSE);
                    $this->db->set('due', 'due + ' . $pending, FALSE);
                    $this->db->update('invoice');
                }
                $this->db->where(['income_category_id'=> $key,'invoice_id'=>$param2]);
                $this->db->set('amount', $val, FALSE);
                $this->db->update('invoice_student_master');
                
            }
            if($this->input->post('amount') != 0){
            $invoicem = $this->db->get_where('invoice_student_master',['invoice_id' =>$param2])->result_array();
            foreach ($invoicem as $key => $value) {
                if($this->input->post('id_'.$value['income_category_id']) !=''){
                $this->db->where(['income_category_id'=> $value['income_category_id'],'invoice_id'=>$param2]);
                $this->db->set('due', 'due - ' . $this->input->post('id_'.$value['income_category_id']), FALSE);
                $this->db->update('invoice_student_master');
                }
            }
            if($this->input->post('discount') =='')
                $disc = 0;
            else
                $disc = $this->input->post('discount');
            $data2['amount_paid']   =   $this->input->post('amount');
            if($disc >0){
                $newdue = $data2['amount_paid'] + $disc;
            }
            else
                $newdue = $data2['amount_paid'];
            $data2['status']        =   $this->input->post('status');
            $this->db->where('invoice_id' , $param2);
            $this->db->set('amount_paid', 'amount_paid + ' . $data2['amount_paid'], FALSE);
            $this->db->set('due', 'due - ' . $newdue, FALSE);
            $this->db->set('discount', $disc, FALSE);
            $this->db->update('invoice');
            $data=$this->db->get_where('student',['student_id' =>$this->input->post('student_id')])->result();
            
            if(isset($data)){
                //sms
                $message = 'Thank you for your Payment. Your invoice has been updated. Paid amount is '.$this->input->post('amount').'. Date : '.date('d-m-Y',strtotime($this->input->post('timestamp')));

                $this->sms_model->send_sms($message , $data[0]->phone);
                $studentid = $this->db->get_where('invoice' , array('invoice_id' => $param2))->row()->student_id;
                 $student = $this->db->get_where('student' , array('student_id' => $studentid))->row()->name;
                //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'Payment from '.$student.' has been updated. Amount: '.$this->input->post('amount').'';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                  $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['status']    =   2;
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            }
            
            $this->session->set_flashdata('flash_message' , get_phrase('payment_successfull'));
            }
             redirect(base_url() . 'index.php?admin/student_payment_print/'.$param2.'/'.$class_id.'/'.$section_id, 'refresh');
            }
          else{
           $this->session->set_flashdata('flash_message' ,get_phrase('payment_failed'));
            redirect(base_url() . 'index.php?admin/income/'.$class_id.'/'.$section_id, 'refresh');
          }
         }
        else if ($param1 == 'delete') {
            $studentid = $this->db->get_where('invoice' , array('invoice_id' => $param2))->row()->student_id;
            $student = $this->db->get_where('student' , array('student_id' => $studentid))->row()->name;
            $this->db->where('invoice_id', $param2);
            $this->db->delete('payment');
            $this->db->where('invoice_id', $param2);
            $this->db->delete('invoice_student_master');
            $this->db->where('invoice_id', $param2);
            $this->db->delete('invoice');
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   '<font color="red">Invoice of <b> '.$student.'</b> has been deleted.</font>';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   2;
                  $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/income', 'refresh');
        }
        else{
            $page_data['page_name']  = 'income';
             $page_data['page_title'] = get_phrase('student_payments');
             $this->db->order_by('creation_timestamp', 'desc');
            $page_data['invoices'] = $this->db->get('invoice')->result_array();
            $this->load->view('backend/index', $page_data); 
        }
       }

    /**********ACCOUNTING********************/
    function income($class_id = '' ,$section_id = '')
    {
       if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
if ($this->input->post('class_id')>0) {
            $page_data['class_id']   = $this->input->post('class_id');
            $page_data['section_id']   = $this->input->post('section_id');
            if ($page_data['section_id'] > 0 && $page_data['class_id'] > 0) {
                redirect(base_url() . 'index.php?admin/income/' . $page_data['class_id'] . '/' .$page_data['section_id'] , 'refresh');
            } else {
                $this->session->set_flashdata('income', 'Choose class and exam');
                redirect(base_url() . 'index.php?admin/invoice/', 'refresh');
            }
        }
     else{
        $page_data['class_id']   = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['page_name']  = 'income';
        $page_data['page_title'] = get_phrase('student_payments');
        $this->load->view('backend/index', $page_data); 
      }
    }
function invoice_report($class_id = '' ,$section_id = '')
    {
       if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
         $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
         
         if ($this->input->post('start_timestamp') !='') {
           $this->db->where('timestamp <=',strtotime($this->input->post('end_timestamp')) );
           $this->db->where('timestamp >=', strtotime($this->input->post('start_timestamp')));         
         }
         $this->db->where('year' , $running_year);
         
         $this->db->order_by('timestamp' , 'DESC');
         $this->db->order_by('payment.payment_id' , 'DESC');
        $this->db->where('payment_type','income');
        $payments = $this->db->get('payment')->result_array();
        $page_data['invoices'] = $payments;
        $page_data['start_date'] = $this->input->post('start_timestamp');
        $page_data['end_date'] = $this->input->post('end_timestamp');
        $page_data['page_name']  = 'invoice_report';
        $page_data['page_title'] = get_phrase('report');
        $this->load->view('backend/index', $page_data); 
    }
    function income_search($class_id = '' ,$section_id = ''){
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $running_year = $this->db->get_where('settings' , array(
            'type' => 'running_year'
        ))->row()->description;
        $this->db->where('invoice.year' , $running_year);
        $this->db->join('enroll', 'invoice.student_id = enroll.student_id'); 
        $this->db->join('student', 'invoice.student_id = student.student_id'); 
        $this->db->like('student.name', $this->input->post('srch-term'));
    $this->db->order_by('invoice.creation_timestamp', 'desc');
        $page_data['invoices'] = $this->db->get('invoice')->result_array();

        $this->db->join('enroll', 'payment.student_id = enroll.student_id'); 
        $this->db->join('student', 'payment.student_id = student.student_id');
        $this->db->like('student.name', $this->input->post('srch-term')); 
    $this->db->where('payment_type' , 'income');
    $this->db->order_by('timestamp' , 'desc');
    $page_data['payments'] = $this->db->get('payment')->result_array();
        $page_data['page_name']  = 'income_search';
        $page_data['page_title'] = get_phrase('student_payments');
        $this->load->view('backend/index', $page_data); 
     }
    function incomesms($param = ''){
        if ($this->session->userdata('admin_login') != 1)
             redirect('login', 'refresh');
        $message = 'Hi, This is from ';
        $edit_data = $this->db->get_where('invoice', array('invoice_id' => $param))->result_array();
        foreach ($edit_data as $row){
            $message .=  $this->db->get_where('settings', array('type' => 'system_name'))->row()->description.'...';
             $message .=$this->db->get_where('student', array('student_id' => $row['student_id']))->row()->name.' payment status on '.$row['title'].' is as follows...';
              $message .= 'Total Amount to pay : INR.'.$row['amount'];
              $message .= '....Amount to paid : INR.'.$row['amount_paid'];
              $message .= '....Amount Due : INR.'.$row['due'];
              $phoneno = $this->db->get_where('student', array('student_id' => $row['student_id']))->row()->phone; 
              $this->sms_model->send_sms($message,$phoneno);
        }
        

    }
    function feedefault($param = ''){
        $count = 1;
        $running_year = $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
         
        $this->db->where('due >' , '0');
        $this->db->order_by('creation_timestamp' , 'desc');
        $invoices = $this->db->get_where('invoice',array('year' => $running_year))->result_array();
        foreach($invoices as $row){
          $stud_details = $this->crud_model->get_student_info($row['student_id']);
          $message = '';
          $message .="Hi ".$stud_details[0]['name'].",... You need to pay Rs. ".$row['due']." for ".$row['title'].". Please make the payment as soon as possible. Thanks";
           $this->sms_model->send_sms($message,$stud_details[0]['phone']);
        }

        $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
        redirect(base_url() . 'index.php?admin/income' , 'refresh');

    }

    function student_payment($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'student_payment';
        $page_data['page_title'] = get_phrase('create_student_payment');
        $this->load->view('backend/index', $page_data); 
    }

    //1632-1704 (student_sms to mass_sms) -->krish
    function student_sms($param1 = '' , $param2 = '' , $param3 = '') {
      
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'student_sms';
        $page_data['page_title'] = 'SEND SMS TO STUDENTS';
        $this->load->view('backend/index', $page_data); 
    }
    //krish
    function student_voice_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'student_voice_sms';
        $page_data['page_title'] = 'SEND VOICE SMS TO STUDENTS';
        $this->load->view('backend/index', $page_data); 
    }
    function all_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'all_sms';
        $page_data['page_title'] = 'SEND SMS TO ALL';
        $this->load->view('backend/index', $page_data); 
    }
    //krish
    function all_voice_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'all_voice_sms';
        $page_data['page_title'] = 'SEND VOICE SMS TO ALL';
        $this->load->view('backend/index', $page_data); 
    }

    function class_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'class_sms';
        $page_data['page_title'] = 'SEND SMS TO CLASS';
        $page_data['class']= $this->db->get('class')->result_array();
        $this->load->view('backend/index', $page_data); 
    }
    //krish
    function class_voice_sms($param1 = '' , $param2 = '' , $param3 = '') {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'class_voice_sms';
        $page_data['page_title'] = 'SEND VOICE SMS TO CLASS';
        $page_data['class']= $this->db->get('class')->result_array();
        $this->load->view('backend/index', $page_data); 
    }
    function teachers_sms() {

        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        $page_data['page_name']  = 'teachers_sms';
        $page_data['page_title'] = 'SEND SMS TO TEACHERS';
        $page_data['teachers']= $this->db->get('teacher')->result_array();
        $this->load->view('backend/index', $page_data); 
    }
    //krish
     function teachers_voice_sms() {

            if ($this->session->userdata('admin_login') != 1)
                redirect('login', 'refresh');
            $page_data['page_name']  = 'teachers_voice_sms';
            $page_data['page_title'] = 'SEND VOICE SMS TO TEACHERS';
            $page_data['teachers']= $this->db->get('teacher')->result_array();
            $this->load->view('backend/index', $page_data); 
        }
    function mass_sms($param1 = '' , $param2 = '' , $param3 = ''){
        $message = '';
        $message .= $this->input->post('description');
        $default = $this->db->get('default_sms')->result_array();
        if ($param1 == 'create_mass_sms') {
            if($this->input->post('class_id') == 0){
                $parents  = $this->db->get('parent')->result_array();
                $students = $this->db->get('student')->result_array();
                $teachers = $this->db->get('teacher')->result_array();
                 foreach($default as $row) {
                    $reciever_phone = $row['number'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
                foreach($parents as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
                foreach($students as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
                foreach($teachers as $row) {
                   $reciever_phone = $row['phone'];
                    $results = $this->sms_model->send_sms($message , $reciever_phone);
                }
               $data=explode(',',$results);
               if($data[1] == 'success'){
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $data['description']    =   'Mass SMS  <br>'.$this->input->post('description');
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['status']    =   5;
                 $data['date'] =  date("Y-m-d",$timestamp);
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $data);
                 $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
               }
            }
            else{
                foreach($default as $row) {
                    $reciever_phone = $row['number'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
                foreach ($this->input->post('student_id') as $id) {
                    $stud_details = $this->crud_model->get_student_info($id);             
                    $results = $this->sms_model->send_sms( $message , $stud_details[0]['phone']);  
                }
               $data=explode(',',$results);
               if($data[1] == 'success'){
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $class = $this->db->get_where('class' , array('class_id' => $this->input->post('class_id')))->row()->name;
                 $section = $this->db->get_where('section' , array('section_id' => $this->input->post('section_id')))->row()->name;
                 $data['description']    =   'Section SMS <br>'.$class.' '.$section.'<br>'.$this->input->post('description');
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['status']    =   5;
                 $data['date'] =  date("Y-m-d",$timestamp);
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $data);
                 $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
               }
            }
            redirect(base_url() . 'index.php?admin/student_sms' , 'refresh');
        }
//krish
        else if ($param1 == 'create_mass_voice_sms') {
            if($this->input->post('class_id') == 0){
               
                $parents  = $this->db->get('parent')->result_array();
                $students = $this->db->get('student')->result_array();
                $teachers = $this->db->get('teacher')->result_array();

                foreach($parents as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_voice_sms($reciever_phone);
                }
                foreach($students as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_voice_sms($reciever_phone);
                }
                foreach($teachers as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_voice_sms($reciever_phone);
                }
                
            }

            else{
                $voice = $this->input->post('voice_id');
                foreach ($this->input->post('student_id') as $id) {
                    $stud_details = $this->crud_model->get_student_info($id);
                    
                    $this->sms_model->send_voice_sms( $stud_details[0]['phone'],$voice);  

                }
               }
            $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
            redirect(base_url() . 'index.php?admin/student_voice_sms' , 'refresh');
        }
        else if ($param1 == 'create_teach_sms') {
            $message = '';
            $message .= $this->input->post('description');
            $this->db->where_in('teacher_id', $this->input->post('teacher_id'));
            $teachers = $this->db->get('teacher')->result_array();
            foreach($teachers as $row) {
                    $reciever_phone = $row['phone'];
                   $results = $this->sms_model->send_sms($message , $reciever_phone);
                }
            $data=explode(',',$results);
               if($data[1] == 'success'){
                 $data=array();
                 $data['user_id']       =   $this->session->userdata('login_user_id');
                 $data['name']       =   $this->session->userdata('name');
                 $data['device']       =   'web';
                 $data['description']    =   'Teacher SMS<br>'.$this->input->post('description');
                 $data['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $data['status']    =   5;
                 $data['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $data);
                 $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
               }
            redirect(base_url() . 'index.php?admin/teachers_sms' , 'refresh');
        }
//krish
        else if ($param1 == 'create_teach_voice_sms') {
            $this->db->where_in('teacher_id', $this->input->post('teacher_id'));
            $teachers = $this->db->get('teacher')->result_array();
            $voice =  $this->input->post('voice_id');
            foreach($teachers as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_voice_sms($reciever_phone,$voice);
                }
            
            $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
            redirect(base_url() . 'index.php?admin/teachers_voice_sms' , 'refresh');
        }
        //krish
        else if ($param1 == 'create_class_sms') {
            $this->db->where_in('class_id', $this->input->post('class_id'));
            $this->db->join('student', 'student.student_id = enroll.student_id'); 
            $query = $this->db->get('enroll')->result_array();
            foreach($query as $row) {
                    $reciever_phone = $row['phone'];
                    $results = $this->sms_model->send_sms($message , $reciever_phone);
                }
            $data=explode(',',$results);
               if($data[1] == 'success'){
                 $this->db->where_in('class_id', $this->input->post('class_id'));
                 $classes = $this->db->get('class')->result_array();
                 $class='';
                 foreach($classes as $key=>$row){
                     if($key !=0){
                        $class=', ';
                     }
                    $class .= $row->name;
                 }
                 $datas=array();
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'Class SMS<br>'.$class.'<br>'.$this->input->post('description');
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   5;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
                 $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
               }
            redirect(base_url() . 'index.php?admin/class_sms' , 'refresh');
        }
//krish
        else if ($param1 == 'create_class_voice_sms') {
            $this->db->where_in('class_id', $this->input->post('class_id'));
            $this->db->join('student', 'student.student_id = enroll.student_id'); 
            $query = $this->db->get('enroll')->result_array();
            $voice=$this->input->post('voice_id');
            foreach($query as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_voice_sms($reciever_phone,$voice);
                }
            
            $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
            redirect(base_url() . 'index.php?admin/class_voice_sms' , 'refresh');
        }
    }
    //Krish
    function other_income($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['title']               =   $this->input->post('title');
            $data['other_income_category_id'] =   $this->input->post('other_income_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'income';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $data['bank']            =   $this->input->post('bank');
            $data['payment_ref']       =   $this->input->post('payment_ref');
            $data['payment_remarks']       =   $this->input->post('payment_remark');
            $data['cheque_dd']       =   $this->input->post('cheque');
            $data['payment_date']       =   $this->input->post('date_payment');
            $this->db->insert('other_income' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/other_income', 'refresh');
        }

        if ($param1 == 'edit') {
            $data['title']               =   $this->input->post('title');
            $data['other_income_category_id'] =   $this->input->post('other_income_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'income';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->where('other_income_id' , $param2);
            $this->db->update('other_income' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/other_income', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('other_income_id' , $param2);
            $this->db->delete('other_income');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/other_income', 'refresh');
        }

        $page_data['page_name']  = 'other_income';
        $page_data['page_title'] = get_phrase('other_income');
        $this->load->view('backend/index', $page_data); 
    }
    //Krish
    function other_income_category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']   =   $this->input->post('name');
            $this->db->insert('other_income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/other_income_category');
        }
        if ($param1 == 'edit') {
            $data['name']   =   $this->input->post('name');
            $this->db->where('other_income_category_id' , $param2);
            $this->db->update('other_income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/other_income_category');
        }
        if ($param1 == 'delete') {
            $this->db->where('other_income_category_id' , $param2);
            $this->db->delete('other_income_category');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/other_income_category');
        }

        $page_data['page_name']  = 'other_income_category';
        $page_data['page_title'] = get_phrase('other_income_category');
        $this->load->view('backend/index', $page_data);
    }
    function expense($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['title']               =   $this->input->post('title');
            $data['expense_category_id'] =   $this->input->post('expense_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'expense';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $data['bank']            =   $this->input->post('bank');
            $data['payment_ref']       =   $this->input->post('payment_ref');
            $data['payment_remarks']       =   $this->input->post('payment_remark');
            $data['cheque_dd']       =   $this->input->post('cheque');
            $data['payment_date']       =   $this->input->post('date_payment');
            $this->db->insert('payment' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/expense', 'refresh');
        }

        if ($param1 == 'edit') {
            $data['title']               =   $this->input->post('title');
            $data['expense_category_id'] =   $this->input->post('expense_category_id');
            $data['description']         =   $this->input->post('description');
            $data['payment_type']        =   'expense';
            $data['method']              =   $this->input->post('method');
            $data['amount']              =   $this->input->post('amount');
            $data['timestamp']           =   strtotime($this->input->post('timestamp'));
            $data['year']                =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
            $this->db->where('payment_id' , $param2);
            $this->db->update('payment' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/expense', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('payment_id' , $param2);
            $this->db->delete('payment');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/expense', 'refresh');
        }

        $page_data['page_name']  = 'expense';
        $page_data['page_title'] = get_phrase('expenses');
        $this->load->view('backend/index', $page_data); 
    }


    function income_category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']   =   $this->input->post('name');
            $this->db->insert('income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/income_category');
        }
        if ($param1 == 'edit') {
            $data['name']   =   $this->input->post('name');
            $this->db->where('income_category_id' , $param2);
            $this->db->update('income_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/income_category');
        }
        if ($param1 == 'delete') {
            $this->db->where('income_category_id' , $param2);
            $this->db->delete('income_category');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/income_category');
        }

        $page_data['page_name']  = 'income_category';
        $page_data['page_title'] = get_phrase('income_category');
        $this->load->view('backend/index', $page_data);
    }


    function expense_category($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']   =   $this->input->post('name');
            $this->db->insert('expense_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/expense_category');
        }
        if ($param1 == 'edit') {
            $data['name']   =   $this->input->post('name');
            $this->db->where('expense_category_id' , $param2);
            $this->db->update('expense_category' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/expense_category');
        }
        if ($param1 == 'delete') {
            $this->db->where('expense_category_id' , $param2);
            $this->db->delete('expense_category');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/expense_category');
        }

        $page_data['page_name']  = 'expense_category';
        $page_data['page_title'] = get_phrase('expense_category');
        $this->load->view('backend/index', $page_data);
    }

    /**********MANAGE LIBRARY / BOOKS********************/
    function book($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']        = $this->input->post('name');
            $data['description'] = $this->input->post('description');
            $data['price']       = $this->input->post('price');
            $data['author']      = $this->input->post('author');
            $data['class_id']    = $this->input->post('class_id');
            $data['copy_number']    = $this->input->post('copy_number');
            $data['status']      = $this->input->post('status');
            $data['location']      = $this->input->post('location');
            $data['book_no']      = $this->input->post('book_no');
            $data['book_condition']      = $this->input->post('book_condition');
            $this->db->insert('book', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']        = $this->input->post('name');
            $data['description'] = $this->input->post('description');
            $data['price']       = $this->input->post('price');
            $data['author']      = $this->input->post('author');
            $data['class_id']    = $this->input->post('class_id');
            $data['copy_number']    = $this->input->post('copy_number');
            $data['status']      = $this->input->post('status');
            $data['location']      = $this->input->post('location');
            $data['book_no']      = $this->input->post('book_no');
            $data['book_condition']      = $this->input->post('book_condition');
            
            $this->db->where('book_id', $param2);
            $this->db->update('book', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('book', array(
                'book_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('book_id', $param2);
            $this->db->delete('book');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        }
        if ($param1 == 'issue') {
            $data['class_id']        = $this->input->post('class_id');
            $data['student_id'] = $this->input->post('student_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['book_id']       = $this->input->post('book_id');
            $data['takingDate']      = $this->input->post('takingDate');
            $data['dueDate']    = $this->input->post('dueDate');
            $this->db->insert('book_issue', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        }
        if ($param1 == 'issue_update') {
            $data['class_id']        = $this->input->post('class_id');
            $data['student_id'] = $this->input->post('student_id');
            $data['teacher_id'] = $this->input->post('teacher_id');
            $data['returnDate']    = $this->input->post('returnDate');
            $data['status']    = $this->input->post('status');
            $this->db->where('issue_id', $param2);
            $this->db->update('book_issue', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        }
        if ($param1 == 'return_update') {
            $data['returnDate']    = $this->input->post('returnDate');
            $data['status']    = $this->input->post('status');
            $data['fine']    = $this->input->post('fine');
            $data['remarks']    = $this->input->post('remarks');
            $this->db->where('issue_id', $param2);
            $this->db->update('book_issue', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        }
        if ($param1 == 'deleteissue') {
            $this->db->where('issue_id', $param2);
            $this->db->delete('book_issue');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/book', 'refresh');
        }
        $page_data['books']      = $this->db->get('book')->result_array();
                                         $this->db->join('book','book.book_id=book_issue.book_id')
                                         ->join('student','student.student_id =book_issue.student_id ','left')
                                         ->join('teacher','teacher.teacher_id =book_issue.teacher_id ','left');
        $page_data['issue_books']      = $this->db->select('student.name as studentname,book.name as bookname,takingDate,dueDate,teacher.name as teachername,issue_id,book_issue.status as issuestatus')
                                        ->from('book_issue')->get()->result_array();
        $page_data['page_name']  = 'book';
        $page_data['page_title'] = get_phrase('manage_library_books');
        $this->load->view('backend/index', $page_data);
        
    }
    function check_book_availablity($book_id)
    {
        $issued_books = $this->db->select()->from('book_issue')->where('status','2')->where('book_id',$book_id)->get()->num_rows();
        $no_of_copy = $this->db->select()->from('book')->where('book_id',$book_id)->get()->row()->copy_number;
        if($issued_books == $no_of_copy)
        {
            echo "1";
        }
        else
        {
            echo "2";
        }
    }
    /**********MANAGE TRANSPORT / VEHICLES / ROUTES********************/
    function transport($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['vehicle_id']        = $this->input->post('vehicle_id');
            $data['route_number'] = $this->input->post('route_number');
            $data['description']       = $this->input->post('description');
            $data['route_fare']        = $this->input->post('route_fare');
            $data['driver_name']        = $this->input->post('driver_name');
            $data['driver_mobile']        = $this->input->post('driver_mobile');
            $this->db->insert('transport', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/transport', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['vehicle_id']        = $this->input->post('vehicle_id');
            $data['route_number'] = $this->input->post('route_number');
            $data['description']       = $this->input->post('description');
            $data['route_fare']        = $this->input->post('route_fare');
            $data['driver_name']        = $this->input->post('driver_name');
            $data['driver_mobile']        = $this->input->post('driver_mobile');
            $this->db->where('transport_id', $param2);
            $this->db->update('transport', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/transport', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('transport', array(
                'transport_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('transport_id', $param2);
            $this->db->delete('transport');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/transport', 'refresh');
        }
        $page_data['transports'] = $this->db->get('transport')->result_array();
        $page_data['page_name']  = 'transport';
        $page_data['page_title'] = get_phrase('manage_transport');
        $this->load->view('backend/index', $page_data);
        
    }
    /**********MANAGE DORMITORY / HOSTELS / ROOMS ********************/
    function dormitory($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']           = $this->input->post('name');
            $data['number_of_room'] = $this->input->post('number_of_room');
            $data['description']    = $this->input->post('description');
            $this->db->insert('dormitory', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/dormitory', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']           = $this->input->post('name');
            $data['number_of_room'] = $this->input->post('number_of_room');
            $data['description']    = $this->input->post('description');
            
            $this->db->where('dormitory_id', $param2);
            $this->db->update('dormitory', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/dormitory', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('dormitory', array(
                'dormitory_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('dormitory_id', $param2);
            $this->db->delete('dormitory');
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/dormitory', 'refresh');
        }
        $page_data['dormitories'] = $this->db->get('dormitory')->result_array();
        $page_data['page_name']   = 'dormitory';
        $page_data['page_title']  = get_phrase('manage_dormitory');
        $this->load->view('backend/index', $page_data);
        
    }

    /****Groups**************************************************************/
    function group($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect('login', 'refresh');
        if ($param1 == 'create') {
            $data['name']           = $this->input->post('name');
            $this->db->insert('group', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/group', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['name']           = $this->input->post('name');
           
            
            $this->db->where('group_id', $param2);
            $this->db->update('group', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/group', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('group', array(
                'group_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('group_id', $param2);
            $this->db->delete('group');

            $this->db->where('groupid', $param2);
            $this->db->delete('students_in_group');
            
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/group', 'refresh');
        }
        $page_data['groups'] = $this->db->get('group')->result_array();
        $page_data['page_name']   = 'group';
        $page_data['page_title']  = get_phrase('manage_group');
        $this->load->view('backend/index', $page_data);
        
    }
    function print_group_student($param2)
    {
        $page_data['param2'] = $param2;
        $page_data['page_name']   = 'print_group_student';
        $page_data['page_title']  = get_phrase('print_group_student');
        $this->load->view('backend/index', $page_data);
    }
    
    /***MANAGE EVENT / NOTICEBOARD, WILL BE SEEN BY ALL ACCOUNTS DASHBOARD**/
    function noticeboard($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($param1 == 'create') {
            $data['notice_title']     = $this->input->post('notice_title');
            $data['notice']           = $this->input->post('notice');
            $data['create_timestamp'] = strtotime($this->input->post('create_timestamp'));
            $this->db->insert('noticeboard', $data);

            $check_sms_send = $this->input->post('check_sms');

            if ($check_sms_send == 1) {
                // sms sending configurations

                $parents  = $this->db->get('parent')->result_array();
                $students = $this->db->get('student')->result_array();
                $teachers = $this->db->get('teacher')->result_array();
                $date     = $this->input->post('create_timestamp');
                $message  = $data['notice_title'] . ' ';
                $message .= get_phrase('on') . ' ' . $date;
                foreach($parents as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
                foreach($students as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
                foreach($teachers as $row) {
                    $reciever_phone = $row['phone'];
                    $this->sms_model->send_sms($message , $reciever_phone);
                }
            }
//Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'New Noticeboard with Title '.$this->input->post('notice_title').' has been added.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_added_successfully'));
            redirect(base_url() . 'index.php?admin/noticeboard/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['notice_title']     = $this->input->post('notice_title');
            $data['notice']           = $this->input->post('notice');
            $data['create_timestamp'] = strtotime($this->input->post('create_timestamp'));
            $this->db->where('notice_id', $param2);
            $this->db->update('noticeboard', $data);

            $check_sms_send = $this->input->post('check_sms');

           
//Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'Noticeboard with title '.$this->input->post('notice_title').' has been updated.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/noticeboard/', 'refresh');
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('noticeboard', array(
                'notice_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $notice = $this->db->get_where('noticeboard' , array('notice_id' => $param2 ))->row()->notice_title;
            $this->db->where('notice_id', $param2);
            $this->db->delete('noticeboard');
            //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'Noticeboard with title '.$notice.'  deleted.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
            $this->session->set_flashdata('flash_message' , get_phrase('data_deleted'));
            redirect(base_url() . 'index.php?admin/noticeboard/', 'refresh');
        }
        $page_data['page_name']  = 'noticeboard';
        $page_data['page_title'] = get_phrase('manage_noticeboard');
        $page_data['notices']    = $this->db->get('noticeboard')->result_array();
        $this->load->view('backend/index', $page_data);
    }
    
    /* private messaging */

    function message($param1 = 'message_home', $param2 = '', $param3 = '') {
        
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'send_new') {
            $message_thread_code = $this->crud_model->send_new_private_message();
            $this->session->set_flashdata('flash_message', get_phrase('message_sent!'));
            redirect(base_url() . 'index.php?admin/message/message_read/' . $message_thread_code, 'refresh');
        }

        if ($param1 == 'send_reply') {
            $this->crud_model->send_reply_message($param2);  //$param2 = message_thread_code
            $this->session->set_flashdata('flash_message', get_phrase('message_sent!'));
            redirect(base_url() . 'index.php?admin/message/message_read/' . $param2, 'refresh');
        }

        if ($param1 == 'message_read') {
            $page_data['current_message_thread_code'] = $param2;  // $param2 = message_thread_code
            $this->crud_model->mark_thread_messages_read($param2);
        }

        $page_data['message_inner_page_name']   = $param1;
        $page_data['page_name']                 = 'message';
        $page_data['page_title']                = get_phrase('private_messaging');
        $this->load->view('backend/index', $page_data);
    }
    
    /*****SITE/SYSTEM SETTINGS*********/
    function system_settings($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        
        if ($param1 == 'do_update') {
             
            $data['description'] = $this->input->post('system_name');
            $this->db->where('type' , 'system_name');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('system_title');
            $this->db->where('type' , 'system_title');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('address');
            $this->db->where('type' , 'address');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('phone');
            $this->db->where('type' , 'phone');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('paypal_email');
            $this->db->where('type' , 'paypal_email');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('currency');
            $this->db->where('type' , 'currency');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('system_email');
            $this->db->where('type' , 'system_email');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('system_name');
            $this->db->where('type' , 'system_name');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('aff_number');
            $this->db->where('type' , 'affiliation');
            $this->db->update('settings' , $data);
        
            $data['description'] = $this->input->post('system_code');
            $this->db->where('type' , 'system_code');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('language');
            $this->db->where('type' , 'language');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('text_align');
            $this->db->where('type' , 'text_align');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('running_year');
            $this->db->where('type' , 'running_year');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('login');
            $this->db->where('type' , 'allow_login');
            $this->db->update('settings' , $data);
            
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated')); 
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh');
        }
        if ($param1 == 'upload_logo') {
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/logo.png');
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh');
        }
        if ($param1 == 'change_skin') {
            $data['description'] = $param2;
            $this->db->where('type' , 'skin_colour');
            $this->db->update('settings' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('theme_selected')); 
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh'); 
        }
        if ($param1 == 'do_attendance'){
            $data['description'] = $this->input->post('attendace');
            $this->db->where('type' , 'attendance');
            $this->db->update('settings' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated')); 
            redirect(base_url() . 'index.php?admin/attendance_settings/', 'refresh'); 
        }
        if ($param1 == 'do_birthday'){
            $data['description'] = $this->input->post('birth');
            $this->db->where('type' , 'birthday');
            $this->db->update('settings' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('settings_updated')); 
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh'); 
        }
        if ($param1 == 'session_add'){
            $data['name'] = $this->input->post('name');
            $this->db->insert('sessions', $data);
            $this->session->set_flashdata('flash_message' , get_phrase('session_added')); 
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh'); 
        }
       if($param1 == 'session_delete'){
            $this->db->where('session_id', $param2);
            $this->db->delete('sessions');
            $this->session->set_flashdata('flash_message' , get_phrase('session_deleted')); 
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh'); 
        }
        $page_data['page_name']  = 'system_settings';
        $page_data['page_title'] = get_phrase('system_settings');
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('backend/index', $page_data);
    }

    function get_session_changer()
    {
        $this->load->view('backend/admin/change_session');
    }

    function change_session()
    {
        $data['description'] = $this->input->post('running_year');
        $this->db->where('type' , 'running_year');
        $this->db->update('settings' , $data);
        $this->session->set_flashdata('flash_message' , get_phrase('session_changed')); 
        redirect(base_url() . 'index.php?admin/dashboard/', 'refresh'); 
    }
    
    /***** UPDATE PRODUCT *****/
    
    function update( $task = '', $purchase_code = '' ) {
        
        
            
        // Create update directory.
        $dir    = 'update';
        if ( !is_dir($dir) )
            mkdir($dir, 0777, true);
        
        $zipped_file_name   = $_FILES["file_name"]["name"];
        $path               = 'update/' . $zipped_file_name;
        
        move_uploaded_file($_FILES["file_name"]["tmp_name"], $path);
        
        // Unzip uploaded update file and remove zip file.
        $zip = new ZipArchive;
        $res = $zip->open($path);
        if ($res === TRUE) {
            $zip->extractTo('update');
            $zip->close();
            unlink($path);
        }
        
        $unzipped_file_name = substr($zipped_file_name, 0, -4);
        $str                = file_get_contents('./update/' . $unzipped_file_name . '/update_config.json');
        $json               = json_decode($str, true);
        

            
        // Run php modifications
        require './update/' . $unzipped_file_name . '/update_script.php';
        
        // Create new directories.
        if(!empty($json['directory'])) {
            foreach($json['directory'] as $directory) {
                if ( !is_dir( $directory['name']) )
                    mkdir( $directory['name'], 0777, true );
            }
        }
        
        // Create/Replace new files.
        if(!empty($json['files'])) {
            foreach($json['files'] as $file)
                copy($file['root_directory'], $file['update_directory']);
        }
        
        $this->session->set_flashdata('flash_message' , get_phrase('product_updated_successfully'));
        redirect(base_url() . 'index.php?admin/system_settings');
    }

    /*****SMS SETTINGS*********/
    function sms_settings($param1 = '' , $param2 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'skysms') {

            $data['description'] = $this->input->post('skysms_user');
            $this->db->where('type' , 'skysms_user');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('skysms_password');
            $this->db->where('type' , 'skysms_password');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('skysms_sender_id');
            $this->db->where('type' , 'skysms_sender_id');
            $this->db->update('settings' , $data);

  //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'SMS '.$data['description'].' has been updated.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['status']    =   0;
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);
                 
            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/sms_settings/', 'refresh');
        }

       if ($param1 == 'malayalam') {

            $data['description'] = $this->input->post('malayalam_user');
            $this->db->where('type' , 'malayalam_user');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('malayalam_sender_id');
            $this->db->where('type' , 'malayalam_sender_id');
            $this->db->update('settings' , $data);

            $data['description'] = $this->input->post('malayalam_api');
            $this->db->where('type' , 'malayalam_api');
            $this->db->update('settings' , $data);

            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/sms_settings/', 'refresh');
        }

        if ($param1 == 'active_service') {

            $data['description'] = $this->input->post('active_sms_service');
            $this->db->where('type' , 'active_sms_service');
            $this->db->update('settings' , $data);
             //Log
                 $datas['user_id']       =   $this->session->userdata('login_user_id');
                 $datas['name']       =   $this->session->userdata('name');
                 $datas['device']       =   'web';
                 $datas['description']    =   'Selected SMS Gateway '.$data['description'].' for sending sms.';
                 $datas['timestamp']    =   strtotime(date('d-m-Y H:i:s'));
                 $datas['status']    =   0;
                 $datas['date'] =  date("Y-m-d",$timestamp);
                 $datas['year']         =   $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description;
                 $this->db->insert('log' , $datas);

            $this->session->set_flashdata('flash_message' , get_phrase('data_updated'));
            redirect(base_url() . 'index.php?admin/sms_settings/', 'refresh');
        }

        $page_data['page_name']  = 'sms_settings';
        $page_data['page_title'] = get_phrase('sms_settings');
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('backend/index', $page_data);
    }
    /*****LANGUAGE SETTINGS*********/
    function manage_language($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        
        if ($param1 == 'edit_phrase') {
            $page_data['edit_profile']  = $param2;  
        }
        if ($param1 == 'update_phrase') {
            $language   =   $param2;
            $total_phrase   =   $this->input->post('total_phrase');
            for($i = 1 ; $i < $total_phrase ; $i++)
            {
                //$data[$language]  =   $this->input->post('phrase').$i;
                $this->db->where('phrase_id' , $i);
                $this->db->update('language' , array($language => $this->input->post('phrase'.$i)));
            }
            redirect(base_url() . 'index.php?admin/manage_language/edit_phrase/'.$language, 'refresh');
        }
        if ($param1 == 'do_update') {
            $language        = $this->input->post('language');
            $data[$language] = $this->input->post('phrase');
            $this->db->where('phrase_id', $param2);
            $this->db->update('language', $data);
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        if ($param1 == 'add_phrase') {
            $data['phrase'] = $this->input->post('phrase');
            $this->db->insert('language', $data);
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        if ($param1 == 'add_language') {
            $language = $this->input->post('language');
            $this->load->dbforge();
            $fields = array(
                $language => array(
                    'type' => 'LONGTEXT'
                )
            );
            $this->dbforge->add_column('language', $fields);
            
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        if ($param1 == 'delete_language') {
            $language = $param2;
            $this->load->dbforge();
            $this->dbforge->drop_column('language', $language);
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        $page_data['page_name']        = 'manage_language';
        $page_data['page_title']       = get_phrase('manage_language');
        //$page_data['language_phrases'] = $this->db->get('language')->result_array();
        $this->load->view('backend/index', $page_data); 
    }
    
    /*****BACKUP / RESTORE / DELETE DATA PAGE**********/
    function backup_restore($operation = '', $type = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($operation == 'create') {
            $this->crud_model->create_backup($type);
        }
        if ($operation == 'restore') {
            $this->crud_model->restore_backup();
            $this->session->set_flashdata('backup_message', 'Backup Restored');
            redirect(base_url() . 'index.php?admin/backup_restore/', 'refresh');
        }
        if ($operation == 'delete') {
            $this->crud_model->truncate($type);
            $this->session->set_flashdata('backup_message', 'Data removed');
            redirect(base_url() . 'index.php?admin/backup_restore/', 'refresh');
        }
        
        $page_data['page_info']  = 'Create backup / restore from backup';
        $page_data['page_name']  = 'backup_restore';
        $page_data['page_title'] = get_phrase('manage_backup_restore');
        $this->load->view('backend/index', $page_data);
    }
    
    /******MANAGE OWN PROFILE AND CHANGE PASSWORD***/
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'update_profile_info') {
            $data['name']  = $this->input->post('name');
            $data['email'] = $this->input->post('email');
            
            $this->db->where('admin_id', $this->session->userdata('admin_id'));
            $this->db->update('admin', $data);
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/admin_image/' . $this->session->userdata('admin_id') . '.jpg');
            $this->session->set_flashdata('flash_message', get_phrase('account_updated'));
            redirect(base_url() . 'index.php?admin/manage_profile/', 'refresh');
        }
        if ($param1 == 'change_password') {
            $data['password']             = sha1($this->input->post('password'));
            $data['new_password']         = sha1($this->input->post('new_password'));
            $data['confirm_new_password'] = sha1($this->input->post('confirm_new_password'));
            
            $current_password = $this->db->get_where('admin', array(
                'admin_id' => $this->session->userdata('admin_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('admin_id', $this->session->userdata('admin_id'));
                $this->db->update('admin', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', get_phrase('password_updated'));
            } else {
                $this->session->set_flashdata('flash_message', get_phrase('password_mismatch'));
            }
            redirect(base_url() . 'index.php?admin/manage_profile/', 'refresh');
        }
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_title'] = get_phrase('manage_profile');
        $page_data['edit_data']  = $this->db->get_where('admin', array(
            'admin_id' => $this->session->userdata('admin_id')
        ))->result_array();
        $this->load->view('backend/index', $page_data);
    }

    function get_class_sections($class_id)
    {
        $page_data['class_id'] = $class_id;
        $this->load->view('backend/admin/get_sections' , $page_data);
    }
     function get_class_section_students_mass($class_id,$section_id)
    {
        $students = $this->db->get_where('enroll' , array(
            'class_id' => $class_id ,'section_id' => $section_id, 'year' => $this->db->get_where('settings' , array('type' => 'running_year'))->row()->description
        ))->result_array();
        echo '<div class="form-group">
                <label class="col-sm-3 control-label">' . get_phrase('students') . '</label>
                <div class="col-sm-9">';
        foreach ($students as $row) {
             $name = $this->db->get_where('student' , array('student_id' => $row['student_id']))->row()->name;
            echo '<div class="checkbox">
                    <label><input type="checkbox" class="check" name="student_id[]" value="' . $row['student_id'] . '">' . $name .'</label>
                </div>';
        }
        echo '<br><button type="button" class="btn btn-default" onClick="select()">'.get_phrase('select_all').'</button>';
        echo '<button style="margin-left: 5px;" type="button" class="btn btn-default" onClick="unselect()"> '.get_phrase('select_none').' </button>';
        echo '</div></div>';
    }
    function send_sms_from_transport( $trans_id ){
         $message  = $this->input->post('smstext');
         $this->db->join('transport_student','transport_student.student_id = student.student_id');
        $transport_students = $this->db->get_where('student', array('transport_student.transport_id' => $trans_id))->result_array();
       $data='';
        foreach($transport_students as $row) {
            $this->sms_model->send_sms($message , $row['phone']);
        }
       
        $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
        redirect(base_url() . 'index.php?admin/transport' , 'refresh');
    }
    
     //new code - Id Card
    function print_id($id){
        if ($this->session->userdata('admin_login') != 1)
            redirect(site_url('login'), 'refresh');
        $data['id'] = $id;
        $this->load->view('backend/admin/print_id', $data);
    }

    function create_barcode($student_id)
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        return $this->Barcode_model->create_barcode($student_id);

    }

    // Details of searched student
    function student_details($param1 = ""){
      if ($this->session->userdata('admin_login') != 1)
          redirect(site_url('login'), 'refresh');

      $student_identifier = html_escape($this->input->post('student_identifier'));
      $query_by_code = $this->db->get_where('student', array('student_code' => $student_identifier));

      if ($query_by_code->num_rows() == 0) {
        $this->db->like('name', $student_identifier);
        $query_by_name = $this->db->get('student');
        if ($query_by_name->num_rows() == 0) {
          $this->session->set_flashdata('error_message' , get_phrase('no_student_found'));
          redirect(site_url('admin/dashboard'), 'refresh');
        }
        else{
          $page_data['student_information'] = $query_by_name->result_array();
        }
      }
      else{
        $page_data['student_information'] = $query_by_code->result_array();
      }
      $page_data['page_name']  	= 'search_result';
  		$page_data['page_title'] 	= get_phrase('search_result');
  		$this->load->view('backend/index', $page_data);
    }
 
 
  // Add Students to Clubs & Groups 
    function add_students_groups()
    {
        if ($this->session->userdata('admin_login') != 1)
        redirect(base_url(), 'refresh');
        $class_id = $this->input->post('class_id');
        $section_id = $this->input->post('section_id');
        $group_id = $this->input->post('group_id');
    
        $page_data['class_id'] = $class_id;
        $page_data['section_id'] = $section_id;
        $page_data['group_id'] = $group_id;
        $page_data['page_name'] = 'add_students_groups';
        $page_data['page_title'] = get_phrase('add_students_groups');
        $this->load->view('backend/index', $page_data);
    }
    function create_group_student()
    {
        if ($this->session->userdata('admin_login') != 1)
        redirect(base_url(), 'refresh');
        $data['student_id']=$this->input->post('student_id');
        $data['group_id']=$this->input->post('group_id');
        $query=$this->db->select()
                        ->from('students_in_group')
                        ->where('student_id',$data['student_id'])
                        ->where('group_id',$data['group_id'])
                        ->get()
                        ->row_array();

        if(!empty($query))
        {
            $this -> db -> where('id', $query['id']);
            $this -> db -> delete('students_in_group');
        }
        else
        {
          $this->db->insert('students_in_group',$data);  
        }
    }


    function send_sms_to_group( $group_id ){
         $message  = $this->input->post('smstext');
        $group_students = $this->db->query('select s.* from student s inner join students_in_group g on s.student_id = g.student_id where g.groupid ='.$group_id,false)->result_array();
       
        foreach($group_students as $row) {
           
            $this->sms_model->send_sms($message , $row['phone']);

        }
        $this->session->set_flashdata('flash_message' , get_phrase('message_sent'));
        redirect(base_url() . 'index.php?admin/group' , 'refresh');
    }
       /******MANAGE VISITOR RECORDS***/
    
  function visitor_book($param1="",$param2="")
    {
        if($param1 == "create")
        {
            $data['purpose']=$this->input->post('purpose');
            $data['name']=$this->input->post('name');
            $data['phone']=$this->input->post('phone');
            $data['id_card']=$this->input->post('id_card');
            $data['no_of_person']=$this->input->post('no_of_person');
            $data['Date']=$this->input->post('Date');
            $data['in_time']=$this->input->post('in_time');
            $data['out_time']=$this->input->post('out_time');
            $data['note']=$this->input->post('note');
            
            $this->db->insert('visitor_book' , $data);
             $this->session->set_flashdata('flash_message' , get_phrase('data added'));
            redirect(base_url() . 'index.php?admin/visitor_book', 'refresh');
           
        }
        if($param1 == "do_update")
        {
            $data['purpose']=$this->input->post('purpose');
            $data['name']=$this->input->post('name');
            $data['phone']=$this->input->post('phone');
            $data['id_card']=$this->input->post('id_card');
            $data['no_of_person']=$this->input->post('no_of_person');
            $data['Date']=$this->input->post('Date');
            $data['in_time']=$this->input->post('in_time');
            $data['out_time']=$this->input->post('out_time');
            $data['note']=$this->input->post('note');
            
            $this->db->where('visitor_id',$param2);
            $this->db->update('visitor_book' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data updated'));
            redirect(base_url() . 'index.php?admin/visitor_book', 'refresh');
            
        }
        if($param1 == "delete")
        {
            $this->db->where('visitor_id', $param2);
            $this->db->delete('visitor_book');
             $this->session->set_flashdata('flash_message' , get_phrase('data deleted'));
            redirect(base_url() . 'index.php?admin/visitor_book', 'refresh');
           
        }
        $filter_date = $this->input->post('filter_date');
        if(!empty($filter_date))
        {
            $this->db->where('Date',$filter_date);
        }
        $page_data['visitor_data'] = $this->db->get('visitor_book')->result_array();
        $page_data['filter_date'] = $filter_date;
        $page_data['page_name'] = 'visitor_book';
        $page_data['page_title'] = get_phrase('visitor_book');
        $this->load->view('backend/index', $page_data);
    }
       /******MANAGE PHONE CALL RECORDS***/
    
    function phone_call_log($param1="",$param2="")
    {
        if($param1 == "create")
        {
            $data['name']=$this->input->post('name');
            $data['phone']=$this->input->post('phone');
            $data['date']=$this->input->post('date');
            $data['description']=$this->input->post('description');
            $data['followUpDate']=$this->input->post('followUpDate');
            $data['duration']=$this->input->post('duration');
            $data['note']=$this->input->post('note');
            $data['callType']=$this->input->post('callType');
            
            $this->db->insert('phone_call_log' , $data);
             $this->session->set_flashdata('flash_message' , get_phrase('data added'));
            redirect(base_url() . 'index.php?admin/phone_call_log', 'refresh');
           
        }
        if($param1 == "do_update")
        {
            $data['name']=$this->input->post('name');
            $data['phone']=$this->input->post('phone');
            $data['date']=$this->input->post('date');
            $data['description']=$this->input->post('description');
            $data['followUpDate']=$this->input->post('followUpDate');
            $data['duration']=$this->input->post('duration');
            $data['note']=$this->input->post('note');
            $data['callType']=$this->input->post('callType');
            
            $this->db->where('phone_call_log_id',$param2);
            $this->db->update('phone_call_log' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data updated'));
            redirect(base_url() . 'index.php?admin/phone_call_log', 'refresh');
            
        }
        if($param1 == "delete")
        {
            $this->db->where('phone_call_log_id', $param2);
            $this->db->delete('phone_call_log');
             $this->session->set_flashdata('flash_message' , get_phrase('data deleted'));
            redirect(base_url() . 'index.php?admin/phone_call_log', 'refresh');
           
        }
        $filter_date = $this->input->post('filter_date');
        if(!empty($filter_date))
        {
            $this->db->where('date',$filter_date);
        }
        $page_data['call_data'] = $this->db->get('phone_call_log')->result_array();
        $page_data['filter_date'] = $filter_date;
        $page_data['page_name'] = 'phone_call_log';
        $page_data['page_title'] = get_phrase('phone_call_log');
        $this->load->view('backend/index', $page_data);
    }
   
       /******MANAGE POSTAL LOG***/
   
    function postal($param1="",$param2="")
    {
        if($param1 == "create")
        {
            $data['to_title']=$this->input->post('to_title');
            $data['reference_no']=$this->input->post('reference_no');
            $data['address']=$this->input->post('address');
            $data['note']=$this->input->post('note');
            $data['from_title']=$this->input->post('from_title');
            $data['date']=$this->input->post('date');
            $data['postal_type']=$this->input->post('postal_type');
            
            $this->db->insert('postal' , $data);
             $this->session->set_flashdata('flash_message' , get_phrase('data added'));
            redirect(base_url() . 'index.php?admin/postal', 'refresh');
           
        }
        if($param1 == "do_update")
        {
            $data['to_title']=$this->input->post('to_title');
            $data['reference_no']=$this->input->post('reference_no');
            $data['address']=$this->input->post('address');
            $data['note']=$this->input->post('note');
            $data['from_title']=$this->input->post('from_title');
            $data['date']=$this->input->post('date');
            
            $this->db->where('postal_id',$param2);
            $this->db->update('postal' , $data);
            $this->session->set_flashdata('flash_message' , get_phrase('data updated'));
            redirect(base_url() . 'index.php?admin/postal', 'refresh');
            
        }
        if($param1 == "delete")
        {
            $this->db->where('postal_id', $param2);
            $this->db->delete('postal');
             $this->session->set_flashdata('flash_message' , get_phrase('data deleted'));
            redirect(base_url() . 'index.php?admin/postal', 'refresh');
           
        }
        $filter_date = $this->input->post('filter_date');
        if(!empty($filter_date))
        {
            $this->db->where('date',$filter_date);
        }
        $page_data['postal_data'] = $this->db->get('postal')->result_array();
        $page_data['filter_date'] = $filter_date;
        $page_data['page_name'] = 'postal';
        $page_data['page_title'] = get_phrase('postal');
        $this->load->view('backend/index', $page_data);
    }   
}
